package ru.microem.reader.usb_bluetooth_test.ui.mifare_ultralight;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Spinner;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.reader.usb_bluetooth_test.ui.mifare_ultralight.MifareUltralightViewModel;
import ru.microem.readerlibrary.UemReader;

public class MifareUltralightFragment extends Fragment {

    private MifareUltralightViewModel mifareUltralightViewModel;

    private View mRoot = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        mifareUltralightViewModel =
                ViewModelProviders.of(this).get(MifareUltralightViewModel.class);
        View root = inflater.inflate(R.layout.fragment_mifare_ultralight, container, false);
        final TextView textView = root.findViewById(R.id.text_mifare_ultralight);
        mifareUltralightViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mMifareUltralightFragment = this;

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((EditText)root.findViewById(R.id.mful_edit_page)).setText(sharedPref.getString("mful_edit_page", "8"));
        ((EditText)root.findViewById(R.id.mful_edit_data)).setText(sharedPref.getString("mful_edit_data", "00000000"));
        ((TextView)root.findViewById(R.id.mful_log)).setText(sharedPref.getString("mful_log", ""));

        return root;
    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putString("mful_edit_page", ((EditText)mRoot.findViewById(R.id.mful_edit_page)).getText().toString()).apply();
        sharedPref.edit().putString("mful_edit_data", ((EditText)mRoot.findViewById(R.id.mful_edit_data)).getText().toString()).apply();
        sharedPref.edit().putString("mful_log", ((TextView)mRoot.findViewById(R.id.mful_log)).getText().toString()).apply();

        super.onPause();
    }

    public void onMfulCommand(View view) {
        EditText editPage = mRoot.findViewById(R.id.mful_edit_page);
        int page = Integer.parseInt(editPage.getText().toString());
        EditText editData = mRoot.findViewById(R.id.mful_edit_data);
        byte[] data = UemReader.Helper.hexStringToByteArray(editData.getText().toString());
        TextView log = mRoot.findViewById(R.id.mful_log);
        switch(view.getId()) {
            case R.id.mful_button_read:
                byte[] res = ((MainActivity) getActivity()).mUemR.Cards.MifareUltralight.readPages(page);
                ((MainActivity) getActivity()).appendLog(log, "Read 4 pages", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                        ), ((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)?String.format("Data: %s",
                        UemReader.Helper.byteArrayToHexString(res)
                        ):null
                );
                break;
            case R.id.mful_button_write:
                ((MainActivity) getActivity()).mUemR.Cards.MifareUltralight.writePage(page, data);
                ((MainActivity) getActivity()).appendLog(log, "Write page", String.format("%s, Status: 0x%02x",
                        ((MainActivity) getActivity()).mUemR.getLastError(),
                        ((MainActivity) getActivity()).mUemR.getLastErrorCode()
                ));
                break;
            default:
        }
    }
}