package ru.microem.reader.usb_bluetooth_test.ui.tags;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;

import androidx.annotation.Nullable;
import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProviders;
import ru.microem.reader.usb_bluetooth_test.MainActivity;
import ru.microem.reader.usb_bluetooth_test.R;
import ru.microem.readerlibrary.UemReader;

public class TagsFragment extends Fragment {

    private TagsViewModel tagsViewModel;

    private View mRoot = null;

    private ArrayList<String> mListTags = null;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        tagsViewModel =
                ViewModelProviders.of(this).get(TagsViewModel.class);
        View root = inflater.inflate(R.layout.fragment_tags, container, false);
        final TextView textView = root.findViewById(R.id.text_tags);
        tagsViewModel.getText().observe(this, new Observer<String>() {
            @Override
            public void onChanged(@Nullable String s) {
                textView.setText(s);
            }
        });

        mRoot = root;

        ((MainActivity)getActivity()).mTagsFragment = this;

        final ListView listTags = root.findViewById(R.id.tags);

        mListTags = new ArrayList<String>();

        ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity().getApplicationContext(),
                android.R.layout.simple_list_item_1, android.R.id.text1, mListTags){

            @Override
            public View getView(int position, View convertView, ViewGroup parent) {
                View view =super.getView(position, convertView, parent);

                TextView textView=(TextView) view.findViewById(android.R.id.text1);

                /*YOUR CHOICE OF COLOR*/
                textView.setTextColor(Color.BLUE);

                return view;
            }
        };

        listTags.setAdapter(adapter);
        listTags.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {

                // ListView Clicked item index
                int itemPosition     = position;

                // ListView Clicked item value
                String  itemValue    = (String) listTags.getItemAtPosition(position);

                // Show Alert
                /*Toast.makeText(getActivity().getApplicationContext(),
                        "Connecting " +itemValue+ " ..." , Toast.LENGTH_LONG)
                        .show();*/

                /*((MainActivity)getActivity()).mUemR.disconnect();
                ((MainActivity)getActivity()).mUemR.connect(itemValue);

                if (((MainActivity)getActivity()).mUemR.getInterfaceType().equals(UemReader.UEM_INTERFACE_USB)) {
                    ((MainActivity)getActivity()).mUemR.Reader.beep(3);
                    //mUemR.disconnect();
                }*/
            }

        });

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        ((RadioButton)root.findViewById(R.id.discover_ISO14443A)).setChecked(sharedPref.getBoolean("discover_ISO14443A", true));
        ((RadioButton)root.findViewById(R.id.discover_ISO14443B)).setChecked(sharedPref.getBoolean("discover_ISO14443B", false));
        ((RadioButton)root.findViewById(R.id.discover_ISO15693)).setChecked(sharedPref.getBoolean("discover_ISO15693", false));

        return root;
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        //super.onViewCreated(view, savedInstanceState);
        /*Toast.makeText(getActivity().getApplicationContext(),
                "TagsFragment onViewCreated", Toast.LENGTH_LONG)
                .show();*/


    }

    public void onPause() {
        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        sharedPref.edit().putBoolean("discover_ISO14443A", ((RadioButton)mRoot.findViewById(R.id.discover_ISO14443A)).isChecked()).apply();
        sharedPref.edit().putBoolean("discover_ISO14443B", ((RadioButton)mRoot.findViewById(R.id.discover_ISO14443B)).isChecked()).apply();
        sharedPref.edit().putBoolean("discover_ISO15693", ((RadioButton)mRoot.findViewById(R.id.discover_ISO15693)).isChecked()).apply();
        super.onPause();
    }

    public void onTagsCommands(View view) {
        final RadioButton checkISO14443A = mRoot.findViewById(R.id.discover_ISO14443A);
        final RadioButton checkISO14443B = mRoot.findViewById(R.id.discover_ISO14443B);
        final RadioButton checkISO15693 = mRoot.findViewById(R.id.discover_ISO15693);
        switch(view.getId()) {
            case R.id.discover_tags:
                /*boolean bR = ((MainActivity) getActivity()).mUemR.SAM.authenticateHost(
                        (byte)0x00,
                        UemReader.CommandsSAM.UEM_SAM_HOST_MODE_PLAIN,
                        UemReader.CommandsSAM.UEM_SAM_KEY_KIND_AES128,
                        (byte)0x00,
                        (byte)0x00,
                        new byte[]{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}
                        );
                //String sE = ((MainActivity) getActivity()).mUemR.getLastError();
                if (!bR) {
                    Toast.makeText(getActivity().getApplicationContext(),
                            ((MainActivity) getActivity()).mUemR.getLastError() + " " + ((MainActivity) getActivity()).mUemR.getLastErrorCode() + " " + ((MainActivity) getActivity()).mUemR.SAM.SW[0] + " " + ((MainActivity) getActivity()).mUemR.SAM.SW[1], Toast.LENGTH_LONG)
                            .show();
                }*/
                mListTags.clear();
                ListView listTags = mRoot.findViewById(R.id.tags);
                ((ArrayAdapter<String>) listTags.getAdapter()).notifyDataSetChanged();
                ((MainActivity) getActivity()).mUemR.Reader.switchOnRadioController();
                String UID = null;
                if (checkISO14443A.isChecked()) {
                    ((MainActivity) getActivity()).mUemR.Reader.setRadioMode(UemReader.CommandsCards.UEM_CARD_STANDARD_ISO14443A);
                    UemReader.CommandsCards.CommandsISO14443A.TagISO14443A tag = ((MainActivity) getActivity()).mUemR.Cards.ISO14443A.activateIdle();
                    if (tag != null) {
                        ((MainActivity) getActivity()).mUID = tag.UID;
                        UID = UemReader.Helper.byteArrayToHexString(((MainActivity) getActivity()).mUID);
                        ((MainActivity) getActivity()).mActiveMode = UemReader.CommandsCards.UEM_CARD_STANDARD_ISO14443A;
                    } else {
                        Toast.makeText(getActivity().getApplicationContext(),
                                ((MainActivity) getActivity()).mUemR.getLastError() , Toast.LENGTH_LONG)
                                .show();
                    }
                }
                if (checkISO14443B.isChecked()) {
                    ((MainActivity) getActivity()).mUemR.Reader.setRadioMode(UemReader.CommandsCards.UEM_CARD_STANDARD_ISO14443B);
                    UemReader.CommandsCards.CommandsISO14443B.TagISO14443B[] tags = ((MainActivity) getActivity()).mUemR.Cards.ISO14443B.activateIdle();
                    if (tags != null && tags.length > 0) {
                        ((MainActivity) getActivity()).mUID = tags[0].PUPI;
                        UID = UemReader.Helper.byteArrayToHexString(((MainActivity) getActivity()).mUID);
                        ((MainActivity) getActivity()).mActiveMode = UemReader.CommandsCards.UEM_CARD_STANDARD_ISO14443B;
                    } else {
                        Toast.makeText(getActivity().getApplicationContext(),
                                ((MainActivity) getActivity()).mUemR.getLastError() , Toast.LENGTH_LONG)
                                .show();
                    }
                }
                if (checkISO15693.isChecked()) {
                    ((MainActivity) getActivity()).mUemR.Reader.setRadioMode(UemReader.CommandsCards.UEM_CARD_STANDARD_ISO15693);
                    UemReader.CommandsCards.CommandsISO15693.TagISO15693[] tags = ((MainActivity) getActivity()).mUemR.Cards.ISO15693.findAllTags();
                    if (tags != null && tags.length > 0) {
                        if (tags[0].retCode == 0x00 && tags[0].UID != null) {
                            ((MainActivity) getActivity()).mUID = tags[0].UID;
                            UID = UemReader.Helper.byteArrayToHexString(((MainActivity) getActivity()).mUID);
                        }
                        ((MainActivity) getActivity()).mActiveMode = UemReader.CommandsCards.UEM_CARD_STANDARD_ISO15693;
                    } else {
                        Toast.makeText(getActivity().getApplicationContext(),
                                ((MainActivity) getActivity()).mUemR.getLastError() , Toast.LENGTH_LONG)
                                .show();
                    }
                }
                if (UID == null)
                    break;
                boolean found = false;
                for (String string : mListTags) {
                    if(string.equals(UID)){
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    mListTags.add(UID);
                    ((ArrayAdapter<String>) listTags.getAdapter()).notifyDataSetChanged();
                }
                break;
            case R.id.button_activate_tcl:
                if (checkISO14443A.isChecked()) {
                    UemReader.CommandsCards.CommandsISO14443A.TagISO14443A tagA = ((MainActivity) getActivity()).mUemR.Cards.ISO14443A.activateExTCL();
                    if (tagA == null || !((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)) {
                        Toast.makeText(getActivity().getApplicationContext(),
                                ((MainActivity) getActivity()).mUemR.getLastError() , Toast.LENGTH_LONG)
                                .show();
                    } else {
                        Toast.makeText(getActivity().getApplicationContext(),
                                "Card " + UemReader.Helper.byteArrayToHexString(tagA.UID) + " activated, ATS=" + UemReader.Helper.byteArrayToHexString(tagA.ATS) , Toast.LENGTH_LONG)
                                .show();
                    }
                }
                if (checkISO14443B.isChecked()) {
                    UemReader.CommandsCards.CommandsISO14443B.TagISO14443B tagB = ((MainActivity) getActivity()).mUemR.Cards.ISO14443B.activateExTCL();
                    if (tagB == null || !((MainActivity) getActivity()).mUemR.getLastError().equals(UemReader.UEM_STATUS_SUCCESS)) {
                        Toast.makeText(getActivity().getApplicationContext(),
                                ((MainActivity) getActivity()).mUemR.getLastError() , Toast.LENGTH_LONG)
                                .show();
                    } else {
                        Toast.makeText(getActivity().getApplicationContext(),
                                "Card " + UemReader.Helper.byteArrayToHexString(tagB.PUPI) + " activated, ATQ=" + UemReader.Helper.byteArrayToHexString(tagB.ATQ) , Toast.LENGTH_LONG)
                                .show();
                    }
                }
                break;
            default:
        }
    }
}