
//==============================================================================
//             SAM-:    RFID-
//==============================================================================

// Clscrfl_SAM.h : main header file for the SAM CLSCRFL DLL EXTENSION

//   RFID-     :
//==============================================================================
//        SAM-
//------------------------------------------------------------------------------
//    SAM
//     SAM-
//      APDU
//    SAM   AV1   AV2
//    () SAM
//     Mifare Classic
//     Mifare Classic
//     Mifare Classic
//     Value  Mifare Classic
//     Mifare Classic
//==============================================================================

//      :
//          0 -  
// 0x80100001 -   ,     
//                 CLSCRF_GetLastInternalError



#if !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
#define AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_

#if _MSC_VER > 1000
	#pragma once
#endif // _MSC_VER > 1000



#ifndef STATIC_LIB
	#ifdef CLSCRF_EXPORTS
		#define CLSCRF_API __declspec(dllexport)
	#else
		#define CLSCRF_API __declspec(dllimport)
	#endif
#else
	#define CLSCRF_API
#endif

#ifdef CLSCRF_CDECL
	#define CLSCRF_DECL __cdecl
#else
	#define CLSCRF_DECL __stdcall
#endif

#ifndef _LPCBYTE_DEFINED
	#define _LPCBYTE_DEFINED
	typedef const BYTE *LPCBYTE;
#endif


#undef STRING_VERSION
#define STRING_VERSION      "S8.10"

#pragma pack(push, 1)

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//------------------------------------------------------------------------------
//  SAM:       
//------------------------------------------------------------------------------
//
//       
//
// pucSW1   1 ;
// pucSW2   2 .
// pError -     (256 ), 
//              
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_GetStatusDescription(	IN BYTE ucSW1,
												IN BYTE ucSW2,
												OUT LPSTR pError);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM
//------------------------------------------------------------------------------
//
//   SAM
//        
//        
//
// pReader    - (.  CLSCRF_Create);
// ucNumHolder     1  4.
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolder(	IN LPVOID pReader,
											IN BYTE ucNumHolder );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM   ATR
//------------------------------------------------------------------------------
//
//   SAM
//        
//        
//
// pReader    - (.  CLSCRF_Create);
// ucNumHolder     1  4.
// dwATRBufSize   ,     ATR.
// pATR      ,     ATR.
// pdwATRSize   ATR,   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolderGetATR(	IN  LPVOID pReader,
												IN  BYTE ucNumHolder,
												IN  DWORD dwATRBufSize,
												OUT PBYTE  pATR,
												OUT PDWORD pdwATRSize
											);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM   
//------------------------------------------------------------------------------
//
//   SAM   
//
// pReader    - (.  CLSCRF_Create);
// ucNumHolder     1  4 ( 0,    ).
// ucWT10 -    0xFF,      ATR    (ISO 7816-3, .8.1).
// ucPPS1 -    0xFF,     PPS1,     TA1 (ISO 7816-3, .9.2, .8.3).
// ucDeactivate -  > 0,      ;
// dwATRBufSize   ,     ATR,  0,  ATR  ;
// pATR      ,     ATR ( NULL,   ).
// pdwATRSize   ATR,    ( NULL,   ).
//
//       ,      .
//
//   ucNumHolder    , 
//
//		 .
//
// ,  ucNumHolder > 0
//
//		    NumHolder  .
//		       .
//		         50 .
//		       1 .
//		            WT( ATR  )  ISO 7816 - 3, .8.1.
//		   WT  ucWT10  FlashParam[20]:
//		 ucWT10 != 0xFF
//			WT = ucWT10 * 10 ( 2540 ).
//		( ucWT10 == 0xFF)
//			 FlashParam[20] = 0xFF
//				WT  (ISO 7816 - 3, .8.1)( 750 ).
//			( FlashParam[20] < 0xFF)
//				WT = FlashParam[20] * 10 ( 2540 ).
// 
//		           ,      ATR.
//		,  SAM AV2  NXP   
//			PPS1 = 0x18 (fKHz = 4800, Baudrate = 154838 ),
//		,   ,    :
//			PPS1 = 0x96 (fKHz = 4800, Baudrate = 300000 ),
//			PPS1 = 0xD7 (fKHz = 12000, Baudrate = 375000 ).
//		     ucPPS1  FlashParam[21].
//		 ucPPS1 != 0xFF
//			PPS1 = ucPPS1;
//		( Opt_PPS1 = 0)
//			 FlashParam[21] = 0xFF
//				PPS1 = TA1
//				( SAM AV2 TA1 = 0x18 (fKHz = 4800, Baudrate = 154838));
//			( FlashParam[21] < 0xFF)
//				PPS1 = FlashParam[21].
// 
// 		 ucDeactivate > 0
// 			   ( ) .
// 		( ucDeactivate == 0)
//			   ( )  .
// 
//  ( ucNumHolder = 0)
// 
// 		    (    ),   7..4 .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_SetCurrentHolderEx(	IN  LPVOID pReader,
											IN  BYTE ucNumHolder,
											IN  BYTE ucWT10,
											IN  BYTE ucPPS1,
											IN  BYTE ucDeactivate,
											IN  DWORD dwATRBufSize,
											OUT PBYTE  pATR,
											OUT PDWORD pdwATRSize
											);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:    SAM-
//------------------------------------------------------------------------------
//
//    SAM-
//
// pReader    - (.  CLSCRF_Create);
// pucNumSAM     1  4.
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_GetCurrentHolder(	IN LPVOID pReader,
											OUT LPBYTE pucNumSAM );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:     APDU
//------------------------------------------------------------------------------
//
//     APDU
//
// pReader    - (.  CLSCRF_Create);
// pbSendBuffer  ;
// dwSendLength   ;
// pbRecvBuffer  ,    SW1  SW2;
// pdwRecvLength   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_APDU(  IN     LPVOID  pReader,
                              IN     LPCBYTE pbSendBuffer, 
                              IN     DWORD   dwSendLength, 
                                 OUT LPBYTE  pbRecvBuffer, 
                              IN OUT LPDWORD pdwRecvLength );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
//  SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -     ;
// ucKeyVer[1] -     ;
// pUnlockKey[24] -   
// ucUnlockKeyNo[1] -    ;
// ucUnlockKeyVer[1] -    ;
//                  ( NULL,     );
// dwMaxChainBlocks -     
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_Lock(IN LPVOID pReader,
							IN BYTE ucLC,
							IN BYTE ucKeyKind,
							IN BYTE ucKeyNo, 
							IN BYTE ucKeyVer, 
							IN PBYTE pUnlockKey, 
							IN BYTE ucUnlockKeyNo,
							IN BYTE ucUnlockKeyVer,
							//IN DWORD dwMaxChainBlocks,
							OUT LPBYTE pucSW1,
							OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
//  SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// pUnlockKey[24] -   
//                  ( NULL,     );
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_Unlock(	IN LPVOID pReader,
								IN BYTE ucLC,
								IN BYTE ucKeyKind,
								IN BYTE ucKeyNo, 
								IN BYTE ucKeyVer, 
								IN PBYTE pUnlockKey, 
								OUT LPBYTE pucSW1,
								OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:     SAM-
//------------------------------------------------------------------------------
//
typedef struct _CLSCRF_SAM_VERSION
{
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} HardwareVersionInfo;
	struct
	{
		BYTE ucVendorID;
		BYTE ucType;
		BYTE ucSubType;
		BYTE ucMajorVersion;
		BYTE ucMinorVersion;
		BYTE ucStorageSize;
		BYTE ucProtocolType;
	} SoftwareVersionInfo;
	struct
	{
		BYTE UID[7];
		BYTE BatchNumber[5];
		BYTE ucProductionDay;
		BYTE ucProductionMonth;
		BYTE ucProductionYear;
		union
		{
			struct
			{
				BYTE RFU:3;
				BYTE fDisable_DESFirePICCKeyChange:1;
				BYTE fDisable_Decryption:1;
				BYTE fDisable_Encryption:1;
				BYTE fDisable_MAC_Verification:1;
				BYTE fDisable_MAC_Generation:1;
			};
			BYTE ucBits;
		} CryptoSettings;
	} ManufacturerData;
	BYTE ucMode;
} CLSCRF_SAM_VERSION;

//     SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// pVersion -    SAM-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_GetVersion(	IN LPVOID pReader,
									IN BYTE ucLC,
									OUT CLSCRF_SAM_VERSION* pVersion,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:  SAM-
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_AUTH_MODE_AV1
{
	struct
	{
		BYTE fKeyDiversifiedWith8Or16BytesDivInp:1;
		BYTE fUseLogicalChannelForCMACCalculation:1;
		BYTE fUseSecretKeyForCrypto:1;
		BYTE fDiversifyUsingOneEncryptionRound:1;
		BYTE fUseMIFARE_SAM_AV2_ModeKeyDiversificationMethods:1;
		BYTE RFU:3;
	};
	BYTE ucBitMask;
} CLSCRF_SAM_AUTH_MODE_AV1;
//
//  SAM-  
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucHostMode[1] -  :
//					0: Plain;
//					1: MAC Protection;
//					2: Full Protection;
//					3: RFU;
// ucKeyKind[1] -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// pKey[24] -   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_AuthenticateHost(IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucHostMode,
										IN BYTE ucKeyKind,
										IN BYTE ucKeyNo, 
										IN BYTE ucKeyVer, 
										IN PBYTE pKey, 
										//IN BYTE ucDivLength, 
										//IN LPBYTE pbDivInp, 
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:  Offline- SAM-
//------------------------------------------------------------------------------
//
//  Offline- SAM-
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo[1] -    ;
// ucKeyVer[1] -    ;
// ucDivLength[1] -    (8-  DES, 
//                  16-  AES  1-31-  );
// pbDivInp[1-31] -   ( DES, AES   );
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_ActivateOfflineKey(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucKeyNo, 
											IN BYTE ucKeyVer, 
											IN BYTE ucDivLength, 
											IN LPBYTE pbDivInp, 
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM   AV1   AV2
//------------------------------------------------------------------------------
//
//   SAM   AV1   AV2
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// pbNewPosAkey[16] -   - AES-128   A;
// ucNewPosAkeyVer[1] -     AES-128   A  0  255;
// pbNewPosBkey[16] -   - AES-128   B;
// ucNewPosBkeyVer[1] -     AES-128   B  0  255;
// pbNewPosCkey[16] -   - AES-128   C;
// ucNewPosCkeyVer[1] -     AES-128   C  0  255;
// dwMaxChainBlocks -     
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_SwitchToAV2Mode(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN LPBYTE pbNewPosAkey, 
										IN BYTE ucNewPosAkeyVer, 
										IN LPBYTE pbNewPosBkey, 
										IN BYTE ucNewPosBkeyVer, 
										IN LPBYTE pbNewPosCkey, 
										IN BYTE ucNewPosCkeyVer, 
										IN DWORD dwMaxChainBlocks,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   () SAM
//------------------------------------------------------------------------------
//
//   () SAM
//
// pReader    - (.  CLSCRF_Create).
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Reset(IN LPVOID pReader);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   () SAM
//------------------------------------------------------------------------------
//
//    SAM
//
// pReader    - (.  CLSCRF_Create).
// ucType  0x01 -   , 0x00 -   SAM  
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_KillAuth(IN LPVOID pReader,
IN BYTE ucType);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   Halt   ISO14443A   SAM
//------------------------------------------------------------------------------
//
//   Halt   ISO14443A   SAM
//
// pReader    - (.  CLSCRF_Create).
// ucLC    SAM-:  0  3;
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Halt_A(IN LPVOID pReader,
IN BYTE ucLC);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_SETTINGS
{
	struct
	{
		WORD bAllowDumpSessionKey:1;
		WORD bAllowCryptoWithSecretKey:1;
		WORD bfKeepInitVector:1;
		WORD wKeyKind:3;
		WORD RFU:2;
		WORD bAV1HigherCmdSecLevel:1;
		WORD bDisableKeyEntry:1;
		WORD bAV1EnableHostAuth:1;
		WORD bDisableChangeKey:1;
		WORD bDisableDecryption:1;
		WORD bDisableEncryption:1;
		WORD bDisableVerifyMAC:1;
		WORD bDisableGenerateMAC:1;
	};
	struct
	{
		WORD :8;
		WORD bAV2EnableHostAuthKey:1;
		WORD :1;
		WORD bAV1AV2AllowLockUnlock:1;
		WORD :5;
	};
	WORD wSettings;
} CLSCRF_SAM_SETTINGS;

typedef union _CLSCRF_SAM_EXT_SETTINGS
{
	struct
	{
		BYTE iKeyClass:3;
		BYTE bAllowDumpSecretKey:1;
		BYTE bRestrictToDiversifiedUse:1;
		BYTE RFU:3;
	};
	BYTE ucExtSettings;
} CLSCRF_SAM_EXT_SETTINGS;

typedef union _CLSCRF_SAM_NV_PROGRAMMING_MASK
{
	struct
	{
		BYTE fUpdateKeyA:1;
		BYTE fUpdateKeyB:1;
		BYTE fUpdateKeyC:1;
		BYTE fUpdateDFKeyNoAndAID:1;
		BYTE fUpdateKeyCEK_NumberAndVersion:1;
		BYTE fUpdateRefNoKUC:1;
		BYTE fUpdateSettings:1;
		BYTE fSendKeyVersionsSeparately:1;
	};
	BYTE ucNVProgramingMask;
} CLSCRF_SAM_NV_PROGRAMMING_MASK;

//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// ucKeyNo -  Mifare-  SAM-  1  127;
// pucKeyAVersion -    A;
// pucKeyBVersion -    B;
// pucKeyCVersion -    C;
// pdwDESFireAID - 3   AID   DESFire;
// pucDESFireKeyNo -  AID,   DESFire;
// pucKeyNoCEK -      ;
// pucKeyVCEK -    ;
// pucRefNoKUC -      ;
// pSettings -     ;
// pExtSettings -      ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_GetKeyEntry(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN BYTE ucKeyKind,
									IN BYTE ucKeyNo,
									OUT LPBYTE pucKeyAVersion,
									OUT LPBYTE pucKeyBVersion,
									OUT LPBYTE pucKeyCVersion,
									OUT LPDWORD pdwDESFireAID,
									OUT LPBYTE pucDESFireKeyNo,
									OUT LPBYTE pucKeyNoCEK,
									OUT LPBYTE pucKeyVCEK,
									OUT LPBYTE pucRefNoKUC,
									OUT CLSCRF_SAM_SETTINGS* pSettings,
									OUT CLSCRF_SAM_EXT_SETTINGS* pExtSettings,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//
//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbKeyA  -  A;
// pbKeyB  -  B;
// pbKeyC  -  C;
// pbDF_AID  - 3   AID   DESFire;
// ucDF_KeyNr  -  AID,   DESFire;
// ucCEKNo -      ;
// ucCEKV  -    ;
// ucKUC   -      ;
// pSettings -     ;
// ucKeyVerA -   A;
// ucKeyVerB -   B;
// ucKeyVerC -   C;
// pExtSettings -      ;
// fPlainKeyUpdate  ,      ;
// fOfflineKeyChange   ,      (Online/Offline);
// pbSAM_UID  UID SAM-;
// pNVProgrammingMask     flash-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_ChangeKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbKeyA,
										IN LPBYTE pbKeyB,
										IN LPBYTE pbKeyC,
										IN DWORD dwDF_AID,
										IN BYTE ucDF_KeyNr,
										IN BYTE ucCEKNo,
										IN BYTE ucCEKV,
										IN BYTE ucKUC,
										IN CLSCRF_SAM_SETTINGS* pSettings,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN BYTE ucKeyVerC,
										IN CLSCRF_SAM_EXT_SETTINGS* pExtSettings,
										IN BOOL fPlainKeyUpdate,
										IN BOOL fOfflineKeyChange,
										IN LPBYTE pbSAM_UID,
										IN CLSCRF_SAM_NV_PROGRAMMING_MASK* pNVProgrammingMask,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   SAM-   
//------------------------------------------------------------------------------
//
//   SAM-   
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyKind -  :
//					0: TDEA - DESFire;
//					1: TDEA - ISO 10116(CRC16);
//					2: MIFARE;
//					3: 3 Key TDEA - ISO 10116;
//					4: AES 128;
//					5: AES 192;
//					6: TDEA - ISO 10116(CRC32);
// pbSAM_UID  UID SAM-;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_DisableKeyEntry(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyKind,
										IN LPBYTE pbSAM_UID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucAuthType -  : 1 - First Authenticate,  - Following Authenticate;
// pbUID[4] -   ;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyVer -  Mifare-  SAM-  0  255;
// ucKeyType -  Mifare-: 0x0A - KeyA,  KeyB;
// dwSector -   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareAuthenticate(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucAuthType,
											IN LPBYTE pbUID,
											IN BYTE ucKeyNo,
											IN BYTE ucKeyVer,
											IN BYTE ucKeyType,
											IN DWORD  dwSector,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwBlock      -   ;
// pbRecvBuffer -  (  16 )   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareRead(	IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
									OUT LPBYTE pbRecvBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwBlock      -   ;
// pbSendBuffer -  (  16 )   ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareWrite( IN LPVOID pReader,
									IN BYTE ucLC,
									IN DWORD  dwSector,
									IN DWORD  dwBlock,
                                    IN LPBYTE pbSendBuffer,
									OUT LPBYTE pucSW1,
									OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
//     Value
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector      -  ,   ;
// dwSourceBlock -   ;
// dwValue       - ,    ;
// dwTargetBlock -  -,    dwSourceBlock;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareIncrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
//     Value
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector     -  ,   ;
// dwSourceBlock -   ;
// dwValue       - ,    ;
// dwTargetBlock -  -,    dwSourceBlock;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareDecrement(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwValue,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:   -    Value  Mifare Classic
//------------------------------------------------------------------------------
//
//       Value     
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// dwSector      -  ,   ;
// dwSourceBlock -   ;
// dwTargetBlock -  -;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareRestore(	IN LPVOID pReader,
										IN BYTE ucLC,
                                        IN DWORD  dwSector,
                                        IN DWORD  dwSourceBlock,
                                        IN DWORD  dwTargetBlock,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:    Mifare Classic
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_CK_PARAM_MASK
{
	struct
	{
		BYTE bEncrypt:1;
		BYTE bDiversifyKeyA:1;
		BYTE bDiversifyKeyB:1;
		BYTE RFU:5;
	};
	BYTE ucBits;
} CLSCRF_SAM_CK_PARAM_MASK;

//
//    Mifare Classic
//
// pReader    - (.  CLSCRF_Create);
// ucLC     0  3;
// ucParamMask -       ;
// ucKeyNo -   Mifare-  SAM-  1  127;
// ucKeyVerA -   Mifare- KeyA  SAM-  0  255;
// ucKeyVerB -   Mifare- KeyB  SAM-  0  255;
// dwSector     -  ,  ;
// pbAccess[4] -     ;
// pbUID[4] -    ( ,  Crypto  0);
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareChangeKey(	IN LPVOID pReader,
										IN BYTE ucLC,
										IN CLSCRF_SAM_CK_PARAM_MASK ParamMask,
										IN BYTE ucKeyNo,
										IN BYTE ucKeyVerA,
										IN BYTE ucKeyVerB,
										IN DWORD  dwSector,
										IN LPBYTE pbAccess,
										IN LPBYTE pbUID,
										OUT LPBYTE pucSW1,
										OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM:     Mifare Classic
//------------------------------------------------------------------------------
//
//      Mifare Classic ( Mifare Plus   SL1).
//
// pReader    - (.  CLSCRF_Create);
// ucSAMLC    SAM-:  0  3;
// ucSAMHolder     :  0  4, 0 -  ;
// ucSAMKeyNo -  Mifare-  SAM-  1  127 ( 0,    );
// ucSAMKeyVer -  Mifare-  SAM-  0  255;
// ucSAMResetType -    SAM-:
//              0x00 - Don't SAM Reset (   SAM-)
//              0x01 - Card Authentication Reset (  , )
//              0x02 - All Authentication Reset (  )
//              0x03 - Hard Reset ( )
// ucRfOffTime -   [],     . 
//                   ucRfOnPauseTime  0,    , 
//                 Activate Idle  ,   ucSAMKeyNo > 0,  
//                 ;
//                   ucRfOnPauseTime   0,   Activate Idle , 
//                 ucSAMKeyNo > 0,     ;
// ucRfOnPauseTime -   [],    (+5 )     
//                        ;
// ucMifareKeyType -  Mifare-: 0x0A - KeyA, 0x0B - KeyB;
// ucMifareOperation -  :
//              0x01 - 
//              0x02 - 
//              0x03 -    ;
// ucMifareSector -   ;
// ucMifareBlock  -      ;
// ucMifareBlocksCount -     ;
// pucATQ   -    (2 ),     ATQ 
// pucSAK   -    (1 ),     SAK 
// pucUID   -    (  10 ),   
//               (UID);
// pucUIDLength -     BYTE,   
//                     pucUID,   
//                    
//                 ,    pucUID
//                (  - 0, 4, 7  10)
// pucWriteData -     ( NULL,   );
// pucReadData -  (  ucMifareBlocksCount*16 )    ( NULL,   );
// pucLastTask -    ,       :
//              0x01 - RF Reset,
//              0x02 - ActivateIdleA,
//              0x03 - SAM SetHolder,
//              0x04 - SAM Reset,
//              0x05 - RFU,
//              0x06 - SAM_MifareAuthenticate,
//              0x07 - SAM_MifareWrite,
//              0x08 - SAM_MifareRead,
//              0x09 -  ;
// pucResBlkCnt -    ,      
//                 ;
// pucSW1   ;
// pucSW2   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_Mifare_Complex(IN LPVOID pReader,
IN BYTE ucSAMLC,
IN BYTE ucSAMHolder,
IN BYTE ucSAMKeyNo,
IN BYTE ucSAMKeyVer,
IN BYTE ucSAMResetType,
IN BYTE ucRfOffTime,
IN BYTE ucRfOnPauseTime,
IN BYTE ucMifareKeyType,
IN BYTE ucMifareOperation,
IN BYTE ucMifareSector,
IN BYTE ucMifareBlock,
IN BYTE ucMifareBlocksCount,
OUT LPBYTE pucATQ,
OUT LPBYTE pucSAK,
OUT LPBYTE pucUID,
IN OUT LPBYTE pucUIDLength,
IN LPBYTE pucWriteData,
OUT LPBYTE pucReadData,
OUT LPBYTE pucLastTask,
OUT LPBYTE pucResBlkCnt,
OUT LPBYTE pucSW1,
OUT LPBYTE pucSW2);


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//==============================================================================
//                          M I F A R E    U L T R A L I G H T (C)
//==============================================================================
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//    Ultra Light C:  
//------------------------------------------------------------------------------
//
//       SAM- 
//
// pReader      -   - (.  CLSCRF_Create )
// ucLC     0  3;
// pbUID[7] -   ;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyVer -  Mifare-  SAM-  0  255;
// pucSW1   ;
// pucSW2   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareUltralightC_WriteKey(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN LPBYTE pbUID,
													IN BYTE ucKeyNo,
													IN BYTE ucKeyVer,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//    Ultra Light C: 
//------------------------------------------------------------------------------
//
//      SAM-
//
// pReader      -   - (.  CLSCRF_Create )
// ucLC     0  3;
// pbUID[7] -   ;
// ucKeyNo -  Mifare-  SAM-  1  127;
// ucKeyVer -  Mifare-  SAM-  0  255;
// pucSW1   ;
// pucSW2   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifareUltralightC_Authenticate(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN LPBYTE pbUID,
														IN BYTE ucKeyNo,
														IN BYTE ucKeyVer,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   
//------------------------------------------------------------------------------
//
//     
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucValueType   -    (. )
// ucSectorNumber-   (      , 
//                    )
// ucBlockNumber -   (      , 
//                      )
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_WritePerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												IN BYTE  ucValueType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucBlockNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_CommitPerso(	IN LPVOID pReader,
												IN BYTE  ucLC,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: MifarePlus:  
//------------------------------------------------------------------------------
//
//   Mifare Plus
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucAuthType	 -     (. );
// ucSecLevel	 -    (0x00 -  SL0, SL1; 0x01 -  SL2; 0x03 -  SL3);
// ucKeyType     -     (. );
// ucSectorNumber-    ;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenCap      -     (0..6,   0);
// pbPcdCap      -    ( );
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0     ,
//       .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Authenticate(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE  ucAuthType,
												IN BYTE  ucSecLevel,
												IN BYTE  ucKeyType,
												IN BYTE  ucSectorNumber,
												IN BYTE  ucKeyNumber,
												IN BYTE  ucKeyVersion,
												IN BYTE  ucLenCap,
												IN LPBYTE pbPcdCap,
												IN BYTE  ucLenDiv,
												IN LPBYTE pbDiv,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    SL2
//------------------------------------------------------------------------------
//
//     SL2,    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucSectorNumber -  
// ucBlockNumber -  ,     
// ucBlocksCount -   
// pbData		 -    ,     
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_MultiBlockRead(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													OUT LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    SL2
//------------------------------------------------------------------------------
//
//     SL2,    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucSectorNumber -  
// ucBlockNumber -     
// ucBlocksCount -   
// pbData		 -        
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_MultiBlockWrite(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE ucSectorNumber,
													IN BYTE ucBlockNumber,
													IN BYTE ucBlocksCount,
													IN LPBYTE pbData,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//     SL3,   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucReadMode    -    (. );
// ucValueType   -    (.  117   MifarePlus);
// ucSectorNumber -     ;
// ucBlockNumber -     ;
// ucBlocksCount -   ;
// pbData		 -    ,     ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_ReadData(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucReadMode,
											IN BYTE ucValueType,
											IN BYTE ucSectorNumber,
											IN BYTE ucBlockNumber,
											IN BYTE ucBlocksCount,
											OUT LPBYTE pbData,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//     SL3,   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucWriteMode   -    (. );
// ucValueType   -    (.  117   MifarePlus);
// ucSectorNumber -     ;
// ucBlockNumber -     ;
// ucBlocksCount -   ;
// pbData		 -    ,       ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_WriteData(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucWriteMode,
												IN BYTE ucValueType,
												IN BYTE ucSectorNumber,
												IN BYTE ucBlockNumber,
												IN BYTE ucBlocksCount,
												IN LPBYTE pbData,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//     SL3,   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			 -    0  3;
// ucEncryptionMode -    (0x00 - , MAC  ; 0x01 - , MAC  , MAC  );
// ucKeyType     -     (. );
// ucSectorNumber -     ;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenDiv		 -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
CLSCRF_SAM_MifarePlus_ChangeKey(IN LPVOID pReader,
IN BYTE ucLC,
IN BYTE ucEncryptionMode,
IN BYTE ucKeyType,
IN BYTE ucSectorNumber,
IN BYTE ucKeyNumber,
IN BYTE ucKeyVersion,
IN BYTE ucLenDiv,
IN LPBYTE pbDiv,
OUT LPBYTE pucSW1,
OUT LPBYTE pucSW2);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//     SL3,    
//         (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Increment(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:  
//------------------------------------------------------------------------------
//
//     SL3,    
//         (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Decrement(	IN LPVOID pReader,
												IN BYTE ucLC,
												IN BYTE ucEncryptionMode,
												IN BYTE ucSourceSectorNumber,
												IN BYTE ucSourceBlockNumber,
												IN DWORD dwValue,
												OUT LPBYTE pucSW1,
												OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
//     SL3,     (Transfer Buffer) 
//   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Transfer(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucDestinationSectorNumber,
											IN BYTE ucDestinationBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:       
//------------------------------------------------------------------------------
//
//     SL3,    ,
//       (Transfer Buffer)  
//   
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_IncrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:       
//------------------------------------------------------------------------------
//
//     SL3,    ,
//       (Transfer Buffer)  
//   
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// ucDestinationSectorNumber -    ;
// ucDestinationBlockNumber -    ;
// dwValue		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_DecrementTransfer(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucEncryptionMode,
														IN BYTE ucSourceSectorNumber,
														IN BYTE ucSourceBlockNumber,
														IN BYTE ucDestinationSectorNumber,
														IN BYTE ucDestinationBlockNumber,
														IN DWORD dwValue,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   -    (Transfer Buffer)
//------------------------------------------------------------------------------
//
//     SL3,     -
//    (Transfer Buffer) 
//
// pReader       -   - (.  CLSCRF_Create );
// ucLC			     0  3;
// ucEncryptionMode -    (. );
// ucSourceSectorNumber -   ;
// ucSourceBlockNumber -   ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  ,
//                        -   .
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_Restore(	IN LPVOID pReader,
											IN BYTE ucLC,
											IN BYTE ucEncryptionMode,
											IN BYTE ucSourceSectorNumber,
											IN BYTE ucSourceBlockNumber,
											OUT LPBYTE pucSW1,
											OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
// ,        -    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_ProximityCheck(	IN LPVOID pReader,
													IN BYTE ucLC,
													IN BYTE  ucKeyNumber,
													IN BYTE  ucKeyVersion,
													IN BYTE  ucLenDiv,
													IN LPBYTE pbDiv,
													OUT LPBYTE pucSW1,
													OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
typedef union _CLSCRF_SAM_VC_DUO
{
	struct 
	{
		BYTE ucKeyEncNo;
		BYTE ucKeyEncVer;
		BYTE ucKeyMacNo;
		BYTE ucKeyMacVer;
	};
	DWORD dwBits;
} CLSCRF_SAM_VC_DUO;

//
//         
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucIIDCount	 -      
// IIDs			 -    (16  * ucIIDCount)
// ucLenCap      -     (0..3,   0)
// pbPcdCap      -    ( )
// ucDuosCount	 -       
// Duos			 - ,     VC Polling ENC Key 
//				    VC Polling MAC Key,      
//				      SAM 
// pbRndQ		 -     12 ,     
//				   RndQ,    SAM-
// pucInfo		 -    ,    
//				      (0x83 - 4- UID, 0x80 - 7- UID)
// bpPiccCap	 -    (2 ),    
//				    
// pbUID		 -    (7 ),     UID 
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL 
            CLSCRF_SAM_MifarePlus_VirtualCardSupport(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE ucIIDCount,
														IN LPBYTE IIDs,
														IN BYTE ucLenCap,
														IN LPBYTE pbPcdCap,
														IN BYTE ucDuosCount,
														IN CLSCRF_SAM_VC_DUO* Duos,
														OUT LPBYTE pbRndQ,
														OUT LPBYTE pucInfo,
														OUT LPBYTE pbPiccCap,
														OUT LPBYTE pbUID,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:   
//------------------------------------------------------------------------------
//
//    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// ucKeyNumber   -  Mifare-  SAM-  1  127;
// ucKeyVersion  -  Mifare-  SAM-  0  255;
// pbRndQ		 -     12 ,    
//				   RndQ,    SAM-
// ucLenDiv      -     ;
// pbDiv		 -    ;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_VirtualCardSelect(	IN LPVOID pReader,
														IN BYTE ucLC,
														IN BYTE  ucKeyNumber,
														IN BYTE  ucKeyVersion,
														IN LPBYTE pbRndQ,
														IN BYTE  ucLenDiv,
														IN LPBYTE pbDiv,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//------------------------------------------------------------------------------
//  SAM: Mifare Plus:    
//------------------------------------------------------------------------------
//
//    
//
// pReader       -   - (.  CLSCRF_Create )
// ucLC			     0  3;
// pucSW1		   ;
// pucSW2		   .
//
//  :  0   -  
//                        -   
//
CLSCRF_API LONG CLSCRF_DECL
            CLSCRF_SAM_MifarePlus_VirtualCardDeselect(	IN LPVOID pReader,
														IN BYTE ucLC,
														OUT LPBYTE pucSW1,
														OUT LPBYTE pucSW2 );

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

#pragma pack(pop)

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLSCRF_H__DE290562_87D9_41F4_A1CD_3B80EFEBA737__INCLUDED_)
