
// UemKbdEmulatorDlg.cpp :  
//

#include "stdafx.h"
#include "UemKbdEmulator.h"
#include "UemKbdEmulatorDlg.h"
#include "afxdialogex.h"
#include <string>
#include "..\..\Clscrfl.h"
#include "..\..\Clscrfl_SAM.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define IDT_TIMER        789
#define TIMER_PERIOD      300

//   CUemKbdEmulatorDlg

#define BUF_SIZE    520


CUemKbdEmulatorDlg::CUemKbdEmulatorDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CUemKbdEmulatorDlg::IDD, pParent)
	, m_iClView(0)
	, m_iCtView(0)
	, m_iClOrder(0)
	, m_iCtOrder(0)
	, m_iClByteOrder(0)
	, m_iCtByteOrder(0)
	, m_iClKbhit(0)
	, m_iCtKbhit(0)
	, m_fClISO14443A(TRUE)
	, m_fClISO14443B(TRUE)
	, m_fClISO15693(TRUE)
	, m_strClPrefix(_T(""))
	, m_strClPostfix(_T(""))
	, m_strClSeparator(_T(""))
	, m_strCtPrefix(_T(""))
	, m_strCtPostfix(_T(""))
	, m_strCtSeparator(_T(""))
	, m_fBackspace(FALSE)
	, m_ucCardIDLength(0)
	, m_ucCtCardIDLength(0)
	, m_strClVirtualKeyCode(_T("1B"))
	, m_strCtVirtualKeyCode(_T("1B"))
	, m_fCardLost(true)
	, m_fCtCardLost(true)
	, m_fClBeep(FALSE)
	, m_fClLed(FALSE)
	, m_fCtBeep(FALSE)
	, m_fCtLed(FALSE)
	, m_fCtCheckEnabled(FALSE)
	, m_iLastPostLength(0)
	, m_fClUseAPDU(FALSE)
	, m_fCtUseAPDU(FALSE)
	, m_strClAPDU(_T("00 A4 04 00 07 F0 00 00 00 0A 01 01"))
	, m_strCtAPDU(_T("80 CA 9F 7F 00"))//00 A4 04 0C 07 a0000002471001
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUemKbdEmulatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_CL_VIEW_DEC, m_iClView);
	DDX_Radio(pDX, IDC_RADIO_CT_VIEW_DEC, m_iCtView);
	DDX_Radio(pDX, IDC_RADIO_CL_ORDER_STRAIGHT, m_iClOrder);
	DDX_Radio(pDX, IDC_RADIO_CT_ORDER_STRAIGHT, m_iCtOrder);
	DDX_Radio(pDX, IDC_RADIO_CL_BYTE_ORDER_STRAIGHT, m_iClByteOrder);
	DDX_Radio(pDX, IDC_RADIO_CT_BYTE_ORDER_STRAIGHT, m_iCtByteOrder);
	DDX_Radio(pDX, IDC_RADIO_CL_KBHIT_NO, m_iClKbhit);
	DDX_Radio(pDX, IDC_RADIO_CT_KBHIT_NO, m_iCtKbhit);
	DDX_Check(pDX, IDC_CHECK_CL_ISO14443A, m_fClISO14443A);
	DDX_Check(pDX, IDC_CHECK_CL_ISO14443B, m_fClISO14443B);
	DDX_Check(pDX, IDC_CHECK_CL_ISO15693, m_fClISO15693);
	DDX_Text(pDX, IDC_EDIT_CL_PREFIX, m_strClPrefix);
	DDX_Text(pDX, IDC_EDIT_CL_POSTFIX, m_strClPostfix);
	DDX_Text(pDX, IDC_EDIT_CL_SEPARATOR, m_strClSeparator);
	DDX_Text(pDX, IDC_EDIT_CT_PREFIX, m_strCtPrefix);
	DDX_Text(pDX, IDC_EDIT_CT_POSTFIX, m_strCtPostfix);
	DDX_Text(pDX, IDC_EDIT_CT_SEPARATOR, m_strCtSeparator);
	DDX_Check(pDX, IDC_CHECK_BACKSPACE, m_fBackspace);
	DDX_Text(pDX, IDC_EDIT_CL_KBHIT_CUSTOM, m_strClVirtualKeyCode);
	DDX_Text(pDX, IDC_EDIT_CT_KBHIT_CUSTOM, m_strCtVirtualKeyCode);
	DDV_MaxChars(pDX, m_strClVirtualKeyCode, 2);
	DDV_MaxChars(pDX, m_strCtVirtualKeyCode, 2);
	DDX_Check(pDX, IDC_CHECK_CL_BEEP, m_fClBeep);
	DDX_Check(pDX, IDC_CHECK_CL_LED, m_fClLed);
	DDX_Check(pDX, IDC_CHECK_CT_BEEP, m_fCtBeep);
	DDX_Check(pDX, IDC_CHECK_CT_LED, m_fCtLed);
	DDX_Check(pDX, IDC_CHECK_ENABLE_CT_CHECK, m_fCtCheckEnabled);
	DDX_Check(pDX, IDC_CHECK_CL_USE_APDU, m_fClUseAPDU);
	DDX_Check(pDX, IDC_CHECK_CT_USE_APDU, m_fCtUseAPDU);
	DDX_Text(pDX, IDC_EDIT_CL_APDU, m_strClAPDU);
	DDX_Text(pDX, IDC_EDIT_CT_APDU, m_strCtAPDU);
}

BEGIN_MESSAGE_MAP(CUemKbdEmulatorDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_APPLY, &CUemKbdEmulatorDlg::OnBnClickedButton1)
	ON_WM_TIMER()
END_MESSAGE_MAP()


//   CUemKbdEmulatorDlg

BOOL CUemKbdEmulatorDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	//      .     ,
	//        
	SetIcon(m_hIcon, TRUE);			//  
	SetIcon(m_hIcon, FALSE);		//  

	ShowWindow(SW_MINIMIZE);

	ZeroMemory(&m_sSettings, sizeof(m_sSettings));
	ZeroMemory(&m_CardID, sizeof(m_CardID));
	ZeroMemory(&m_CtCardID, sizeof(m_CtCardID));

	LoadSettings();

	m_Timer = SetTimer(IDT_TIMER, TIMER_PERIOD, NULL);

	return TRUE;  //   TRUE,      
}

//            ,
//    .    MFC,     ,
//      .

void CUemKbdEmulatorDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); //    

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		//      
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//          
//   .
HCURSOR CUemKbdEmulatorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

int StrHexInvalid(LPCTSTR pS, BYTE* Data, int &Size)
{
	CString str;
	str = pS;
	str.MakeUpper();
	Size = 0;
	int l = str.GetLength();
	if (l == 0)
		return -1;

	BYTE c;
	USHORT m = 0;
	int i = 0;
	int k = 0;
	while (i < l)
	{
		c = str[i++];
		if (c != ' ')
		{
			if (c >= 0x30 && c <= 0x39)
				m = m * 16 + c - 0x30;
			else if (c >= 0x41 && c <= 0x46)
				m = m * 16 + c - 0x37;
			else
				return i - 1;

			if (++k > 1 || i >= l)
			{
				Data[Size++] = (BYTE)m;
				k = 0;
				m = 0;
			}
		}
	}

	return -1;
}

void CUemKbdEmulatorDlg::OnBnClickedButton1()
{
	SaveSettings();
}

void CUemKbdEmulatorDlg::LoadSettings()
{
	//CHAR Buff[256] = { 0 };
	CFile SettingsFile;
	if (FALSE == SettingsFile.Open(L".\\Settings.dat", CFile::modeRead))
		return;

	SettingsFile.Read((BYTE*)&m_sSettings, sizeof(m_sSettings));

	//sscanf(Buff, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X",
	//	m_Key, m_Key + 1, m_Key + 2, m_Key + 3, m_Key + 4, m_Key + 5, m_Key + 6, m_Key + 7,
	//	m_Key + 8, m_Key + 9, m_Key + 10, m_Key + 11, m_Key + 12, m_Key + 13, m_Key + 14, m_Key + 15);

	SettingsFile.Close();

	m_fBackspace = m_sSettings.fBackspace;
	m_fClISO14443A = m_sSettings.fClISO14443A;
	m_fClISO14443B = m_sSettings.fClISO14443B;
	m_fClISO15693 = m_sSettings.fClISO15693;
	m_iClByteOrder = m_sSettings.iClByteOrder;
	m_iClKbhit = m_sSettings.iClKbhit;
	m_iClOrder = m_sSettings.iClOrder;
	m_iClView = m_sSettings.iClView;
	m_iCtByteOrder = m_sSettings.iCtByteOrder;
	m_iCtKbhit = m_sSettings.iCtKbhit;
	m_iCtOrder = m_sSettings.iCtOrder;
	m_iCtView = m_sSettings.iCtView;
	m_strClPostfix = m_sSettings.strClPostfix;
	m_strClPrefix = m_sSettings.strClPrefix;
	m_strClSeparator = m_sSettings.strClSeparator;
	m_strClAPDU = m_sSettings.strClAPDU;
	m_strCtPostfix = m_sSettings.strCtPostfix;
	m_strCtPrefix = m_sSettings.strCtPrefix;
	m_strCtSeparator = m_sSettings.strCtSeparator;
	m_strCtAPDU = m_sSettings.strCtAPDU;
	m_fClBeep = m_sSettings.fClBeep;
	m_fClLed = m_sSettings.fClLed;
	m_fClUseAPDU = m_sSettings.fClUseAPDU;
	m_fCtBeep = m_sSettings.fCtBeep;
	m_fCtLed = m_sSettings.fCtLed;
	m_fCtUseAPDU = m_sSettings.fCtUseAPDU;
	m_fCtCheckEnabled = m_sSettings.fCtCheckEnabled;

	UpdateData(FALSE);
}

void CUemKbdEmulatorDlg::SaveSettings()
{
	UpdateData();

	m_sSettings.fBackspace = m_fBackspace;
	m_sSettings.fClISO14443A = m_fClISO14443A;
	m_sSettings.fClISO14443B = m_fClISO14443B;
	m_sSettings.fClISO15693 = m_fClISO15693;
	m_sSettings.iClByteOrder = m_iClByteOrder;
	m_sSettings.iClKbhit = m_iClKbhit;
	m_sSettings.iClOrder = m_iClOrder;
	m_sSettings.iClView = m_iClView;
	m_sSettings.fClBeep = m_fClBeep;
	m_sSettings.fClLed = m_fClLed;
	m_sSettings.fClUseAPDU = m_fClUseAPDU;
	m_sSettings.iCtByteOrder = m_iCtByteOrder;
	m_sSettings.iCtKbhit = m_iCtKbhit;
	m_sSettings.iCtOrder = m_iCtOrder;
	m_sSettings.iCtView = m_iCtView;
	m_sSettings.fCtBeep = m_fCtBeep;
	m_sSettings.fCtLed = m_fCtLed;
	m_sSettings.fCtUseAPDU = m_fCtUseAPDU;
	m_sSettings.fCtCheckEnabled = m_fCtCheckEnabled;

	/*
	memcpy(m_sSettings.strClPostfix, m_strClPostfix.GetBuffer(), m_strClPostfix.GetLength());
	memcpy(m_sSettings.strClPrefix, m_strClPrefix.GetBuffer(), m_strClPrefix.GetLength());
	memcpy(m_sSettings.strClSeparator, m_strClSeparator.GetBuffer(), m_strClSeparator.GetLength());
	memcpy(m_sSettings.strCtPostfix, m_strCtPostfix.GetBuffer(), m_strCtPostfix.GetLength());
	memcpy(m_sSettings.strCtPrefix, m_strCtPrefix.GetBuffer(), m_strCtPrefix.GetLength());
	memcpy(m_sSettings.strCtSeparator, m_strCtSeparator.GetBuffer(), m_strCtSeparator.GetLength());

	m_strClPostfix.ReleaseBuffer();
	m_strClPrefix.ReleaseBuffer();
	m_strClSeparator.ReleaseBuffer();
	m_strCtPostfix.ReleaseBuffer();
	m_strCtPrefix.ReleaseBuffer();
	m_strCtSeparator.ReleaseBuffer();
	*/

	wsprintf(m_sSettings.strClPostfix, L"%s", m_strClPostfix);
	wsprintf(m_sSettings.strClPrefix, L"%s", m_strClPrefix);
	wsprintf(m_sSettings.strClSeparator, L"%s", m_strClSeparator);
	wsprintf(m_sSettings.strClAPDU, L"%s", m_strClAPDU);
	wsprintf(m_sSettings.strCtPostfix, L"%s", m_strCtPostfix);
	wsprintf(m_sSettings.strCtPrefix, L"%s", m_strCtPrefix);
	wsprintf(m_sSettings.strCtSeparator, L"%s", m_strCtSeparator);
	wsprintf(m_sSettings.strCtAPDU, L"%s", m_strCtAPDU);

	//CHAR Buff[256] = { 0 };
	CFile SettingsFile;
	if (FALSE == SettingsFile.Open(L".\\Settings.dat", CFile::modeWrite))
	{ 
		if (FALSE == SettingsFile.Open(L".\\Settings.dat", CFile::modeCreate))
			return;
	}

	SettingsFile.Write((BYTE*)&m_sSettings, sizeof(m_sSettings));

	SettingsFile.Close();
}

void CUemKbdEmulatorDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == IDT_TIMER)
	try
	{
		ReaderScan();
	}
	catch (int){};

	//CPropertyPage
	CDialog::OnTimer(nIDEvent);
}

CString CUemKbdEmulatorDlg::MakeHEX(PBYTE pData, UINT nBytes)
{
	CString strOut = L"";
	wchar_t HEX[256] = { 0 };
	for (UINT j = 0; j < nBytes; j++)
		wsprintf(HEX, L"%s %02X", HEX, pData[j]);
	strOut = HEX;
	return strOut;
}

int CUemKbdEmulatorDlg::ReadHEX(CString strCode)
{
	int iRes = 0;
	wscanf(strCode, L"%02X", iRes);
	return iRes;
}

CString CUemKbdEmulatorDlg::MakeClNumber(PBYTE pData, UINT nBytes)
{
	CString strOut = L"";
	int i = 0;
	//nBytes = 14;
	//memcpy(pData, new byte[] { 0x30, 0x34, 0x34, 0x42, 0x35, 0x45, 0x35, 0x41, 0x33, 0x44, 0x34, 0x41, 0x38, 0x30 }, nBytes);
	if (m_iClView == 0) // Dec
	{
		ULONGLONG m_ullID = 0;
		for (int i = 0; i < nBytes; i++)
			m_ullID += (0x00000000000000FF & (ULONGLONG)pData[i]) << (i * 8);
		strOut.Format(L"%llu", m_ullID);
	}
	if (m_iClView == 1) // Hex
	{
		wchar_t HEX[256] = { 0 };
		for (UINT j = 0; j < nBytes; j++)
			wsprintf(HEX, L"%s%02X", HEX, pData[j]);
		strOut = HEX;
	}
	if (m_iClView == 2) // UTF8
	{
		wchar_t strChar[256] = { 0 };
		MultiByteToWideChar(CP_UTF8, 0, (char*)pData, nBytes, strChar, sizeof(strChar));
		//memcpy(strChar, pData, nBytes);
		//for (UINT j = 0; j < nBytes; j++)
		//	wsprintf(strChar, L"%c", strChar, (char)pData[j]);
		strOut = strChar;
	}

	if (m_iClByteOrder == 1) // Reverse pairs of symbols
		for (i = 0; i < strOut.GetLength(); i += 2)
		{
			std::wstring s(strOut.GetBuffer());
			std::swap(s[i], s[i + 1]);
			strOut = s.c_str();
		}

	if (m_iClOrder == 1) // Reverse symbols
		strOut.MakeReverse();

	for (i = 2; i < strOut.GetLength(); i += 2 + m_strClSeparator.GetLength())
		strOut.Insert(i, m_strClSeparator);

	strOut = m_strClPrefix + strOut;
	strOut += m_strClPostfix;

	return strOut;
}

CString CUemKbdEmulatorDlg::MakeCtNumber(PBYTE pData, UINT nBytes)
{
	CString strOut = L"";
	int i = 0;

	if (m_iCtView == 0) // Dec
	{
		ULONGLONG m_ullID = 0;
		for (int i = 0; i < nBytes; i++)
			m_ullID += (0x00000000000000FF & (ULONGLONG)pData[i]) << (i * 8);
		strOut.Format(L"%llu", m_ullID);
	}
	if (m_iCtView == 1) // Hex
	{
		wchar_t HEX[256] = { 0 };
		for (UINT j = 0; j < nBytes; j++)
			wsprintf(HEX, L"%s%02X", HEX, pData[j]);
		strOut = HEX;
	}
	if (m_iCtView == 2) // UTF8
	{
		wchar_t strChar[256] = { 0 };
		MultiByteToWideChar(CP_UTF8, 0, (char*)pData, nBytes, strChar, sizeof(strChar));
		strOut = strChar;
	}

	if (m_iCtByteOrder == 1) // Reverse pairs of symbols
		for (i = 0; i < strOut.GetLength(); i += 2)
		{
			std::wstring s(strOut.GetBuffer());
			std::swap(s[i], s[i + 1]);
			strOut = s.c_str();
		}

	if (m_iCtOrder == 1) // Reverse symbols
		strOut.MakeReverse();

	for (i = 2; i < strOut.GetLength(); i += 2 + m_strCtSeparator.GetLength())
		strOut.Insert(i, m_strCtSeparator);

	strOut = m_strCtPrefix + strOut;
	strOut += m_strCtPostfix;

	return strOut;
}

void CUemKbdEmulatorDlg::PostNumber(CString strCardNumber, int iKbhit, CString strVirtualKeyCode)
{
	//LoadKeyboardLayout(L"00000419", KLF_ACTIVATE); //RU
	WCHAR strPrevLayoutName[256] = { 0 };
	GetKeyboardLayoutName(strPrevLayoutName);
	//LoadKeyboardLayout(L"04090409", KLF_ACTIVATE); //EN

	//::SendMessage(::GetActiveWindow(), WM_INPUTLANGCHANGEREQUEST, 0, 0x00000409);
	//HWND HWND_BROADCAST = (HWND)0x0000FFFF;
	HKL hKBLang = LoadKeyboardLayout(L"00000409", KLF_ACTIVATE);
	ActivateKeyboardLayout(hKBLang, 0x00000000);
	::SendMessage(HWND_BROADCAST, WM_INPUTLANGCHANGEREQUEST, INPUTLANGCHANGE_SYSCHARSET, (LPARAM)hKBLang);
	//GetForegroundWindow

	INPUT inp;

	inp.type = INPUT_KEYBOARD;
	inp.ki.wScan = 0;
	inp.ki.time = 0;
	inp.ki.dwExtraInfo = NULL;

	for (int i = 0; i < strCardNumber.GetLength(); i++)
	{
		WORD wKey = VkKeyScan(strCardNumber[i]);
		inp.ki.dwFlags = 0;
		if ((wKey & 0xFF00) == 0x0100)
		{
			inp.ki.wVk = 0x10; //SHIFT
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0200)
		{
			inp.ki.wVk = 0x11; //CTRL
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0400)
		{
			inp.ki.wVk = 0x12; //ALT
			SendInput(1, &inp, sizeof(inp));
		}
		inp.ki.wVk = wKey & 0xFF;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		if ((wKey & 0xFF00) == 0x0400)
		{
			inp.ki.wVk = 0x12; //ALT
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0200)
		{
			inp.ki.wVk = 0x11; //CTRL
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0100)
		{
			inp.ki.wVk = 0x10; //SHIFT
			SendInput(1, &inp, sizeof(inp));
		}
	}

	switch (iKbhit)
	{
	case 1:
		inp.ki.dwFlags = 0;
		inp.ki.wVk = VK_SPACE;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 2:
		inp.ki.wVk = VK_TAB;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));	
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 3:
		inp.ki.wVk = VK_RETURN;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 4:
		inp.ki.wVk = VK_LEFT;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 5:
		inp.ki.wVk = VK_UP;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 6:
		inp.ki.wVk = VK_RIGHT;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 7:
		inp.ki.wVk = VK_DOWN;
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		break;
	case 8:
	{
		inp.ki.dwFlags = 0;
		WORD wKey = VkKeyScan(ReadHEX(strVirtualKeyCode));
		if ((wKey & 0xFF00) == 0x0100)
		{
			inp.ki.wVk = 0x10; //SHIFT
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0200)
		{
			inp.ki.wVk = 0x11; //CTRL
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0400)
		{
			inp.ki.wVk = 0x12; //ALT
			SendInput(1, &inp, sizeof(inp));
		}
		inp.ki.wVk = wKey & 0xFF;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
		if ((wKey & 0xFF00) == 0x0400)
		{
			inp.ki.wVk = 0x12; //ALT
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0200)
		{
			inp.ki.wVk = 0x11; //CTRL
			SendInput(1, &inp, sizeof(inp));
		}
		if ((wKey & 0xFF00) == 0x0100)
		{
			inp.ki.wVk = 0x10; //SHIFT
			SendInput(1, &inp, sizeof(inp));
		}
		break;
	}
	default:
		;
	}

	//LoadKeyboardLayout(strPrevLayoutName, KLF_ACTIVATE);
	hKBLang = LoadKeyboardLayout(strPrevLayoutName, KLF_ACTIVATE);
	ActivateKeyboardLayout(hKBLang, 0x00000000);
	::SendMessage(HWND_BROADCAST, WM_INPUTLANGCHANGEREQUEST, INPUTLANGCHANGE_SYSCHARSET, (LPARAM)hKBLang);
	//::SendMessage(HWND_BROADCAST, WM_INPUTLANGCHANGEREQUEST, INPUTLANGCHANGE_BACKWARD, (LPARAM)hKBLang);

	return;
}

void CUemKbdEmulatorDlg::PostBackspaces(int iCount)
{
	INPUT inp;

	inp.type = INPUT_KEYBOARD;
	inp.ki.wScan = 0;
	inp.ki.time = 0;
	inp.ki.dwExtraInfo = NULL;
	inp.ki.wVk = VK_BACK;
	for (int i = 0; i < iCount; i++)
	{
		inp.ki.dwFlags = 0;
		SendInput(1, &inp, sizeof(inp));
		inp.ki.dwFlags = KEYEVENTF_KEYUP;
		SendInput(1, &inp, sizeof(inp));
	}
}

void CUemKbdEmulatorDlg::ReaderScan()
{
	LONG Status;

	LPVOID pReader = NULL;

	//UpdateData();

	Status = CLSCRF_Create(&pReader);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "  !";
		//UpdateData(FALSE);
		return;
	}

	Status = CLSCRF_OpenUSB(pReader);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "  !";
		//UpdateData(FALSE);
		CLSCRF_Destroy(&pReader);
		return;
	}

	DWORD dwState = 0;

	Status = CLSCRF_GetState(pReader, &dwState);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "   !";
		//UpdateData(FALSE);
		CLSCRF_Close(pReader);
		CLSCRF_Destroy(&pReader);
		return;
	}

	if (dwState == 0x00000000)
	{
		Status = CLSCRF_Mfrc_On(pReader);
		if (Status != SCARD_S_SUCCESS)
		{
			m_strResult = "   !";
			//UpdateData(FALSE);
			CLSCRF_Close(pReader);
			CLSCRF_Destroy(&pReader);
			return;
		}

		Sleep(10);
	}

	Status = CLSCRF_Mfrc_Rf_Off_On(pReader, 100);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "   !";
		//UpdateData(FALSE);
		CLSCRF_Close(pReader);
		CLSCRF_Destroy(&pReader);
		return;
	}

	Sleep(10);

	memset(m_CardID, 0x00, sizeof(m_CardID));
	m_ucCardIDLength = 0;
	memset(m_CtCardID, 0x00, sizeof(m_CtCardID));
	m_ucCtCardIDLength = 0;

	if (m_fClISO14443A == TRUE)
	{
		Status = CLSCRF_Mfrc_Set_Rf_Mode(pReader, 0x00);
		if (Status != SCARD_S_SUCCESS)
		{
			m_strResult = "   !";
			//UpdateData(FALSE);
			CLSCRF_Close(pReader);
			CLSCRF_Destroy(&pReader);
			return;
		}

		BYTE ATQ[2] = { 0x00 };
		BYTE SAK = 0x00;
		BYTE UID[10];
		DWORD dwUIDLen = 10;

		Status = CLSCRF_Activate_Idle_A(pReader,
			ATQ,// pbATQ 2 bytes
			&SAK,// pbSAK 1 byte
			UID,// pbUID max 10 bytes
			&dwUIDLen);
		if (Status == SCARD_S_SUCCESS)
		{
			//if (m_fCardLost)
			{
				m_ucCardIDLength = dwUIDLen;
				memcpy(m_CardID, &UID, m_ucCardIDLength);
			}
			//m_fCardLost = false;
			if (m_fClUseAPDU)
			{
				BYTE  ATS[BUF_SIZE] = { 0 };

				Status = CLSCRF_ISO14443A_4_Activate(pReader, 0, 0x00, ATS);

				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "      T=CL!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}

				BYTE  SendBuffer[BUF_SIZE];
				BYTE  RecvBuffer[BUF_SIZE];
				DWORD SendLength;
				DWORD RecvLength;
				int   Size;

				Size = m_strClAPDU.GetLength();
				if ((StrHexInvalid(m_strClAPDU.GetBuffer(), SendBuffer, Size)) >= 0)
				{
					m_strClAPDU.ReleaseBuffer();
					m_strResult = "   APDU!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
				m_strClAPDU.ReleaseBuffer();

				RecvLength = BUF_SIZE;
				Status = CLSCRF_ISO14443_4_Exchange(pReader,
					0x0000,
					SendBuffer,
					Size,
					RecvBuffer,     // Type A    00A4040007F00000000A0101
					&RecvLength);   // Type B    00A4040C07A0000002471001

				if ((Status != SCARD_S_SUCCESS) || (RecvLength < 2) || (RecvBuffer[RecvLength - 2] != 0x90) || (RecvBuffer[RecvLength - 1] != 0x00))
				{
					m_strResult = "   APDU!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}

				m_ucCardIDLength = RecvLength - 2;
				memcpy(m_CardID, &RecvBuffer, m_ucCardIDLength);


			}
		}
		else
		{
			//m_fCardLost = true;
			m_strResult = "   !";
			//UpdateData(FALSE);
			//CLSCRF_Close(pReader);
			//CLSCRF_Destroy(&pReader);
			//return;
		}
	}

	if ((m_ucCardIDLength == 0) && (m_fClISO14443B == TRUE))
	{
		Status = CLSCRF_Mfrc_Set_Rf_Mode(pReader, 0x10);
		if (Status != SCARD_S_SUCCESS)
		{
			m_strResult = "   !";
			//UpdateData(FALSE);
			CLSCRF_Close(pReader);
			CLSCRF_Destroy(&pReader);
			return;
		}

		const int MAX_CARDS_B = 1;
		DWORD PUPI[MAX_CARDS_B];
		DWORD AppData[MAX_CARDS_B];
		DWORD ProtInfo[MAX_CARDS_B];
		DWORD CardCount = MAX_CARDS_B;

		Status = CLSCRF_Activate_Idle_B(pReader, 0, 2,
			PUPI, AppData, ProtInfo, &CardCount);
		if (Status == SCARD_S_SUCCESS)
		{
			//if (m_fCardLost)
			{
				m_ucCardIDLength = 4;
				memcpy(m_CardID, &PUPI, m_ucCardIDLength);
			}

			//m_fCardLost = false;

			if (m_fClUseAPDU)
			{
				Sleep(10);

				BYTE  RecvBuffer[BUF_SIZE];
				DWORD RecvLength;
				BYTE  Mbli;
				DWORD pdwAppData[16];
				DWORD pdwProtInfo[16];

				RecvLength = 0;
				Status = CLSCRF_Attrib_B(pReader,
					(BYTE*)PUPI,
					0x00,       //IN     BYTE    bParam1,
					0x05,       //IN     BYTE    bParam2,
					0x01,       //IN     BYTE    bParam3,
					0x00,       //IN     BYTE    bParam4,
					RecvBuffer, //IN OUT LPBYTE  pbHigherLayerBuf,
					BUF_SIZE,   //IN     DWORD   dwHLBufSize,
					&RecvLength,//IN OUT LPDWORD pdwHLInfLength,
					&Mbli);     //OUT LPBYTE  pbMbliCid);


				BYTE e;
				CLSCRF_GetLastInternalError(pReader, &e);
				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "      T=CL!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}

				BYTE  SendBuffer[BUF_SIZE];
				DWORD SendLength;
				int   Size;

				Size = m_strClAPDU.GetLength();
				if ((StrHexInvalid(m_strClAPDU.GetBuffer(), SendBuffer, Size)) >= 0)
				{
					m_strClAPDU.ReleaseBuffer();
					m_strResult = "   APDU!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
				m_strClAPDU.ReleaseBuffer();

				RecvLength = BUF_SIZE;
				Status = CLSCRF_ISO14443_4_Exchange(pReader,
					0x0000,
					SendBuffer,
					Size,
					RecvBuffer,     // Type A    00A4040007F00000000A0101
					&RecvLength);   // Type B    00A4040C07A0000002471001

				if ((Status != SCARD_S_SUCCESS) || (RecvLength < 2) || (RecvBuffer[RecvLength - 2] != 0x90) || (RecvBuffer[RecvLength - 1] != 0x00))
				{
					m_strResult = "   APDU!";
					m_ucCtCardIDLength = 0;
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}

				m_ucCardIDLength = RecvLength - 2;
				memcpy(m_CardID, &RecvBuffer, m_ucCardIDLength);
			}
		}
		else
		{
			//m_fCardLost = true;
			m_strResult = "   !";
			//UpdateData(FALSE);
			//CLSCRF_Close(pReader);
			//CLSCRF_Destroy(&pReader);
			//return;
		}
	}

	if ((m_ucCardIDLength == 0) && (m_fClISO15693 == TRUE))
	{
		Status = CLSCRF_Mfrc_Set_Rf_Mode(pReader, 0x40);
		if (Status != SCARD_S_SUCCESS)
		{
			m_strResult = "   !";
			//UpdateData(FALSE);
			CLSCRF_Close(pReader);
			CLSCRF_Destroy(&pReader);
			return;
		}

		BYTE RecvBuffer[BUF_SIZE];
		DWORD RecvLength = BUF_SIZE;

		Status = CLSCRF_Inventory_15693(pReader,
			0x26,
			0x01,  //Inventory, 
			0,//AFI, 
			0,//MaskLen, 
			NULL,//*MaskVal, 
			RecvBuffer,   // LPBYTE  pbRecvBuffer, 
			&RecvLength);// LPDWORD pdwRecvLength );
		if (Status == SCARD_S_SUCCESS)
		{
			if (RecvLength > 2)
			{
				if (RecvBuffer[1])
				{
					//if (m_fCardLost)
					{
						m_ucCardIDLength = 8;
						memcpy(m_CardID, &RecvBuffer[4], m_ucCardIDLength);
					}
				}
			}
			//m_fCardLost = false;
		}
		else
		{
			//m_fCardLost = true;
			m_strResult = "   !";
			//UpdateData(FALSE);
			//CLSCRF_Close(pReader);
			//CLSCRF_Destroy(&pReader);
			//return;
		}
	}







	if (m_fCtCheckEnabled == TRUE)
	{
		BYTE ucNumSAM;
		Status = CLSCRF_SAM_GetCurrentHolder(pReader, &ucNumSAM);
		if (Status == SCARD_S_SUCCESS)
		{
			SAM_VERSION Version = { 0 };
			BYTE ucSW1, ucSW2;
			Status = CLSCRF_SAM_GetVersion(
				pReader,
				0,
				&Version,
				&ucSW1,
				&ucSW2);
			if (Status == SCARD_S_SUCCESS)
			{
				m_ucCtCardIDLength = 7;
				memcpy(m_CtCardID, Version.ManufacturerData.UID, m_ucCtCardIDLength);

				if (m_fCtUseAPDU)
				{
					BYTE  SendBuffer[BUF_SIZE];
					BYTE  RecvBuffer[BUF_SIZE];
					DWORD SendLength;
					DWORD RecvLength;
					int   Size;

					Size = m_strCtAPDU.GetLength();
					if ((StrHexInvalid(m_strCtAPDU.GetBuffer(), SendBuffer, Size)) >= 0)
					{
						m_strCtAPDU.ReleaseBuffer();
						m_strResult = "   APDU!";
						m_ucCtCardIDLength = 0;
						CLSCRF_Close(pReader);
						CLSCRF_Destroy(&pReader);
						return;
					}
					m_strCtAPDU.ReleaseBuffer();

					RecvLength = BUF_SIZE;
					Status = CLSCRF_SAM_APDU(pReader,
						SendBuffer,
						SendLength,
						RecvBuffer,
						&RecvLength);

					if ((Status != SCARD_S_SUCCESS) || (RecvLength < 2) || (RecvBuffer[RecvLength - 2] != 0x90) || (RecvBuffer[RecvLength - 1] != 0x00))
					{
						m_strResult = "   APDU!";
						m_ucCtCardIDLength = 0;
						CLSCRF_Close(pReader);
						CLSCRF_Destroy(&pReader);
						return;
					}

					m_ucCardIDLength = RecvLength - 2;
					memcpy(m_CardID, &RecvBuffer, m_ucCardIDLength);
				}
			}
			else
			{
				m_strResult = "   !";
				//UpdateData(FALSE);
				//CLSCRF_Close(pReader);
				//CLSCRF_Destroy(&pReader);
				//return;
			}
		}
		else
		{
			m_strResult = "   !";
			//UpdateData(FALSE);
			//CLSCRF_Close(pReader);
			//CLSCRF_Destroy(&pReader);
			//return;
		}
	}






	if (m_ucCardIDLength > 0)
	{
		if (m_fCardLost)
		{
			CString strCardID = MakeClNumber(m_CardID, m_ucCardIDLength);
			m_fNewCard = (m_strCardID != strCardID);
			m_strCardID = strCardID;
			if (m_fBackspace == TRUE)
				PostBackspaces(m_iLastPostLength);
			m_iLastPostLength = m_strCardID.GetLength();
			PostNumber(m_strCardID, m_iClKbhit, m_strClVirtualKeyCode);

			if (m_fClLed == TRUE)
			{
				Status = Status = CLSCRF_Led(pReader, 2, 0, 2);
				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "   !";
					//UpdateData(FALSE);
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
			}

			if (m_fClBeep == TRUE)
			{
				Status = CLSCRF_Sound(pReader, 1);
				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "   !";
					//UpdateData(FALSE);
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
			}
		}
		m_fCardLost = false;
	}
	else
	{
		if (m_fClLed == TRUE)
		{
			Status = Status = CLSCRF_Led(pReader, 0, 1, 1);
			if (Status != SCARD_S_SUCCESS)
			{
				m_strResult = "   !";
				//UpdateData(FALSE);
				CLSCRF_Close(pReader);
				CLSCRF_Destroy(&pReader);
				return;
			}
		}
		m_fCardLost = true;
	}





	if (m_ucCtCardIDLength > 0)
	{
		if (m_fCtCardLost)
		{
			CString strCardID = MakeCtNumber(m_CtCardID, m_ucCtCardIDLength);
			m_fCtNewCard = (m_strCtCardID != strCardID);
			m_strCtCardID = strCardID;
			if (m_fBackspace == TRUE)
				PostBackspaces(m_iLastPostLength);
			m_iLastPostLength = m_strCtCardID.GetLength();
			PostNumber(m_strCtCardID, m_iCtKbhit, m_strCtVirtualKeyCode);

			if (m_fCtLed == TRUE)
			{
				Status = Status = CLSCRF_Led(pReader, 2, 0, 2);
				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "   !";
					//UpdateData(FALSE);
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
			}

			if (m_fCtBeep == TRUE)
			{
				Status = CLSCRF_Sound(pReader, 1);
				if (Status != SCARD_S_SUCCESS)
				{
					m_strResult = "   !";
					//UpdateData(FALSE);
					CLSCRF_Close(pReader);
					CLSCRF_Destroy(&pReader);
					return;
				}
			}
		}
		m_fCtCardLost = false;
	}
	else
	{
		/*if (m_fCtLed == TRUE)
		{
			Status = Status = CLSCRF_Led(pReader, 0, 1, 1);
			if (Status != SCARD_S_SUCCESS)
			{
				m_strResult = "   !";
				//UpdateData(FALSE);
				CLSCRF_Close(pReader);
				CLSCRF_Destroy(&pReader);
				return;
			}
		}*/
		m_fCtCardLost = true;
	}




	Status = CLSCRF_Close(pReader);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "  !";
		//UpdateData(FALSE);
		CLSCRF_Destroy(&pReader);
		return;
	}

	Status = CLSCRF_Destroy(&pReader);
	if (Status != SCARD_S_SUCCESS)
	{
		m_strResult = "  !";
		//UpdateData(FALSE);
		return;
	}

	if (m_fNewCard || (m_strResult != "  !"))
		m_strResult = "  !";

	//UpdateData(FALSE);

}
