﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Threading;
//using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace MifarePlusCS
{
    /// <summary>
    /// Класс обертка над библиотекой
    /// </summary>
    public class Clscrfl_SAM
    {
#if WindowsCE
        private const string ClscrflDll = "Clscrfl_CE.dll";
#else
        private const string ClscrflDll = "Clscrfl_SAM.dll";
#endif

        public const byte CLSCRF_UID_LENGTH_ISO14443_B = 4;
        public const byte CLSCRF_UID_LENGTH_ISO15693 = 8;

        public const byte CLSCRF_ICC_TYPE_ISO14443A = 0x01;
        public const byte CLSCRF_ICC_TYPE_ISO14443B = 0x02;
        public const byte CLSCRF_ICC_TYPE_ISO15693 = 0x04;
        public const byte CLSCRF_ICC_TYPE_ICODE_1 = 0x08;
        public const byte CLSCRF_ICC_TYPE_ISO18000 = 0x20;
        public const byte CLSCRF_ICC_TYPE_RFU = 0x80;

        public const byte CLSCRF_DF_AUTH_TYPE_DES = 0x00;
        public const byte CLSCRF_DF_AUTH_TYPE_3DES = 0x01;
        public const byte CLSCRF_DF_AUTH_TYPE_3K3DES = 0x02;
        public const byte CLSCRF_DF_AUTH_TYPE_AES = 0x03;

        public const byte CLSCRF_DF_CRYPTO_METHOD_DES_OR_3DES = 0x00;
        public const byte CLSCRF_DF_CRYPTO_METHOD_3K3DES = 0x01;
        public const byte CLSCRF_DF_CRYPTO_METHOD_AES = 0x02;

        public const byte CLSCRF_DF_TRANSFER_TYPE_PLAIN = 0x00;
        public const byte CLSCRF_DF_TRANSFER_TYPE_MACCED = 0x01;
        public const byte CLSCRF_DF_TRANSFER_TYPE_ENCRYPTED = 0x03;

        public const byte CLSCRF_DF_COMMUNICATION_SETTINGS_PLAIN = 0x00;
        public const byte CLSCRF_DF_COMMUNICATION_SETTINGS_MACCED = 0x01;
        public const byte CLSCRF_DF_COMMUNICATION_SETTINGS_ENCRYPTED = 0x03;

        public const byte CLSCRF_DF_FILE_TYPE_DATA_STANDARD = 0x00;
        public const byte CLSCRF_DF_FILE_TYPE_DATA_BACKUP = 0x01;
        public const byte CLSCRF_DF_FILE_TYPE_VALUE_WITH_BACKUP = 0x02;
        public const byte CLSCRF_DF_FILE_TYPE_LINEAR_RECORD_WITH_BACKUP = 0x03;
        public const byte CLSCRF_DF_FILE_TYPE_CYCLIC_RECORD_WITH_BACKUP = 0x04;

        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_MASTER_KEY = 0x00;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_1 = 0x01;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_2 = 0x02;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_3 = 0x03;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_4 = 0x04;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_5 = 0x05;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_6 = 0x06;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_7 = 0x07;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_8 = 0x08;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_9 = 0x09;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_10 = 0x0A;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_11 = 0x0B;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_12 = 0x0C;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_APPLICATION_KEY_13 = 0x0D;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_REQUIRED_AUTHENTICATION_WITH_SAME_APPLICATION_KEY = 0x0E;
        public const byte CLSCRF_DF_CHANGE_KEY_ACCESS_RIGHT_ALL_APPLICATION_KEYS_BUT_MASTER_KEY_ARE_FROZEN = 0x0F;

        public const byte CLSCRF_DF_CHANGE_KEY_KEY_TYPE_DES_OR_3DES = 0x00;
        public const byte CLSCRF_DF_CHANGE_KEY_KEY_TYPE_3K3DES = 0x01;
        public const byte CLSCRF_DF_CHANGE_KEY_KEY_TYPE_AES = 0x02;


        //* Значения DRI/DSI (BRI/BSI)


        public const byte CLSCRF_PHPAL_I18092MPI_DATARATE_106 = 0x00;   /**< Значение DRI/DSI для 106 kBit/s. */
        public const byte CLSCRF_PHPAL_I18092MPI_DATARATE_212 = 0x01;   /**< Значение DRI/DSI для 212 kBit/s. */
        public const byte CLSCRF_PHPAL_I18092MPI_DATARATE_424 = 0x02;   /**< Значение DRI/DSI для 424 kBit/s. */



        //* Значения FSL/LRI


        public const byte CLSCRF_PHPAL_I18092MPI_FRAMESIZE_64 = 0x00;   /**< Значение FSL для макс. размера кадра в 64 байта.  */
        public const byte CLSCRF_PHPAL_I18092MPI_FRAMESIZE_128 = 0x01;   /**< Значение FSL для макс. размера кадра в 128 байт. */
        public const byte CLSCRF_PHPAL_I18092MPI_FRAMESIZE_192 = 0x02;   /**< Значение FSL для макс. размера кадра в 192 байта. */
        public const byte CLSCRF_PHPAL_I18092MPI_FRAMESIZE_254 = 0x03;   /**< Значение FSL для макс. размера кадра в 254 байта. */



        //* Значения параметра bDeselectCommand


        public const byte CLSCRF_PHPAL_I18092MPI_DESELECT_DSL = 0x08;   /**< DSL отправляется для отмена выбора цели. */
        public const byte CLSCRF_PHPAL_I18092MPI_DESELECT_RLS = 0x0A;   /**< RLS отправляется для отмены выбора цели. */


        // Опции команды Exchange


        //Режим обмена по умолчанию.
        //Для выполнения буферизации комбинируйте 
        //с PH_EXCHANGE_BUFFERED_BIT и PH_EXCHANGE_LEAVE_BUFFER_BIT
        //Специфично для ISO14443-4:
        //Выполняет цепочную передачу Tx/Rx с картой.
        //Возвращает PH_ERR_SUCCESS_CHAINING, если RxBuffer полон и не отправляет 
        //подтверждение (ACK) для последнего принятого блока.

        public const ushort CLSCRF_PH_EXCHANGE_DEFAULT = 0x0000;


        //Специфично для ISO14443-4:
        //Передает данные в карту цепочной передачей.
        //Кобинируется с PH_EXCHANGE_BUFFERED_BIT и PH_EXCHANGE_LEAVE_BUFFER_BIT 
        //для выполнения буферизации.
        //Не принимает никаких данных.

        public const ushort CLSCRF_PH_EXCHANGE_TXCHAINING = 0x0001;


        //Специфично для ISO14443-4:
        //Начинает передачу с блоком R(ACK) и выполняет цепочную передачу Rx с картой.
        //Возвращает PH_ERR_SUCCESS_CHAINING, если RxBuffer полон и не подтверждает (ACK)
        //последний принятый блок.

        public const ushort CLSCRF_PH_EXCHANGE_RXCHAINING = 0x0002;


        //Специфично для ISO14443-4:
        //Начинает передачу с блоком R(ACK) и выполняет цепочную передачу Rx с картой.
        //Завершает цепочную передачу Rx с картой, если RxBuffer полон.

        public const ushort CLSCRF_PH_EXCHANGE_RXCHAINING_BUFSIZE = 0x0003;

        // Маска для режимов выше. Все остальные биты зарезервированы. */
        public const ushort CLSCRF_PH_EXCHANGE_MODE_MASK = 0x000F;


        //Не производит очистки внутреннего буфера перед выполнением операции.
        //Если этот бит установлен и данные переданы,
        //то содержимое внутреннего буфера отправляются в первую очередь.

        public const ushort CLSCRF_PH_EXCHANGE_LEAVE_BUFFER_BIT = 0x4000;


        //Буферизует Tx-Data во внутренний буфер вместо его передачи.

        public const ushort CLSCRF_PH_EXCHANGE_BUFFERED_BIT = 0x8000;


        //Введенные данные являются первой частью потока.
        //(Определение помощника для буферизации).
        
        public const ushort CLSCRF_PH_EXCHANGE_BUFFER_FIRST = (CLSCRF_PH_EXCHANGE_DEFAULT | CLSCRF_PH_EXCHANGE_BUFFERED_BIT);


        //Введенные данные являются следующей частью потока.
        //(Определение помощника для буферизации).

        public const ushort CLSCRF_PH_EXCHANGE_BUFFER_CONT = (CLSCRF_PH_EXCHANGE_DEFAULT | CLSCRF_PH_EXCHANGE_BUFFERED_BIT | CLSCRF_PH_EXCHANGE_LEAVE_BUFFER_BIT);


        //Введенные данные являются последней частью потока.
        //(Определение помощника для буферизации).

        public const ushort CLSCRF_PH_EXCHANGE_BUFFER_LAST = (CLSCRF_PH_EXCHANGE_DEFAULT | CLSCRF_PH_EXCHANGE_LEAVE_BUFFER_BIT);
        public const ushort CLSCRF_PH_EXCHANGE_TX_CRC = 0x0010;
        public const ushort CLSCRF_PH_EXCHANGE_RX_CRC = 0x0020;
        public const ushort CLSCRF_PH_EXCHANGE_PARITY = 0x0040;



        //* Параметры режима пассивного инициатора ISO18092 ucParameterNumber


        //* Задать / получить номер пакета

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_PACKETNO = 0x0000;

        //* Задать / получить идентификатор устройства

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_DID = 0x0001;

        //* Задать / получить адрес узла

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_NAD = 0x0002;

        //* Задать / получить время ожидания

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_WT = 0x0003;

        //* Задать / получить длину кадра

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_FSL = 0x0004;

        //* Задать / получить максимальное количество повторных попыток

        public const ushort CLSCRF_PHPAL_I18092MPI_CONFIG_MAXRETRYCOUNT = 0x0005;

        public const byte CLSCRF_PHPAL_I18092MPI_NFCID3_LENGTH = 0x0A; /**< Размер NFCID3. */

        /*
        [global::System.AttributeUsage(AttributeTargets.Field, AllowMultiple = false)]
        sealed class BitfieldLengthAttribute : Attribute
        {
            uint length;

            public BitfieldLengthAttribute(uint length)
            {
                this.length = length;
            }

            public uint Length { get { return length; } }
        }

        static class PrimitiveConversion
        {
            public static long ToLong<T>(T t) where T : struct
            {
                long r = 0;
                int offset = 0;

                // For every field suitably attributed with a BitfieldLength
                foreach (System.Reflection.FieldInfo f in t.GetType().GetFields())
                {
                    object[] attrs = f.GetCustomAttributes(typeof(BitfieldLengthAttribute), false);
                    if (attrs.Length == 1)
                    {
                        uint fieldLength  = ((BitfieldLengthAttribute)attrs[0]).Length;

                        // Calculate a bitmask of the desired length
                        long mask = 0;
                        for (int i = 0; i < fieldLength; i++)
                            mask |= 1 << i;

                        r |= ((UInt32)f.GetValue(t) & mask) << offset;

                        offset += (int)fieldLength;
                    }
                }

                return r;
            }
        }
        

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_CARD
        {
            //[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]
            //public string ip;
            [MarshalAs(UnmanagedType.U4)]
            public uint Timeout;  // etu = 128/fc = 9,4 us
            [MarshalAs(UnmanagedType.U4)]
            public uint CardType;
            [MarshalAs(UnmanagedType.I4)]
            public int UID_Len;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
            public static byte[] UID = new byte[32];
            [MarshalAs(UnmanagedType.Struct)]
            public struct ATQ
            {
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
                public struct ISO14443A
                {    // 14443-A 
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
                    public static byte[] ATQA = new byte[2];
                    [MarshalAs(UnmanagedType.U1)]
                    public byte SAK;
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 37)]
                    public static byte[] ATS = new byte[37];    // if 14443-4 only
                }
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
                public struct ISO14443B 
                {    // 14443-B
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
                    public static byte[] AppData = new byte[4];
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
                    public static byte[] ProtInf = new byte[4];
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 33)]
                    public static byte[] Attrib = new byte[33];
                }
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
                public struct ISO15693
                {    // 15693
                    [MarshalAs(UnmanagedType.U1)]
                    public byte DSFID;
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 39)]
                    public static byte[] SLI_Data = new byte[39]; // not used
                }
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
                public struct ICODE
                {    // ICODE EPC
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
                    public static byte[] CRC16 = new byte[2];
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 38)]
                    public static byte[] EPC_Data = new byte[38]; // not used
                }
            }
            [MarshalAs(UnmanagedType.U1)]
            public byte CID;
            [MarshalAs(UnmanagedType.U1)]
            public byte Active;
            [MarshalAs(UnmanagedType.U1)]
            public byte RfMode;
            [MarshalAs(UnmanagedType.U1)]
            public byte BlockNumberBit;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_HW_SW_INFO
        {
            [MarshalAs(UnmanagedType.U1)]
            public byte ucVendorID;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucType;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucSubType;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucMajorVer;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucMinorVer;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucStorageSize;
            [MarshalAs(UnmanagedType.U1)]
            public byte ucProtocol;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_MORE_INFO
        {
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 7)]
            public static byte[] pUID = new byte[7];
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
            public static byte[] pBatchNumber = new byte[5];
            [MarshalAs(UnmanagedType.U1)]
	        public byte ucCwProd;
            [MarshalAs(UnmanagedType.U1)]
	        public byte ucYearProd;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS
        {
            [BitfieldLength(4)]
	        public byte ChangeAccessRights;
            [BitfieldLength(4)]
	        public byte ReadAndWriteAccess;
            [BitfieldLength(4)]
	        public byte WriteAccess;
            [BitfieldLength(4)]
	        public byte ReadAccess;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_FILE_SETTINGS
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
	        public byte ucFileType;
            [FieldOffset(1), MarshalAs(UnmanagedType.U1)]
	        public byte ucCommSettings;
            [FieldOffset(2), MarshalAs(UnmanagedType.Struct)]
	        public CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS AccessRights;
            // union
                [FieldOffset(18), MarshalAs(UnmanagedType.Struct)]
		        public struct DataFile
		        {
                    [BitfieldLength(24)]
			        public uint dwFileSize;
		        }
                [FieldOffset(18), MarshalAs(UnmanagedType.Struct)]
		        public struct ValueFile
		        {
                    [MarshalAs(UnmanagedType.U4)]
			        public uint dwLowerLimit;
                    [MarshalAs(UnmanagedType.U4)]
			        public uint dwUpperLimit;
                    [MarshalAs(UnmanagedType.U4)]
			        public uint dwLimitedCreditValue;
                    [MarshalAs(UnmanagedType.U1)]
			        public byte ucLimitedCreditEnabled;
		        }
                [FieldOffset(18), MarshalAs(UnmanagedType.Struct), StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
		        public struct RecordFile
		        {
			        //struct
                        [FieldOffset(0), BitfieldLength(24)]
				        public uint dwRecordSize;
			        //struct
                        //[FieldOffset(0)]
				        //public byte[] Padding1 = new byte[3];
                        [FieldOffset(3), BitfieldLength(24)]
				        public uint dwMaxNumberOfRecords;
			        //struct
                        //[FieldOffset(0)]
				        //public byte[] Padding2 = new byte[6];
                        [FieldOffset(6), BitfieldLength(24)]
				        public uint dwCurrentNumberOfRecords;
		        }
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_CONFIGURATION
        {
            [FieldOffset(0)]
	        public byte ucOption;
	        //union
		        //union
                    [FieldOffset(1), MarshalAs(UnmanagedType.U1)]
			        public byte ucConfigurationByte;
                    [FieldOffset(1), MarshalAs(UnmanagedType.Struct)]
			        public struct ConfigurationByte
                    {
                        [BitfieldLength(1)]
				        public byte fFormatCardDisabled;
                        [BitfieldLength(1)]
				        public byte fRandomIDEnabled;
                        [BitfieldLength(6)]
				        public byte RFU;
                    }
		        //struct
                    [FieldOffset(1), MarshalAs(UnmanagedType.ByValArray, SizeConst = 24)]
                    public static byte[] Key = new byte[24];
                    [FieldOffset(24), MarshalAs(UnmanagedType.U1)]
			        public byte KeyVersion;
		        //struct
                    [FieldOffset(1), MarshalAs(UnmanagedType.ByValArray, SizeConst = 32)]
                    public static byte[] ATS = new byte[32];
                    [FieldOffset(32), MarshalAs(UnmanagedType.U1)]
			        public byte ATSSize;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_DFNAME
        {
            [FieldOffset(0), BitfieldLength(24)]
	        public uint AID;
	        //struct
                [FieldOffset(0), MarshalAs(UnmanagedType.ByValArray, SizeConst = 3)]
                public static byte[] Padding = new byte[3];
                [FieldOffset(3), MarshalAs(UnmanagedType.U4)]
		        public uint FID;
                [FieldOffset(7), MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
                public static byte[] DFName = new byte[16];
                [FieldOffset(23), MarshalAs(UnmanagedType.U1)]
		        public byte DFNameSize;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_LIMITED_CREDIT_ENABLED
        {
            [BitfieldLength(1)]
	        public byte fEnableLimitedCredit;
            [BitfieldLength(1)]
	        public byte fEnableFreeGetValue;
            [BitfieldLength(6)]
	        public byte RFU;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_PICC_MASTER_KEY_SETTINGS
        {
            [BitfieldLength(1)]
	        public byte fAllowChangingPiccMasterKey;
            [BitfieldLength(1)]
	        public byte fFreeDirectoryListAccessWithoutPiccMasterKey;
            [BitfieldLength(1)]
	        public byte fCreateAndDeleteWithoutPiccMasterKey;
            [BitfieldLength(1)]
	        public byte fConfigurationChangeable;
            [BitfieldLength(4)]
	        public byte RFU;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_APPLICATION_MASTER_KEY_SETTINGS
        {
            [BitfieldLength(1)]
	        public byte fAllowChangingApplicationMasterKey;
            [BitfieldLength(1)]
	        public byte fFreeDirectoryListAccessWithoutApplicationMasterKey;
            [BitfieldLength(1)]
	        public byte fCreateAndDeleteWithoutApplicationMasterKey;
            [BitfieldLength(1)]
	        public byte fConfigurationChangeable;
            [BitfieldLength(4)]
	        public byte ChangeKeyAccessRights;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_NEW_APPLICATION_KEY_SETTINGS
        {
            [BitfieldLength(4)]
	        public byte MaxNumberOfKeys;
            [BitfieldLength(1)]
	        public byte RFU;
            [BitfieldLength(1)]
	        public byte Supported2ByteFileIDs;
            [BitfieldLength(2)]
	        public byte CryptoMethod;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_MASTER_KEY_SETTINGS
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        CLSCRF_DESFIRE_PICC_MASTER_KEY_SETTINGS PiccMasterKeySettings;
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        CLSCRF_DESFIRE_APPLICATION_MASTER_KEY_SETTINGS ApplicationMasterKeySettings;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_KEY_DATA
        {
            [MarshalAs(UnmanagedType.Struct), StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
	        public struct KeyNumber
	        {
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
		        public struct PiccMasterKey
		        {
                    [BitfieldLength(6)]
			        public byte SetToZero;
                    [BitfieldLength(2)]
			        public byte KeyType;
		        }
                [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
		        public byte ApplicationKeyNumber;
	        }
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 24)]
            public static byte[] Key = new byte[24];
            [MarshalAs(UnmanagedType.U1)]
	        public byte ucKeySize;
            [MarshalAs(UnmanagedType.U1)]
	        public byte ucAESKeyVersion;
            [MarshalAs(UnmanagedType.U1)]
	        public byte fIsAESKey;
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_DESFIRE_MASTER_KEY_SETTINGS_AND_LENGTH
        {
            [MarshalAs(UnmanagedType.Struct)]
	        public CLSCRF_DESFIRE_MASTER_KEY_SETTINGS MasterKeySettings;
            [MarshalAs(UnmanagedType.Struct), StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
	        public struct MaxNumberOfKeys
	        {
                [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
		        public struct PiccMasterKey
		        {
                    [BitfieldLength(6)]
			        public byte MaxPiccKeysNumber;
                    [BitfieldLength(2)]
			        public byte KeyType;
		        }
                [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
		        public byte MaxApplicationKeysNumber;
	        }
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_ISO7816_HOLDERS_INFO
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct AllHolders
	        {
                [MarshalAs(UnmanagedType.U1)]
		        public byte Count;
                [MarshalAs(UnmanagedType.U1)]
		        public byte Active;
                [MarshalAs(UnmanagedType.U1)]
		        public byte CurNo;
                [MarshalAs(UnmanagedType.U1)]
		        public byte WTI;
	        }
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct SpecifiedHolder
	        {
		        //struct
                    [BitfieldLength(1)]
			        public byte isActive;
                    [BitfieldLength(1)]
			        public byte isCurrent;
                    [BitfieldLength(6)]
			        public byte RFU;
                [MarshalAs(UnmanagedType.U1)]
		        public byte Prot;
                [MarshalAs(UnmanagedType.U1)]
		        public byte F_D;
                [MarshalAs(UnmanagedType.I2)]
		        public short fKHz;
                [MarshalAs(UnmanagedType.U4)]
		        public uint BR;
	        }
            [FieldOffset(0), MarshalAs(UnmanagedType.ByValArray, SizeConst = 9)]
            public static byte[] BinData = new byte[9];
        }

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_VERSION
        {
            [MarshalAs(UnmanagedType.Struct)]
	        public struct HardwareVersionInfo
	        {
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucVendorID;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucType;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucSubType;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucMajorVersion;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucMinorVersion;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucStorageSize;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucProtocolType;
	        }
            [MarshalAs(UnmanagedType.Struct)]
	        public struct SoftwareVersionInfo
	        {
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucVendorID;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucType;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucSubType;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucMajorVersion;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucMinorVersion;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucStorageSize;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucProtocolType;
	        }
            [MarshalAs(UnmanagedType.Struct)]
	        public struct ManufacturerData
	        {
                [MarshalAs(UnmanagedType.ByValArray, SizeConst = 7)]
                public static byte[] UID = new byte[7];
                [MarshalAs(UnmanagedType.ByValArray, SizeConst = 5)]
                public static byte[] BatchNumber = new byte[5];
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucProductionDay;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucProductionMonth;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucProductionYear;
                [MarshalAs(UnmanagedType.Struct), StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
		        public struct CryptoSettings
		        {
                    [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
			        public struct Bits
			        {
                        [BitfieldLength(3)]
				        public byte RFU;
                        [BitfieldLength(1)]
				        public byte fDisable_DESFirePICCKeyChange;
                        [BitfieldLength(1)]
				        public byte fDisable_Decryption;
                        [BitfieldLength(1)]
				        public byte fDisable_Encryption;
                        [BitfieldLength(1)]
				        public byte fDisable_MAC_Verification;
                        [BitfieldLength(1)]
				        public byte fDisable_MAC_Generation;
			        };
                    [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
			        public byte ucBits;
		        }
	        }
	        public byte ucMode;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_AUTH_MODE_AV1
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct BitMask
	        {
                [BitfieldLength(1)]
		        public byte fKeyDiversifiedWith8Or16BytesDivInp;
                [BitfieldLength(1)]
		        public byte fUseLogicalChannelForCMACCalculation;
                [BitfieldLength(1)]
		        public byte fUseSecretKeyForCrypto;
                [BitfieldLength(1)]
		        public byte fDiversifyUsingOneEncryptionRound;
                [BitfieldLength(1)]
		        public byte fUseMIFARE_SAM_AV2_ModeKeyDiversificationMethods;
                [BitfieldLength(3)]
		        public byte RFU;
	        };
            [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
	        public byte ucBitMask;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_SETTINGS
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct Settings2
	        {
                [BitfieldLength(1)]
		        public short bAllowDumpSessionKey;
                [BitfieldLength(1)]
		        public short bAllowCryptoWithSecretKey;
                [BitfieldLength(1)]
		        public short bfKeepInitVector;
                [BitfieldLength(3)]
		        public short wKeyKind;
                [BitfieldLength(2)]
		        public short RFU;
                [BitfieldLength(1)]
		        public short bAV1HigherCmdSecLevel;
                [BitfieldLength(1)]
		        public short bDisableKeyEntry;
                [BitfieldLength(1)]
		        public short bAV1EnableHostAuth;
                [BitfieldLength(1)]
		        public short bDisableChangeKey;
                [BitfieldLength(1)]
		        public short bDisableDecryption;
                [BitfieldLength(1)]
		        public short bDisableEncryption;
                [BitfieldLength(1)]
		        public short bDisableVerifyMAC;
                [BitfieldLength(1)]
		        public short bDisableGenerateMAC;
	        };
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct Settings1
	        {
                [BitfieldLength(8)]
		        public short padding8;
                [BitfieldLength(1)]
		        public short bAV2EnableHostAuthKey;
                [BitfieldLength(1)]
		        public short padding1;
                [BitfieldLength(1)]
		        public short bAV1AV2AllowLockUnlock;
                [BitfieldLength(5)]
		        public short padding5;
	        }
            [FieldOffset(0), MarshalAs(UnmanagedType.I2)]
	        public short wSettings;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_EXT_SETTINGS
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct ExtSettings
	        {
                [BitfieldLength(3)]
		        public byte iKeyClass;
                [BitfieldLength(1)]
		        public byte bAllowDumpSecretKey;
                [BitfieldLength(1)]
		        public byte bRestrictToDiversifiedUse;
                [BitfieldLength(3)]
		        public byte RFU;
	        }
            [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
	        public byte ucExtSettings;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_NV_PROGRAMMING_MASK
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct NVProgramingMask
	        {
                [BitfieldLength(1)]
		        public byte fUpdateKeyA;
                [BitfieldLength(1)]
		        public byte fUpdateKeyB;
                [BitfieldLength(1)]
		        public byte fUpdateKeyC;
                [BitfieldLength(1)]
		        public byte fUpdateDFKeyNoAndAID;
                [BitfieldLength(1)]
		        public byte fUpdateKeyCEK_NumberAndVersion;
                [BitfieldLength(1)]
		        public byte fUpdateRefNoKUC;
                [BitfieldLength(1)]
		        public byte fUpdateSettings;
                [BitfieldLength(1)]
		        public byte fSendKeyVersionsSeparately;
	        };
            [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
	        public byte ucNVProgramingMask;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_CK_PARAM_MASK
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct Bits
	        {
                [BitfieldLength(1)]
		        public byte bEncrypt;
                [BitfieldLength(1)]
		        public byte bDiversifyKeyA;
                [BitfieldLength(1)]
		        public byte bDiversifyKeyB;
                [BitfieldLength(5)]
		        public byte RFU;
	        };
            [FieldOffset(0), MarshalAs(UnmanagedType.U1)]
	        public byte ucBits;
        }

        [StructLayout(LayoutKind.Explicit, CharSet = CharSet.Ansi, Pack = 1)]
        public struct CLSCRF_SAM_VC_DUO
        {
            [FieldOffset(0), MarshalAs(UnmanagedType.Struct)]
	        public struct Bits
	        {
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucKeyEncNo;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucKeyEncVer;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucKeyMacNo;
                [MarshalAs(UnmanagedType.U1)]
		        public byte ucKeyMacVer;
	        };
            [FieldOffset(0), MarshalAs(UnmanagedType.U4)]
	        public uint dwBits;
        }
        */

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Cards_GetCount(ref int piCardsCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Create(ref IntPtr handle);

        [DllImport(ClscrflDll)]
        [Obsolete("Метод вызывает ошибку в библиотеке!")]
        public static extern uint CLSCRF_Destroy(IntPtr handle);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenRS(IntPtr handle, uint dwIndex, uint dwBaudrate, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenUSB(IntPtr pReader, uint dwIndex, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenETH(IntPtr pReader, uint dwPort, IntPtr szIP, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_OpenPCSC(IntPtr pReader, IntPtr szName, uint dwLogFile);

        [DllImport(ClscrflDll)]
        public static extern bool CLSCRF_IsOpened(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Close(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetIOTimeout(IntPtr pReader, ref uint pdwTimeout);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SetIOTimeout(IntPtr pReader, uint dwTimeout);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetLastInternalError(IntPtr pReader, ref byte pbError);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetState(IntPtr pReader, ref uint pdwState);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_On(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Off(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Get_Mfrc_Version(IntPtr pReader, IntPtr pbMfrcVersion);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Get_Mfrc_Serial_Number(IntPtr pReader, IntPtr pbMfrcSN);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Get_ReaderID(IntPtr pReader, IntPtr pbReaderID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Reader_Restart(IntPtr pReader, IntPtr pbReaderID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Rf_Off_On(IntPtr pReader, ushort usDelay);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Mfrc_Set_Rf_Mode(IntPtr pReader, byte bRfMode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Sound(IntPtr pReader, byte nBeepCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Led(IntPtr pReader, byte bBlinkColor, byte bBlinkCount, byte bPostColor);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Switches(IntPtr pReader, byte ucControl);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_UART_Baudrate(IntPtr pReader, uint dwBaudrate);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SetIndicatorMessage(IntPtr pReader, IntPtr lpMessage, byte ucMessageLength, uint dwInfiniteLoop, uint dwLineIndex, uint dwMode, byte ucRepeats);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Idle_A(IntPtr pReader, ref ushort usATQ, ref byte bSAK, IntPtr pbUID, ref uint pdwUIDLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Halt_A(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Wakeup_A(IntPtr pReader, IntPtr pbUID, uint UIDLength, ref ushort usATQ, ref byte bSAK);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Idle_B(IntPtr pReader, byte bAfi, byte bSni, ref uint dwPUPI, ref uint dwAppData, ref uint dwProtInfo, ref uint dwCardCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Attrib_B(IntPtr pReader, IntPtr pbPUPI, byte bParam1, byte bParam2, byte bParam3, byte bParam4, IntPtr pbHigherLayerBuf, uint dwHLBufSize, ref uint dwHLInfLength, IntPtr pbMbliCid);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Halt_B(IntPtr pReader, IntPtr pbPUPI);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Activate_Wakeup_B(IntPtr pReader, byte bAfi, byte bSni, ref uint dwPUPI, ref uint dwAppData, ref uint dwProtInfo, ref uint dwCardCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Inventory_15693(IntPtr pReader, byte bFlags, byte bInventory, byte bAfi, byte bMaskLen, IntPtr pbMaskVal,  IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_FindAllTags_15693(IntPtr pReader, byte bFlags, byte bAfi, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Stay_Quiet_15693(IntPtr pReader, byte bFlags, byte bStayQuiet, IntPtr pbUID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Select_15693(IntPtr pReader, byte bFlags, byte bSelect, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ResetToReady_15693(IntPtr pReader, byte bFlags, byte bResetToReady, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_HostCodeKey(IntPtr pReader, IntPtr pbUncoded, IntPtr pbCoded);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthKey(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwSector, IntPtr pbCodedKey);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthKeyDirect(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwSector, IntPtr pbKey);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_WriteKeyToE2(IntPtr pReader, byte bKeyType, uint dwE2RecNo, IntPtr pbUncoded);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthE2Ex(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwE2RecNo, uint dwSector);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_AuthE2(IntPtr pReader, byte bKeyType, IntPtr pbUID, uint dwSector);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Read(IntPtr pReader, uint dwSector, uint dwBlock, IntPtr pbRecvBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Write(IntPtr pReader, uint dwSector, uint dwBlock, IntPtr pbSendBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Decrement(IntPtr pReader, uint dwSector, uint dwSourceBlock, uint dwValue, uint dwTargetBlock);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Increment(IntPtr pReader, uint dwSector, uint dwSourceBlock, uint dwValue, uint dwTargetBlock);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_Restore(IntPtr pReader, uint dwSector, uint dwSourceBlock, uint dwTargetBlock);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_CustomExchange(IntPtr pReader, ushort wOption, IntPtr pbSendBuffer, uint dwSendLength, byte bTxLastBitsCount, uint dwTimeout, IntPtr pbRecvBuffer, ref uint dwRecvLength, ref byte pRxLastBitsCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_EV1_PersonalizeUid(IntPtr pReader, byte ucUidMode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareStandard_EV1_SetLoadModulationType(IntPtr pReader, byte ucModType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralight_Read(IntPtr pReader, byte ucPage, IntPtr pbRecvBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralight_Write(IntPtr pReader, byte ucPage, IntPtr pbSendBuffer);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightC_WriteKey(IntPtr pReader, uint dwKeyFlashAddress);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightC_Authenticate(IntPtr pReader, uint dwKeyFlashAddress);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_GetVersion(IntPtr pReader, IntPtr pbVersion);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_Read(IntPtr pReader, byte ucPageAddress, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_ReadFast(IntPtr pReader, byte ucPageStart, byte ucPageEnd, ref uint pdwSizeRead, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_Write(IntPtr pReader, byte ucPageAddress, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_ReadCounter(IntPtr pReader, byte ucCounterNumber, ref uint dwCounterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_IncrementCounter(IntPtr pReader, byte ucCounterNumber, uint dwCounterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_AuthenticatePassword(IntPtr pReader, ref uint pPassword, ref ushort pPasswordAcknowledge);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_ReadSignature(IntPtr pReader, byte ucAddr, IntPtr pSignature);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_CheckTearingEvent(IntPtr pReader, byte ucCounterNumber, ref byte ucValidFlagByte);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareUltralightEV1_VirtualCardSupportLast(IntPtr pReader, IntPtr pIID, IntPtr pPCDCAPS, ref byte ucVirtualCardTypeIdentifier);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ReadSingleBlock_15693(IntPtr pReader, byte bFlags, byte bReadSingleBlock, IntPtr pbUID, byte bBlockNumber, ref byte bOutFlags, ref byte bBlockSecurityStatus, IntPtr pbData, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteSingleBlock_15693(IntPtr pReader, byte bFlags, byte bWriteSingleBlock, IntPtr pbUID, byte bBlockNumber, IntPtr pbData, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteMultipleBlocks_15693(IntPtr pReader, byte bFlags, byte bWriteMultipleBlocks, IntPtr pbUID, byte bBlockNumber, byte bBlocksCount, IntPtr pbData, ref byte pbFlags, ref byte pbErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_LockBlock_15693(IntPtr pReader, byte bFlags, byte bLockBlock, IntPtr pbUID, byte bBlockNumber, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ReadMultipleBlocks_15693(IntPtr pReader,
                                                                byte ucFlags,
                                                                byte ucReadMultipleBlock,
                                                                IntPtr pbUID,
                                                                byte ucFirstBlockNumber,
                                                                ref byte ucNumberOfBlocks,
                                                                ref byte ucOutFlags,
                                                                IntPtr pbBlockSecurityStatus,
                                                                IntPtr pbData,
                                                                ref byte ucErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteAFI_15693(IntPtr pReader, byte bFlags, byte bWriteAFI, IntPtr pbUID, byte bAFI, ref byte bOutFlags, ref byte pbErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_LockAFI_15693(IntPtr pReader, byte bFlags, byte bLockAFI, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteDSFID_15693(IntPtr pReader, byte bFlags, byte bWriteDSFID, IntPtr pbUID, byte bDSFID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_LockDSFID_15693(IntPtr pReader, byte bFlags, byte bLockDSFID, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetSystemInfo_15693(IntPtr pReader, byte bFlags, byte bGetSystemInfo, IntPtr pbUID, ref byte bOutFlags, ref byte pbInfoFlags, ref byte pbDSFID, ref byte pbAFI, ref uint bMemorySize, ref byte bICReference, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetMultipleBSS_15693(IntPtr pReader, byte bFlags, byte bGetMultipleBSS, IntPtr pbUID, byte bFirstBlockNumber, ref byte bNumberOfBlocks, ref byte bOutFlags, IntPtr pbBlockSecurityStatus, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SetEAS_15693(IntPtr pReader, byte bFlags, byte bSetEAS, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ResetEAS_15693(IntPtr pReader, byte bFlags, byte bResetEAS, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_LockEAS_15693(IntPtr pReader, byte bFlags, byte bLockEAS, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_EASAlarm_15693(IntPtr pReader, byte bFlags, byte bEASAlarm, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, IntPtr pbEASData, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_GetRandomNumber(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, ref uint pdwRandomNumber, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_SetPassword(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, byte ucPasswordIdentifier, uint dwPassword, uint dwRandomNumber, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_WritePassword(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, byte ucPasswordIdentifier, uint dwPassword, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_LockPassword(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, byte ucPasswordIdentifier, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_PasswordProtectEAS_AFI(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_64BitProtection(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_ProtectPage(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, byte ucProtectionPointerAddress, byte ucExtendedProtectionStatus, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_LockPageProtectionCondition(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, byte ucProtectionPointerAddress, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_Destroy(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, uint dwPassword, uint dwRandomNumber, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_15693_ICode_EnablePrivacy(IntPtr pReader, byte bFlags, byte bICMfgCode, IntPtr pbUID, uint dwPassword, uint dwRandomNumber, ref byte bOutFlags, ref byte bErrorCode);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_DirectIO_Reader(IntPtr pReader, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_DirectIO_Card(IntPtr pReader, IntPtr pbSendBuffer, uint uiSendLength, uint uiTimeout, IntPtr pbRecvBuffer, ref uint uiRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_GetIOAddress(IntPtr pReader, ref byte bIOAddr);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SetIOAddress(IntPtr pReader, byte bIOAddr);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ReadDeviceAddress(IntPtr pReader, ref byte bDevAddr);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteDeviceAddress(IntPtr pReader, byte bDevAddr);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_SaveAESKeysToFile(IntPtr pReader, IntPtr pbIV, IntPtr pbKeys, uint dwKeysCount, IntPtr lsPassword);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_GenerateAndSaveAESKeysToFile(IntPtr pReader, uint dwKeysCount, IntPtr lsPassword);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_LoadAESKeysFromFile(IntPtr pReader, IntPtr lsFileName, IntPtr lsPassword, ref uint ldKeysCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_WriteFlash_AESKeys(IntPtr pReader, uint dwStartKey, uint dwKeysCount );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_SetEncryptionMode(IntPtr pReader, int fEncryptionMode );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_GetEncryptionMode(IntPtr pReader, ref int pfEncryptionMode );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_GetAESKeysCount(IntPtr pReader, ref uint dwKeysCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_GetAESKey(IntPtr pReader, uint dwKeyIndex, IntPtr lpKey);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_Crypto_AuthenticateReader(IntPtr pReader, byte ucAuthType, uint dwKeyNumber );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_EraseFlash(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteFlashValue(IntPtr pReader, uint dwAddress, IntPtr pbValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_CheckFlashValueFilled(IntPtr pReader, uint dwFlashAddr, ref byte bStatus);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_WriteReaderConfig(IntPtr pReader, byte ucMemType, byte ucAddress, byte ucLength, IntPtr pbValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ReadReaderConfig(IntPtr pReader, byte ucMemType, byte ucAddress, byte ucLength, IntPtr pbValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ResetReaderConfig(IntPtr pReader, byte ucMemType, byte ucAddress, byte ucLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_4_RATS(IntPtr pReader, byte ucCID, IntPtr pbATS);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_4_PPS(IntPtr pReader, byte ucCID, byte ucBaudrate);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_4_Activate(IntPtr pReader, byte ucCID, byte ucBaudrate, IntPtr pbATS);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443_ActivateEx(IntPtr pReader, byte ucCardStandard, byte ucCID, byte ucBaudrate, byte ucRfOffTime, byte ucRfOnPause, byte ucDisableTCLSwitch, byte ucAFI, byte ucExtATQ, byte ucSni, ref ushort bATQ, ref byte ucSAK, IntPtr pbATS, IntPtr pbUID, ref byte ucUIDLength, IntPtr pucMBLI, IntPtr pbATQB, ref byte ucATQBLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443A_ActivateEx(IntPtr pReader, byte ucCID, byte ucBaudrate, byte ucRfOffTime, byte ucRfOnPause, byte ucDisableTCLSwitch, ref ushort bATQ, ref byte ucSAK, IntPtr pbATS, IntPtr pbUID, ref byte ucUIDLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443B_ActivateEx(IntPtr pReader, byte ucCID, byte ucBaudrate, byte ucRfOffTime, byte ucRfOnPause, byte ucDisableTCLSwitch, byte ucAFI, byte ucExtATQ, byte ucSni, ref uint dwPUPI, ref uint dwAppData, ref uint dwProtInfo, ref byte ucProtInfoLength, IntPtr pucMBLI);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO14443_4_Exchange(IntPtr pReader, uint dwOption, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_WritePerso(IntPtr pReader, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, uint dwValueFlashAddress);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_WritePersoExplicit(IntPtr pReader, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_CommitPerso(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_Authenticate(IntPtr pReader, byte ucAuthType, byte ucKeyType, byte ucSectorNumber, uint usKeyFlashAddress, byte ucLenCap, IntPtr pbPCDCap);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_AuthenticateDirect(IntPtr pReader, byte ucAuthType, byte ucKeyType, byte ucSectorNumber, IntPtr pbKey, byte ucLenCap, IntPtr pbPCDCap);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_MultiBlockRead(IntPtr pReader, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_MultiBlockWrite(IntPtr pReader, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_ReadData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_WriteData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_Increment(IntPtr pReader, byte ucEncryptionMode, byte ucSourceSectorNumber, byte ucSourceBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_Decrement(IntPtr pReader, byte ucEncryptionMode, byte ucSourceSectorNumber, byte ucSourceBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_Transfer(IntPtr pReader, byte ucEncryptionMode, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_IncrementTransfer(IntPtr pReader, byte ucEncryptionMode, byte ucSourceSectorNumber, byte ucSourceBlockNumber, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_DecrementTransfer(IntPtr pReader, byte ucEncryptionMode, byte ucSourceSectorNumber, byte ucSourceBlockNumber, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_Restore(IntPtr pReader, byte ucEncryptionMode, byte ucSourceSectorNumber, byte ucSourceBlockNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_VirtualCardSupport(IntPtr pReader, IntPtr pIID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_VirtualCardSupportLast(IntPtr pReader, IntPtr pIID, uint dwKencFlashAddress, uint dwKmacFlashAddress, byte ucLenCap, IntPtr pbPcdCap, ref byte ucInfo, ref ushort pPiccCap, IntPtr pPaddedUID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_VirtualCardSelect(IntPtr pReader, uint dwKselFlashAddress, ref ushort pPiccCap, IntPtr pPaddedUID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_VirtualCardDeselect(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlus_ProximityCheck(IntPtr pReader, uint dwKproxFlashAddress);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_WritePerso(IntPtr pReader, byte ucT_CL, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_CommitPerso(IntPtr pReader, byte ucOption, byte ucT_CL);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_GetVersion(IntPtr pReader, IntPtr pbVerInfo);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ReadSignature(IntPtr pReader, byte ucT_CL, byte ucAddr, IntPtr pbSignature);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Authenticate(IntPtr pReader, byte ucSL, byte ucT_CL, byte ucAuthType, byte ucKeyType, byte ucSectorNumber, ushort usKeyFlashAddress, byte ucLenDIV, IntPtr pbDIV, byte ucLenCap, IntPtr pbPCDCap, IntPtr pbRCOut, IntPtr pbTCOut);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_AuthenticateDirect(IntPtr pReader, byte ucSecLevel, byte ucT_CL, byte ucAuthType, byte ucKeyType, byte ucSectorNumber, IntPtr pbKey, byte ucLenDIV, IntPtr pbDIV, byte ucLenCap, IntPtr pbPcdCap, IntPtr pbRetPiccCap);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_CommitReaderID(IntPtr pReader, byte ucSectorNumber, byte ucBlockNumber, byte ucTMACNumber, uint dwFlashKeyNumber, IntPtr pbEncTMRI);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ReadData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_WriteData(IntPtr pReader, byte ucEncryptionMode, byte ucValueType, byte ucSectorNumber, byte ucBlockNumber, byte ucBlocksCount, IntPtr pbData, ref uint dwMACCounter, IntPtr pMACValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Increment(IntPtr pReader, byte ucMAConResponse, byte ucSourceSectorNumber, byte ucSourceBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Decrement(IntPtr pReader, byte ucMAConResponse, byte ucSourceSectorNumber, byte ucSourceBlockNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Transfer(IntPtr pReader, byte ucMAConResponse, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber, ref uint dwMACCounter, IntPtr pMACValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_IncrementTransfer(IntPtr pReader, byte ucMAConResponse, byte ucSourceSectorNumber, byte ucSourceBlockNumber, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber, uint dwValue, ref uint dwMACCounter, IntPtr pMACValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_DecrementTransfer(IntPtr pReader, byte ucMAConResponse, byte ucSourceSectorNumber, byte ucSourceBlockNumber, byte ucDestinationSectorNumber, byte ucDestinationBlockNumber, uint dwValue, ref uint dwMACCounter, IntPtr pMACValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_Restore(IntPtr pReader, byte ucMAConResponse, byte ucSourceSectorNumber, byte ucSourceBlockNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_VirtualCardSupportLastISOL3(IntPtr pReader, IntPtr pIID, IntPtr pbPcdCapL3, IntPtr pucInfo);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ProximityCheck(IntPtr pReader, byte ucSteps, uint dwPcKeyNr, byte ucGenRndC, IntPtr pbRndC);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ISOSelectExternalAuthenticate(IntPtr pReader, uint dwEncKeyNr, uint dwMacKeyNr, byte ucLenIID, IntPtr pbIID, ref uint dwVCDataLength, IntPtr pbVCData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_ISOSelect(IntPtr pReader, uint dwEncKeyNr, byte ucLenIID, IntPtr pbIID, ref uint dwVCDataLength, IntPtr pbVCData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_AuthenticateSectorSwitch(IntPtr pReader, byte ucL1L3, uint dwSSKeyNr, byte ucSector, uint dwSKeyBNr, byte ucLSS, IntPtr pbDISS, byte ucLSK, IntPtr pbDISK);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_MF_PersonalizeUID(IntPtr pReader, byte ucUidType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifarePlusEV1_SetConfigSL1(IntPtr pReader, byte ucT_CL_Disable);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ClearAuthState(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_Authenticate(IntPtr pReader, byte ucAuthType, IntPtr pKey, byte ucKeyNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_SetTransferType(IntPtr pReader, byte ucTransferType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ChangeKeySettings(IntPtr pReader, /*IN CLSCRF_DESFIRE_MASTER_KEY_SETTINGS**/ IntPtr pMasterKeySettings);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetKeySettings(IntPtr pReader, /*OUT CLSCRF_DESFIRE_MASTER_KEY_SETTINGS_AND_LENGTH**/ IntPtr pKeyData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ChangeKey(IntPtr pReader, /*IN CLSCRF_DESFIRE_KEY_DATA**/ IntPtr pKeyData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetKeyVersion(IntPtr pReader, byte ucKeyNumber, ref byte ucKeyVersion);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateApplication(IntPtr pReader, /*3 bytes*/ref uint AID, /*IN CLSCRF_DESFIRE_APPLICATION_MASTER_KEY_SETTINGS**/ IntPtr pKeySett1, /*IN CLSCRF_DESFIRE_NEW_APPLICATION_KEY_SETTINGS**/ IntPtr pKeySett2, ref ushort IsoFileID, IntPtr pIso7816DfName, int iIso7816DfNameLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_DeleteApplication(IntPtr pReader, /*3 bytes*/ref uint AID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetApplicationIDs(IntPtr pReader, IntPtr pAIDs, ref byte ucApplicationsCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetDFNames(IntPtr pReader, /*OUT CLSCRF_DESFIRE_DFNAME**/ IntPtr pDFNames, ref byte ucDFNamesCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_SelectApplication(IntPtr pReader, /*3 bytes*/ref uint AID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_FormatPICC(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetVersion(IntPtr pReader, /*OUT CLSCRF_DESFIRE_HW_SW_INFO**/ IntPtr pHWInfo, /*OUT CLSCRF_DESFIRE_HW_SW_INFO**/ IntPtr pSWInfo, /*OUT CLSCRF_DESFIRE_MORE_INFO**/ IntPtr pMoreInfo);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_FreeMemory(IntPtr pReader, ref uint dwMemSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_SetConfiguration(IntPtr pReader, /*IN CLSCRF_DESFIRE_CONFIGURATION**/ IntPtr pCfg);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetCardUID(IntPtr pReader, IntPtr pUID);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetFileIDs(IntPtr pReader, IntPtr pFileIDs, ref byte ucFilesCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetISOFileIDs(IntPtr pReader, IntPtr pISOFileIDs, ref byte ucFilesCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetFileSettings(IntPtr pReader, byte ucFileNumber, /*OUT CLSCRF_DESFIRE_FILE_SETTINGS**/ IntPtr pFileSettings);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ChangeFileSettings(IntPtr pReader, byte ucFileNumber, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateStdDataFile(IntPtr pReader, byte ucFileNumber, IntPtr pISOFileID, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights, uint dwFileSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateBackupDataFile(IntPtr pReader, byte ucFileNumber, IntPtr pISOFileID, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights, uint dwFileSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateValueFile(IntPtr pReader, byte ucFileNumber, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights, uint dwLowerLimit, uint dwUpperLimit, uint dwValue, /*IN CLSCRF_DESFIRE_LIMITED_CREDIT_ENABLED**/ IntPtr pLimitedCreditEnabled);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateLinearRecordFile(IntPtr pReader, byte ucFileNumber, IntPtr pISOFileID, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights, uint dwRecordSize, uint dwMaxNumOfRecords);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CreateCyclicRecordFile(IntPtr pReader, byte ucFileNumber, IntPtr pISOFileID, byte ucCommSettings, /*IN CLSCRF_DESFIRE_FILE_ACCESS_RIGHTS**/ IntPtr pAccessRights, uint dwRecordSize, uint dwMaxNumOfRecords);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_DeleteFile(IntPtr pReader, byte ucFileNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ReadData(IntPtr pReader, byte ucFileNumber, uint dwOffset, uint dwLength, IntPtr pData, ref uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_WriteData(IntPtr pReader, byte ucFileNumber, uint dwOffset, uint dwLength, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_GetValue(IntPtr pReader, byte ucFileNumber, ref uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_Credit(IntPtr pReader, byte ucFileNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_Debit(IntPtr pReader, byte ucFileNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_LimitedCredit(IntPtr pReader, byte ucFileNumber, uint dwValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_WriteRecord(IntPtr pReader, byte ucFileNumber, uint dwOffset, uint dwLength, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ReadRecords(IntPtr pReader, byte ucFileNumber, uint dwRecordOffset, uint dwRecordsCount, uint dwRecordSize, IntPtr pData, ref uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_ClearRecordFile(IntPtr pReader, byte ucFileNumber);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_CommitTransaction(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_MifareDesFire_AbortTransaction(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_ActivateCard(IntPtr pReader,
										IntPtr	Nfcid3i,/**< [In] NFCID3 - any number in case of 106kbps initial datarate.
                                                            For 212/424kbps datarate bytes 0 - 7 have to be NFCID2,
                                                            bytes 8 - 9 need to be set to 0; uint8_t[10] */
										byte	Did,/**< [In] Device Identifier; '0' to disable usage else 1-14. */
										byte	NadEnable,/**< [In] Enable usage of Node Address; Unequal '0' to enable. */
										byte	Nad,/**< [In] Node Address; Ignored if bNadEnabled is equal '0'. */
										byte	Dsi,/**< [In] Divisor Send (target to initiator) Integer; 0-7 */
										byte	Dri,/**< [In] Divisor Receive (initiator to target) Integer; 0-7 */
										byte	Fsl,/**< [In] Frame Length Byte; 0-3 */
										byte	GiLength,/**< [In] Number of General Information bytes. */
										IntPtr	Gi,/**< [In] Optional General Information bytes. */
										IntPtr  pbATR, /**< [Out] Attribute Response; uint8_t[64]. */
									    ref uint dwATRLength );/**< [Out] Attribute Response Length. */

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_Deselect(IntPtr pReader, byte DeselectCommand);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_Exchange(IntPtr pReader, uint dwOption, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_ResetProtocol(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_AttributeRequest(IntPtr pReader,
											IntPtr	Nfcid3i,/**< [In] NFCID3 - randomly generated in case of 106kbps initial datarate or
                                                   NFCID2 in case of 212/424kbps datarate; uint8_t[10] */
											byte	Did,/**< [In] Device Identifier; '0' to disable usage else 1-14. */
											byte	NadEnable,/**< [In] Enable usage of Node Address; Unequal '0' to enable. */
											byte	Nad,/**< [In] Node Address; Ignored if bNadEnabled is equal '0'. */
											byte	Fsl,/**< [In] Frame Length Byte; 0-3  */
											byte	GiLength,/**< [In] Number of General Information bytes; Not more than #PHPAL_I18092MPI_MAX_GI_LENGTH. */
											IntPtr	Gi,/**< [In] Optional General Information bytes. */
											IntPtr  pbATR, /**< [Out] Attribute Response; uint8_t[64]. */
										    ref uint dwATRLength );/**< [Out] Attribute Response Length. */

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_ParameterSelect(IntPtr pReader,
											byte	Dsi,/**< [In] Divisor Send (target to initiator) Integer; 0-2 */
											byte	Dri,/**< [In] Divisor Receive (initiator to target) Integer; 0-2 */
											byte	Fsl );/**< [In] Frame Length Byte; 0-3  */

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_PresenceCheck(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_SetConfig(IntPtr pReader, uint dwParameterNumber, uint pdwParameterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_GetConfig(IntPtr pReader, uint dwParameterNumber, ref uint dwParameterValue);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_GetSerialNo(IntPtr pReader, IntPtr NFCID3);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_E2_Read(IntPtr pReader, uint dwAddr, byte ucLength, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_E2_Write(IntPtr pReader, uint dwAddr, byte ucData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC663_E2_WritePage(IntPtr pReader, uint dwAddr, byte ucLength, IntPtr pData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_TDA8029_APDU(IntPtr pReader, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_TDA8029_Exchange(IntPtr pReader, byte ucCommand, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_TDA8029_Reset(IntPtr pReader, byte ucInterval);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_TDA8029_GetStatus(IntPtr pReader, ref byte ucStatus);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_TDA8029_GetATR(IntPtr pReader, IntPtr pbATRBuffer, ref uint dwATRLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_Create(IntPtr lpMsgDataBytes, uint dwMsgDataLength, ref IntPtr phNDEFMessage);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_GetRecordsCount(IntPtr hNDEFMessage, ref uint dwRecordsCount);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_GetDataSize(IntPtr hNDEFMessage, ref uint dwDataSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_GetData(IntPtr hNDEFMessage, IntPtr lpData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecord(IntPtr hNDEFMessage, IntPtr hNDEFRecord);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecordEmpty(IntPtr hNDEFMessage);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecordText(IntPtr hNDEFMessage, IntPtr lpwstrText, IntPtr lpwstrEncoding);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecordUri(IntPtr hNDEFMessage, IntPtr lpwstrUri);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecordMimeMedia(IntPtr hNDEFMessage, IntPtr lpwstrMimeType, IntPtr lpPayload, uint dwPayloadLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_AddRecordMimeMediaText(IntPtr hNDEFMessage, IntPtr lpwstrMimeType, IntPtr lpwstrText);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_GetRecord(IntPtr hNDEFMessage, uint dwRecordIndex, ref IntPtr phNDEFRecord);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Message_Destroy(IntPtr hNDEFMessage);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_Create(ref IntPtr phNDEFRecord);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetDataSize(IntPtr hNDEFRecord, ref uint dwDataSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetTnf(IntPtr hNDEFRecord, ref byte ucTnf);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_SetTnf(IntPtr hNDEFRecord, byte ucTnf);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetTypeLength(IntPtr hNDEFRecord, ref uint dwTypeLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetType(IntPtr hNDEFRecord, IntPtr lpTypeData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetTypeStr(IntPtr hNDEFRecord, IntPtr lpwstrType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_SetType(IntPtr hNDEFRecord, IntPtr lpTypeData, uint dwTypeLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_SetTypeStr(IntPtr hNDEFRecord, IntPtr lpwstrType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetPayloadLength(IntPtr hNDEFRecord, ref uint dwPayloadLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetPayload(IntPtr hNDEFRecord, IntPtr lpPayloadData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetPayloadText(IntPtr hNDEFRecord, IntPtr lpwstrText);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetPayloadUri(IntPtr hNDEFRecord, IntPtr lpwstrUri);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_SetPayload(IntPtr hNDEFRecord, IntPtr lpPayloadData, uint dwPayloadLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetIdLength(IntPtr hNDEFRecord, ref uint pdwIdLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetId(IntPtr hNDEFRecord, IntPtr lpIdData);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_GetIdStr(IntPtr hNDEFRecord, IntPtr lpwstrId);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_SetId(IntPtr hNDEFRecord, IntPtr lpIdData, uint dwIdLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_NDEF_Record_Destroy(IntPtr hNDEFRecord);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_Create(IntPtr pReader, ref IntPtr phLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_SetTimeout(IntPtr hLLCPLink, uint dwTimeoutMs);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_SetBaudrate(IntPtr hLLCPLink, byte ucDsiDri);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_SetGeneralInformation(IntPtr hLLCPLink, IntPtr lpGI, uint dwGILength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_SetNFCID3Information(IntPtr hLLCPLink, IntPtr lpNFCID3i);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ServerOpen(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ServerReceive(IntPtr hLLCPLink, IntPtr lpData, ref uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ServerClose(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ClientOpen(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ClientTransmit(IntPtr hLLCPLink, IntPtr lpData, uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_ClientClose(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_LLCP_Destroy(IntPtr hLLCPLink);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Create(IntPtr hLLCPLink, ref IntPtr phSNEP);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Receive(IntPtr hSNEP, IntPtr lpData, ref uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Transmit(IntPtr hSNEP, IntPtr lpData, uint dwDataLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_SNEP_Destroy(IntPtr hSNEP);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(IntPtr pReader, ref ushort ATQ, byte SAK, ref byte pucTagType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_BeginType4(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Format(IntPtr pReader, byte ucTagType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Read(IntPtr pReader, byte ucTagType, IntPtr lpData, ref uint dwDataSize, ref byte ucPermissions);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_Write(IntPtr pReader, byte ucTagType, IntPtr lpData, uint dwDataSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(IntPtr pReader, IntPtr ATQ, byte SAK, ref byte pucTagType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_SetCurrentHolder(IntPtr pReader, byte ucNumHolder);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_SetCurrentHolderGetATR(IntPtr pReader, byte ucNumHolder, uint dwATRBufSize, IntPtr pATR, ref uint dwATRSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_SetCurrentHolderEx(IntPtr pReader, byte ucNumHolder, byte ucWT10, byte ucPPS1, byte ucDeactivate, uint dwATRBufSize, IntPtr pATR, ref uint dwATRSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_GetCurrentHolder(IntPtr pReader, ref byte pucNumHolder);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_GetHoldersInfo(IntPtr pReader, byte ucNumHolder, /*OUT CLSCRF_ISO7816_HOLDERS_INFO**/ IntPtr pHoldersInfo);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_Reset(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_ISO7816_APDU(IntPtr pReader, IntPtr pbSendBuffer, uint dwSendLength, IntPtr pbRecvBuffer, ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetStatusDescription(byte ucSW1, byte ucSW2, IntPtr pError);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_SetCurrentHolder(IntPtr pReader, byte ucNumSAM);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_SetCurrentHolderGetATR(IntPtr pReader,
												byte ucNumHolder,
												uint dwATRBufSize,
												IntPtr pATR,
												ref uint dwATRSize
											);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_SetCurrentHolderEx(IntPtr pReader,
											byte ucNumHolder,
											byte ucWT10,
											byte ucPPS1,
											byte ucDeactivate,
											uint dwATRBufSize,
											IntPtr pATR,
											ref uint dwATRSize);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetCurrentHolder(IntPtr pReader, ref byte ucNumSAM );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_APDU(IntPtr pReader,
                              IntPtr pbSendBuffer, 
                              uint dwSendLength, 
                              IntPtr pbRecvBuffer, 
                              ref uint dwRecvLength);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_Lock(IntPtr pReader,
							byte ucLC,
							byte ucKeyKind,
							byte ucKeyNo, 
							byte ucKeyVer, 
							IntPtr pUnlockKey, 
							byte ucUnlockKeyNo,
							byte ucUnlockKeyVer,
							//uint dwMaxChainBlocks,
							ref byte ucSW1,
							ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_Unlock(IntPtr pReader,
								byte ucLC,
								byte ucKeyKind,
								byte ucKeyNo, 
								byte ucKeyVer, 
								IntPtr pUnlockKey, 
								ref byte ucSW1,
								ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetVersion(IntPtr pReader,
									byte ucLC,
									/*OUT CLSCRF_SAM_VERSION**/ IntPtr pVersion,
									ref byte ucSW1,
									ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_AuthenticateHost(IntPtr pReader,
										byte ucLC,
										byte ucHostMode,
										byte ucKeyKind,
										byte ucKeyNo, 
										byte ucKeyVer, 
										IntPtr pKey, 
										//byte ucDivLength, 
										//IN LPBYTE pbDivInp, 
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_ActivateOfflineKey(IntPtr pReader,
											byte ucLC,
											byte ucKeyNo, 
											byte ucKeyVer, 
											byte ucDivLength, 
											IntPtr pbDivInp, 
											ref byte ucSW1,
											ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_SwitchToAV2Mode(IntPtr pReader,
										byte ucLC,
										IntPtr pbNewPosAkey, 
										byte ucNewPosAkeyVer, 
										IntPtr pbNewPosBkey, 
										byte ucNewPosBkeyVer, 
										IntPtr pbNewPosCkey, 
										byte ucNewPosCkeyVer, 
										uint dwMaxChainBlocks,
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_Reset(IntPtr pReader);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_KillAuth(IntPtr pReader, byte bType);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_Halt_A(IntPtr pReader, byte ucLC);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_GetKeyEntry(IntPtr pReader,
									                    byte ucLC,
									                    byte ucKeyKind,
									                    byte ucKeyNo,
									                    ref byte pucKeyAVersion,
									                    ref byte pucKeyBVersion,
									                    ref byte pucKeyCVersion,
									                    ref uint pdwDESFireAID,
									                    ref byte pucDESFireKeyNo,
									                    ref byte pucKeyNoCEK,
									                    ref byte pucKeyVCEK,
									                    ref byte pucRefNoKUC,
									                    ref ushort pSettings,
                                                        ref byte pExtSettings,
									                    ref byte pucSW1,
									                    ref byte pucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_ChangeKeyEntry(IntPtr pReader,
										                    byte ucLC,
										                    byte ucKeyNo,
										                    byte ucKeyKind,
										                    IntPtr pbKeyA,
										                    IntPtr pbKeyB,
										                    IntPtr pbKeyC,
										                    uint dwDF_AID,
										                    byte ucDF_KeyNr,
										                    byte ucCEKNo,
										                    byte ucCEKV,
										                    byte ucKUC,
                                                            ref ushort pSettings,
										                    byte ucKeyVerA,
										                    byte ucKeyVerB,
										                    byte ucKeyVerC,
                                                            ref byte pExtSettings,
										                    uint fPlainKeyUpdate,
                                                            uint fOfflineKeyChange,
										                    IntPtr pbSAM_UID,
                                                            ref byte pNVProgrammingMask,
										                    ref byte pucSW1,
										                    ref byte pucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_DisableKeyEntry(IntPtr pReader,
										byte ucLC,
										byte ucKeyNo,
										byte ucKeyKind,
										IntPtr pbSAM_UID,
										ref byte ucSW1,
										ref byte ucSW2 );

        //[DllImport(ClscrflDll)]
        //public static extern uint CLSCRF_SAM_MifareAuthenticate(IntPtr pReader, byte bLC, byte bAuthType, IntPtr pbUID, byte keyNo, byte keyVer, byte keyType, uint dwSector, out byte pbSW1, out byte pbSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareAuthenticate(IntPtr pReader,
                                                                byte ucLC,
                                                                byte ucAuthType,
                                                                IntPtr pbUID,
                                                                byte ucKeyNo,
                                                                byte ucKeyVer,
                                                                byte ucKeyType,
                                                                uint dwSector,
                                                                ref byte pucSW1,
                                                                ref byte pucSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareRead(IntPtr pReader, byte bLC, uint dwSector, uint dwBlock, IntPtr pbRecvBuffer, out byte pbSW1, out byte pbSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareWrite(IntPtr pReader,
									byte ucLC,
									uint  dwSector,
									uint  dwBlock,
                                    IntPtr pbSendBuffer,
									ref byte ucSW1,
									ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareIncrement(IntPtr pReader,
										byte ucLC,
                                        uint  dwSector,
                                        uint  dwSourceBlock,
                                        uint  dwValue,
                                        uint  dwTargetBlock,
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareDecrement(IntPtr pReader,
										byte ucLC,
                                        uint  dwSector,
                                        uint  dwSourceBlock,
                                        uint  dwValue,
                                        uint  dwTargetBlock,
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareRestore(IntPtr pReader,
										byte ucLC,
                                        uint  dwSector,
                                        uint  dwSourceBlock,
                                        uint  dwTargetBlock,
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareChangeKey(IntPtr pReader,
										byte ucLC,
										/*IN CLSCRF_SAM_CK_PARAM_MASK*/ IntPtr ParamMask,
										byte ucKeyNo,
										byte ucKeyVerA,
										byte ucKeyVerB,
										uint  dwSector,
										IntPtr pbAccess,
										IntPtr pbUID,
										ref byte ucSW1,
										ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_Mifare_Complex(IntPtr pReader,
byte ucSAMLC,
byte ucSAMHolder,
byte ucSAMKeyNo,
byte ucSAMKeyVer,
byte ucSAMResetType,
byte ucRfOffTime,
byte ucRfOnPauseTime,
byte ucMifareKeyType,
byte ucMifareOperation,
byte ucMifareSector,
byte ucMifareBlock,
byte ucMifareBlocksCount,
ref ushort ucATQ,
ref byte ucSAK,
IntPtr pucUID,
ref byte ucUIDLength,
IntPtr pucWriteData,
IntPtr pucReadData,
IntPtr pucLastTask,
ref byte pucResBlkCnt,
ref byte ucSW1,
ref byte ucSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareUltralightC_WriteKey(IntPtr pReader,
													byte ucLC,
													IntPtr pbUID,
													byte ucKeyNo,
													byte ucKeyVer,
													ref byte ucSW1,
													ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifareUltralightC_Authenticate(IntPtr pReader,
														byte ucLC,
														IntPtr pbUID,
														byte ucKeyNo,
														byte ucKeyVer,
														ref byte ucSW1,
														ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_WritePerso(IntPtr pReader,
												byte  ucLC,
												byte  ucValueType,
												byte  ucSectorNumber,
												byte  ucBlockNumber,
												byte  ucKeyNumber,
												byte  ucKeyVersion,
												byte  ucLenDiv,
												IntPtr pbDiv,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_CommitPerso(IntPtr pReader,
												byte  ucLC,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_Authenticate(IntPtr pReader,
												byte ucLC,
												byte  ucAuthType,
												byte  ucSecLevel,
												byte  ucKeyType,
												byte  ucSectorNumber,
												byte  ucKeyNumber,
												byte  ucKeyVersion,
												byte  ucLenCap,
												IntPtr pbPcdCap,
												byte  ucLenDiv,
												IntPtr pbDiv,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_MultiBlockRead(IntPtr pReader,
													byte ucLC,
													byte ucSectorNumber,
													byte ucBlockNumber,
													byte ucBlocksCount,
													IntPtr pbData,
													ref byte ucSW1,
													ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_MultiBlockWrite(IntPtr pReader,
													byte ucLC,
													byte ucSectorNumber,
													byte ucBlockNumber,
													byte ucBlocksCount,
													IntPtr pbData,
													ref byte ucSW1,
													ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_ReadData(IntPtr pReader,
											byte ucLC,
											byte ucReadMode,
											byte ucValueType,
											byte ucSectorNumber,
											byte ucBlockNumber,
											byte ucBlocksCount,
											IntPtr pbData,
											ref byte ucSW1,
											ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_WriteData(IntPtr pReader,
												byte ucLC,
												byte ucWriteMode,
												byte ucValueType,
												byte ucSectorNumber,
												byte ucBlockNumber,
												byte ucBlocksCount,
												IntPtr pbData,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_ChangeKey(IntPtr pReader,
byte ucLC,
byte ucEncryptionMode,
byte ucKeyType,
byte ucSectorNumber,
byte ucKeyNumber,
byte ucKeyVersion,
byte ucLenDiv,
IntPtr pbDiv,
ref byte ucSW1,
ref byte ucSW2);

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_Increment(IntPtr pReader,
												byte ucLC,
												byte ucEncryptionMode,
												byte ucSourceSectorNumber,
												byte ucSourceBlockNumber,
												uint dwValue,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_Decrement(IntPtr pReader,
												byte ucLC,
												byte ucEncryptionMode,
												byte ucSourceSectorNumber,
												byte ucSourceBlockNumber,
												uint dwValue,
												ref byte ucSW1,
												ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_Transfer(IntPtr pReader,
											byte ucLC,
											byte ucEncryptionMode,
											byte ucDestinationSectorNumber,
											byte ucDestinationBlockNumber,
											ref byte ucSW1,
											ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_IncrementTransfer(IntPtr pReader,
														byte ucLC,
														byte ucEncryptionMode,
														byte ucSourceSectorNumber,
														byte ucSourceBlockNumber,
														byte ucDestinationSectorNumber,
														byte ucDestinationBlockNumber,
														uint dwValue,
														ref byte ucSW1,
														ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_DecrementTransfer(IntPtr pReader,
														byte ucLC,
														byte ucEncryptionMode,
														byte ucSourceSectorNumber,
														byte ucSourceBlockNumber,
														byte ucDestinationSectorNumber,
														byte ucDestinationBlockNumber,
														uint dwValue,
														ref byte ucSW1,
														ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_Restore(IntPtr pReader,
											byte ucLC,
											byte ucEncryptionMode,
											byte ucSourceSectorNumber,
											byte ucSourceBlockNumber,
											ref byte ucSW1,
											ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_ProximityCheck(IntPtr pReader,
													byte ucLC,
													byte  ucKeyNumber,
													byte  ucKeyVersion,
													byte  ucLenDiv,
													IntPtr pbDiv,
													ref byte ucSW1,
													ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_VirtualCardSupport(IntPtr pReader,
														byte ucLC,
														byte ucIIDCount,
														IntPtr IIDs,
														byte ucLenCap,
														IntPtr pbPcdCap,
														byte ucDuosCount,
														/*IN CLSCRF_SAM_VC_DUO**/ IntPtr Duos,
														IntPtr pbRndQ,
														IntPtr pucInfo,
														IntPtr pbPiccCap,
														IntPtr pbUID,
														ref byte ucSW1,
														ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_VirtualCardSelect(IntPtr pReader,
														byte ucLC,
														byte  ucKeyNumber,
														byte  ucKeyVersion,
														IntPtr pbRndQ,
														byte  ucLenDiv,
														IntPtr pbDiv,
														ref byte ucSW1,
														ref byte ucSW2 );

        [DllImport(ClscrflDll)]
        public static extern uint CLSCRF_SAM_MifarePlus_VirtualCardDeselect(IntPtr pReader,
														byte ucLC,
														ref byte ucSW1,
														ref byte ucSW2 );


        /// <summary>
        /// Код внутренней ошибки
        /// </summary>
        public const UInt32 InternalError = 0x80100001;
        /// <summary>
        /// Код успешного выполнения
        /// </summary>
        public const int RES_SUSSESS = 0x00;
        /// <summary>
        /// Состояние индикатора
        /// </summary>
        public enum IndicatorState
        {
            Off = 0x00,
            Green = 0x01,
            Red = 0x02,
            Yellow = 0x03
        };
        /// <summary>
        /// Преобразование массива байт в строку HEX символов
        /// </summary>
        /// <param name="ba"></param>
        /// <returns></returns>
        public static string ByteArrayToHexString(byte[] byteArray)
        {
            StringBuilder hex = new StringBuilder(byteArray.Length * 2);
            foreach (byte b in byteArray)
                hex.AppendFormat("{0:X2}", b);
            return hex.ToString();
        }
        /// <summary>
        /// Преобразование строки HEX символов в массив байт
        /// </summary>
        /// <param name="hexString"></param>
        /// <returns></returns>
        public static byte[] HexStringToByteArray(string hexString)
        {
            if (hexString.Length % 2 != 0)
            {
                throw new ArgumentException(String.Format(System.Globalization.CultureInfo.InvariantCulture, "The binary key cannot have an odd number of digits: {0}", hexString));
            }

            byte[] data = new byte[hexString.Length / 2];
            for (int index = 0; index < data.Length; index++)
            {
                string byteValue = hexString.Substring(index * 2, 2);
                data[index] = byte.Parse(byteValue, System.Globalization.NumberStyles.HexNumber, System.Globalization.CultureInfo.InvariantCulture);
            }

            return data;
        }
        /// <summary>
        /// Бросает исключение
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="result"></param>
        private static void ThrowException(IntPtr handle, uint result)
        {
            if (result == InternalError)
            {
                //throw new CardReaderException("Ошибка внуреняя: " + LastInternalError(handle).ToString("X2"));
            }
            else
            {
                //throw new CardReaderException("Ошибка: " + result.ToString("X8"));
            }
        }
        /// <summary>
        /// Создание интерфейса
        /// </summary>
        /// <param name="handle"></param>
        internal static void Create(ref IntPtr handle)
        {
            //string path = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            //Console.WriteLine(System.IO.File.Exists(path + "\\" + ClscrflDll) ? "File exists." : "File does not exist.");
            var lowLevelResult = CLSCRF_Create(ref handle);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Открытие интерфейса USB
        /// </summary>
        /// <param name="handle"></param>
        internal static void OpenUSB(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_OpenUSB(handle, 0, 0);
            if (lowLevelResult != 0)
            {
                ThrowException(handle, lowLevelResult);
            }
        }
        /// <summary>
        /// Преобразование названия порта в номер
        /// </summary>
        /// <param name="port"></param>
        /// <returns></returns>
        internal static byte ConvertCOM(string port)
        {
            byte result = 0;
            if (port.ToUpper().StartsWith("COM"))
            {
                try
                {
                    result = byte.Parse(port.Substring(3));
                }
                catch (Exception e)
                {
                    //throw new CardReaderException("Параметр порта должен быть вида COM1", e);
                }
            }
            else
            {
                //throw new CardReaderException("Параметр порта должен быть вида COM1");
            }
            return result;
        }
        /// <summary>
        /// Откртие интерфейса COM
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="port"></param>
        /// <returns></returns>
        internal static uint OpenCom(IntPtr handle, string port)
        {
            var portNo = ConvertCOM(port);
            var lowLevelResult = CLSCRF_OpenRS(handle, portNo, 9600, 0);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Получение полследнего ошибочного состояния при внутреней ошибке
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte LastInternalError(IntPtr handle)
        {
            byte result = 0;

            if (CLSCRF_GetLastInternalError(handle, ref result) != 0)
            {
                result = 0;
            }
            return result;
        }
        /// <summary>
        /// Помигать индикатором
        /// </summary>
        /// <param name="handle"></param>
        public static uint Blink(IntPtr handle)
        {
            var lowLevelResult = CLSCRF_Led(handle, (byte)IndicatorState.Yellow, 3, (byte)IndicatorState.Off);
//             if (lowLevelResult != Ok)
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Попищать
        /// </summary>
        /// <param name="handle"></param>
        public static uint Sound(IntPtr handle)
        {
            byte nCount = 3;
            var lowLevelResult = CLSCRF_Sound(handle, nCount);
//             if (lowLevelResult != Ok)
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Включить микросхему считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static uint ReaderOn(IntPtr handle)
        {
            uint res = CLSCRF_Mfrc_On(handle);
            if (res != 0)
            {
                Thread.Sleep(200);
                res = CLSCRF_Mfrc_On(handle);
//                 if (res != 0)
//                 {
//                     ThrowException(handle, on);
//                     return false;
//                 }
            }
            return res;
        }
        /// <summary>
        /// Выключить микросхему считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static uint ReaderOff(IntPtr handle)
        {
            var res = CLSCRF_Mfrc_Off(handle);
//             if (on != Ok)
//             {
//                 ThrowException(handle, on);
//                 return false;
//             }
            return res;
        }
        /// <summary>
        /// Включить радиополе считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static uint ReaderRfOn(IntPtr handle)
        {
            var res = CLSCRF_Mfrc_Rf_Off_On(handle, 10);
//             if (on != Ok)
//             {
//                 ThrowException(handle, on);
//                 return false;
//             }
            return res;
        }
        /// <summary>
        /// Выключить радиополе считывателя
        /// </summary>
        /// <param name="handle"></param>
        internal static uint ReaderRfOff(IntPtr handle)
        {
            uint res = CLSCRF_Mfrc_Rf_Off_On(handle, 0);
//             if (on != Ok)
//             {
//                 ThrowException(handle, on);
//                 return false;
//             }
            return res;
        }
        /// <summary>
        /// Получить версию считывателя
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static string GetVersion(IntPtr handle)
        {
            var pbMfrcVersion = Marshal.AllocHGlobal(6);
            byte[] version = new byte[6];
            var sb = new StringBuilder();
            var lowLevelResult = CLSCRF_Get_Mfrc_Version(handle, pbMfrcVersion);
            Marshal.Copy(pbMfrcVersion, version, 0, 6);
            if (lowLevelResult != RES_SUSSESS)
            {
                //ThrowException(handle, lowLevelResult);
                return "";
            }
            for (int i = 0; i < version.Length; i++)
            {
                sb.AppendFormat(" {0:X2}", version[i]);
            }
            Marshal.FreeHGlobal(pbMfrcVersion);
            return sb.ToString();
        }
        /// <summary>
        /// Получить состояние микросхемы считывателя
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static string GetState(IntPtr handle)
        {
            uint state = 0;
            //var state = Marshal.AllocHGlobal(4);
            var result = CLSCRF_GetState(handle, ref state);
            //var resstate = new byte[4];
            //var sb = new StringBuilder();
            //Marshal.Copy(state, resstate, 0, 4);
            if (result != 0)
            {
                return result.ToString("X8");
            }
            //Marshal.FreeHGlobal(state);
            //for (int i = 0; i < resstate.Length; i++)
            //{
            //    sb.AppendFormat(" {0:X2}", resstate[i]);
            //}
            //return sb.ToString();
            return state.ToString("X8");
        }
        /// <summary>
        /// Получить состояние в массив
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] GetStateBytes(IntPtr handle)
        {
            //var state = Marshal.AllocHGlobal(4);
            uint state = 0;
            var result = CLSCRF_GetState(handle, ref state);
            //var resstate = new byte[4];
            //var sb = new StringBuilder();
            //Marshal.Copy(IntPtr(state), resstate, 0, 4);
            var resstate = BitConverter.GetBytes(state);
            if (result != 0)
            {
                return null;
            }
            //Marshal.FreeHGlobal(state);
            return resstate;
        }
        /// <summary>
        /// Установить режим ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint SetRFMode14443A(IntPtr handle)
        {
            uint lowLevelResult = CLSCRF_Mfrc_Set_Rf_Mode(handle, (byte)0x00);
//             if (lowLevelResult != Ok)
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Установить режим ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint SetRFMode15693(IntPtr handle)
        {
            uint lowLevelResult = CLSCRF_Mfrc_Set_Rf_Mode(handle, (byte)0x40);
//             if (lowLevelResult != Ok)
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Подключиться к карте типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ConnectToCard14443A(IntPtr handle)
        {
            //var pbATQ = Marshal.AllocHGlobal(2);
            ushort ATQ = 0;
            //var pbSAK = Marshal.AllocHGlobal(1);
            byte SAK = 0;
            var pbUID = Marshal.AllocHGlobal(10);
            uint dwUIDLength = 7;
            //var aia_r = CLSCRF_Activate_Idle_A(handle, pbATQ, pbSAK, pbUID, ref dwUIDLength);
            var aia_r = CLSCRF_Activate_Idle_A(handle, ref ATQ, ref SAK, pbUID, ref dwUIDLength);
            byte[] result;
            if (aia_r == 0)
            {
                result = new byte[dwUIDLength];
                Marshal.Copy(pbUID, result, 0, (int)dwUIDLength);
            }
            else
            {
                result = null;
            }
            //Marshal.FreeHGlobal(pbATQ);
            //Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Приостановить карту типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint HaltCard14443A(IntPtr handle)
        {
            uint res = CLSCRF_Halt_A(handle);
            return res;
        }
        /// <summary>
        /// Разбудить карту типа ISO14443A
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint WakeupCard14443A(IntPtr handle, byte[] uid)
        {
            //var pbATQ = Marshal.AllocHGlobal(2);
            ushort ATQ = 0;
            //var pbSAK = Marshal.AllocHGlobal(1);
            byte SAK = 0;
            var pbUID = Marshal.AllocHGlobal(10);
            uint dwUIDLength = (uint)uid.Length;
            Marshal.Copy(uid, 0, pbUID, uid.Length);
            uint res = CLSCRF_Activate_Wakeup_A(handle, pbUID, dwUIDLength, ref ATQ, ref SAK);
            //Marshal.FreeHGlobal(pbATQ);
            //Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return res;
        }
        /// <summary>
        /// Признак поддержки стандарта ISO18092
        /// </summary>
        public static bool _fISO18092 = false;
        /// <summary>
        /// Признак поддержки стандарта NFC Forum Tag Type #
        /// </summary>
        public static byte _ucTagType = 0;
        /// <summary>
        /// Подключиться к карте
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ConnectToCard(IntPtr handle)
        {
            //var pbATQ = Marshal.AllocHGlobal(2);
            ushort ATQ = 0;
            //var pbSAK = Marshal.AllocHGlobal(1);
            byte SAK = 0;
            var pbUID = Marshal.AllocHGlobal(10);
            uint pdwUIDLength = 7;
            uint Status = CLSCRF_Activate_Idle_A(handle, ref ATQ, ref SAK, pbUID, ref pdwUIDLength);
            byte[] result;
            if (Status == 0)
            {
                result = new byte[pdwUIDLength];
                Marshal.Copy(pbUID, result, 0, (int)pdwUIDLength);

                //_fISO18092 = ((Marshal.ReadByte(pbSAK) & 0x44) == 0x40);
                _fISO18092 = ((SAK & 0x44) == 0x40);

                //CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(handle, pbATQ, Marshal.ReadByte(pbSAK), ref _ucTagType);
                CLSCRF_NFC_ForumTags_SupposeTypeISO14443A(handle, ref ATQ, SAK, ref _ucTagType);

                //_fTagType2 = (Marshal.ReadByte(pbSAK) == 0x00 && Marshal.ReadByte(pbATQ, 0) == 0x44 && Marshal.ReadByte(pbATQ, 1) == 0x00);
                //_fTagType4 = (Marshal.ReadByte(pbSAK) == 0x20 && Marshal.ReadByte(pbATQ, 0) == 0x44 && Marshal.ReadByte(pbATQ, 1) == 0x03);

                if (_ucTagType == 4)
                {
                    //byte CID = 0;
                    //var pbATS = Marshal.AllocHGlobal(37);

                    //Status = CLSCRF_ISO14443A_4_RATS(handle, CID, pbATS);

                    //Marshal.FreeHGlobal(pbATS);

                    //if (Status != 0)
                    //    return null;

                    //Status = CLSCRF_ISO14443A_4_PPS(handle, CID, 0 );
                    //if (Status != 0)
                    //    return null;

                    //Status = CLSCRF_Mfrc_Set_Rf_Mode(handle, 0 );
                    //if (Status != 0)
                    //    return null;

                    Status = CLSCRF_NFC_ForumTags_BeginType4(handle);
                    if (Status != 0)
                        return null;
                }
            }
            else
            {
                result = null;
            }
            //Marshal.FreeHGlobal(pbATQ);
            //Marshal.FreeHGlobal(pbSAK);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Подключиться к карте
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint RequestAnswerToSelect(IntPtr handle)
        {
            byte CID = 0;
            var pbATS = Marshal.AllocHGlobal(37);
            uint Status = 0;

            Status = CLSCRF_ISO14443A_4_RATS(handle, CID, pbATS);

            Marshal.FreeHGlobal(pbATS);

            return Status;
        }
        /// <summary>
        /// Загрузка ключа в ридер (Flash)
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="address"></param>
        /// <param name="keyType"></param>
        /// <param name="data"></param>
        internal static uint WriteFlashValue(IntPtr handle, byte address, byte[] data)
        {
            var pbData = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbData, 16);
            uint lowLevelResult = CLSCRF_WriteFlashValue(handle, address, pbData);
            Marshal.FreeHGlobal(pbData);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }     
        /// <summary>
        /// Загрузка ключа в ридер (EEPROM)
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static uint MifareStandardLoadKey(IntPtr handle, byte sector, byte keyType, byte[] key)
        {
            var pbKey = Marshal.AllocHGlobal(6);
            Marshal.Copy(key, 0, pbKey, 6);
            uint lowLevelResult = CLSCRF_MifareStandard_WriteKeyToE2(handle, keyType, sector, pbKey);
            Marshal.FreeHGlobal(pbKey);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Загрузка ключа в ридер по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static uint MifareStandardLoadKeyAddress(IntPtr handle, int address, byte keyType, byte[] key)
        {
            byte sector = AddressToSector(address);
            return MifareStandardLoadKey(handle, sector, keyType, key);
        }
        /// <summary>
        /// Авторизоваться к сектору
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static uint MifareStandardAuth(IntPtr handle, byte keyType, byte[] UID, byte sector)
        {
            var result = false;
            var pbUID = Marshal.AllocHGlobal(UID.Length);
            Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            uint lowLevelResult = CLSCRF_MifareStandard_AuthE2(handle, keyType, pbUID, sector);
            Marshal.FreeHGlobal(pbUID);
//             if (lowLevelResult == 0)
//             {
//                 result = true;
//             }
//             else
//             {
//                 ThrowException(handle, lowLevelResult);
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Авторизоваться к сектору по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="keyType"></param>
        /// <param name="key"></param>
        internal static uint MifareStandardAuthAddress(IntPtr handle, byte keyType, byte[] UID, int address)
        {
            byte sector = AddressToSector(address);
            return MifareStandardAuth(handle, keyType, UID, sector);
        }
        /// <summary>
        /// Считать данные MifareStandard
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareStandardRead(IntPtr handle, byte sector, byte block)
        {
            var pbRecvBuffer = Marshal.AllocHGlobal(16);
            var result = new byte[16];
            var lowLevelResult = CLSCRF_MifareStandard_Read(handle, sector, block, pbRecvBuffer);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbRecvBuffer, result, 0, 16);
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                result = null;
                //ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Считать данные MifareStandard по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareStandardReadAddress(IntPtr handle, int address)
        {
            byte sector = AddressToSector((int)address);
            byte block = AddressToBlock((int)address);
            return MifareStandardRead(handle, sector, block);
        }
        /// <summary>
        /// Запись блока MifareStandard
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifareStandardWrite(IntPtr handle, byte sector, byte block, byte[] data)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbSendBuffer, 16);
            uint lowLevelResult = CLSCRF_MifareStandard_Write(handle, sector, block, pbSendBuffer);
            Marshal.FreeHGlobal(pbSendBuffer);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Запись блока MifareStandard по адресу
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifareStandardWriteAddress(IntPtr handle, int address, byte[] data)
        {
            byte sector = AddressToSector((int)address);
            byte block = AddressToBlock((int)address);
            return MifareStandardWrite(handle, sector, block, data);
        }
        private static bool _fBNBit = false;
        /// <summary>
        /// Считать страницу MifareUltralight
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareUltralightRead(IntPtr handle, byte page)
        {
            var pbRecvBuffer = Marshal.AllocHGlobal(16);
            var result = new byte[16];
            var lowLevelResult = CLSCRF_MifareUltralight_Read(handle, page, pbRecvBuffer);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbRecvBuffer, result, 0, 16);
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                result = null;
                //ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Запись страницу MifareUltralight
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifareUltralightWrite(IntPtr handle, byte page, byte[] data)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbSendBuffer, 16);
            uint lowLevelResult = CLSCRF_MifareUltralight_Write(handle, page, pbSendBuffer);
            Marshal.FreeHGlobal(pbSendBuffer);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Прочитать счетчик MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint MifareUltralightEV1ReadCounter(IntPtr handle, int counter, ref uint value)
        {
            var lowLevelResult = CLSCRF_MifareUltralightEV1_ReadCounter(handle, (byte)counter, ref value);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }

            return lowLevelResult;
        }
        /// <summary>
        /// Инкрементировать счетчик MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint MifareUltralightEV1IncrementCounter(IntPtr handle, int counter, uint value)
        {
            uint lowLevelResult = CLSCRF_MifareUltralightEV1_IncrementCounter(handle, (byte)counter, value);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }

            return lowLevelResult;
        }
        /// <summary>
        /// Вычитать версию MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifareUltralightEV1GetVersion(IntPtr handle)
        {
            var pbVersion = Marshal.AllocHGlobal(8);
            var result = new byte[8];
            uint lowLevelResult = CLSCRF_MifareUltralightEV1_GetVersion(handle, pbVersion);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbVersion, result, 0, 8);
                Marshal.FreeHGlobal(pbVersion);
            }
            else
            {
                Marshal.FreeHGlobal(pbVersion);
                result = null;
                //ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Аутентификация с MifareUltralight EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint MifareUltralightEV1Authenticate(IntPtr handle, uint password, ref ushort ack)
        {
            uint lowLevelResult = CLSCRF_MifareUltralightEV1_AuthenticatePassword(handle, ref password, ref ack);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return -1;
//             }

            return lowLevelResult;
        }
        /// <summary>
        /// Запись данные персонализации MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifarePlusWritePerso(IntPtr handle, byte valueType, byte sectorNumber, byte blockNumber, byte[] data)
        {
            var pbData = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbData, 16);
            uint lowLevelResult = CLSCRF_MifarePlus_WritePersoExplicit(handle, valueType, sectorNumber, blockNumber, pbData);
            Marshal.FreeHGlobal(pbData);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Запись данные персонализации MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifarePlusWritePersoByAddress(IntPtr handle, uint address, byte[] data)
        {
            byte valueType = 0x00;
            byte sectorNumber = 0x00;
            byte blockNumber = 0x00;

            /*
            if (address <= 0x007F)
            {
                sectorNumber = (byte)Math.Floor((float)address / 4);
                blockNumber = (byte)(address % 4);
            }
            else if (address <= 0x00FF)
            {
                sectorNumber = (byte)(32 + Math.Floor((float)(address - 0x80) / 16));
                blockNumber = (byte)((address - 0x80) % 16);
            }
            */
            if (address <= 0x00FF)
            {
                sectorNumber = AddressToSector((int)address);
                blockNumber = AddressToBlock((int)address);
            }
            else if (address == 0xB000)
                valueType = 0xB0;
            else if (address == 0xB001)
                valueType = 0xB1;
            else if (address == 0xB002)
                valueType = 0xB2;
            else if (address == 0xB003)
                valueType = 0xB3;
            else if ((0x4000 <= address) && (address <= 0x404F))
            {
                valueType = ((address & 0x00FF) % 2 == 0) ? (byte)0x4A : (byte)0x4B;
                sectorNumber = (byte)Math.Floor((float)(address & 0x00FF) / 2);
            }
            else if (address == 0x8000)
                valueType = 0x80;
            else if (address == 0x9000)
                valueType = 0x90;
            else if (address == 0x9001)
                valueType = 0x91;
            else if (address == 0x9002)
                valueType = 0x92;
            else if (address == 0x9003)
                valueType = 0x93;
            else if (address == 0x9004)
                valueType = 0x94;
            else if (address == 0xA000)
                valueType = 0xA0;
            else if (address == 0xA001)
                valueType = 0xA1;
            else if (address == 0xA080)
                valueType = 0xA2;
            else if (address == 0xA081)
                valueType = 0xA3;

            var pbData = Marshal.AllocHGlobal(16);
            Marshal.Copy(data, 0, pbData, 16);
            uint lowLevelResult = CLSCRF_MifarePlus_WritePersoExplicit(handle, valueType, sectorNumber, blockNumber, pbData);
            Marshal.FreeHGlobal(pbData);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }
        /// <summary>
        /// Завершение персонализации MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint MifarePlusCommitPerso(IntPtr handle)
        {
            uint Status = 0;

            Status = CLSCRF_MifarePlus_CommitPerso(handle);

            return Status;
        }
        /// <summary>
        /// Переинициализация T=CL ISO14443-4
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static void InitTCL()
        {
            _fBNBit = false;
        }

        /// <summary>
        /// Аутентификация MifarePlus расширенная
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint MifarePlus_Authenticate(IntPtr handle, byte keyType, byte sectorNumber, ushort keyFlashAddress)
        {
            uint Status = 0;

            byte[] PCDCap = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
            var pPCDCap = Marshal.AllocHGlobal(PCDCap.Length);
            Marshal.Copy(PCDCap, 0, new IntPtr(pPCDCap.ToInt64()), PCDCap.Length);
            var pRCOut = Marshal.AllocHGlobal(6);
            var pTCOut = Marshal.AllocHGlobal(6);
            Status = CLSCRF_MifarePlus_Authenticate(handle, 0x01, keyType, sectorNumber, keyFlashAddress, 0x06, pPCDCap);

            return Status;
        }

        /// <summary>
        /// Аутентификация MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint MifarePlus_AuthenticateA(IntPtr handle, byte sectorNumber, ushort keyFlashAddress)
        {
            return MifarePlus_Authenticate(handle, 0x4A, sectorNumber, keyFlashAddress);
        }

        /// <summary>
        /// Считать данные MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] MifarePlusReadData(IntPtr handle, byte encMode, byte valType, byte sector, byte block, byte blkCount)
        {
            var pbRecvBuffer = Marshal.AllocHGlobal(16);
            var result = new byte[16 * blkCount];
            var lowLevelResult = CLSCRF_MifarePlus_ReadData(handle, encMode, valType, sector, block, blkCount, pbRecvBuffer);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbRecvBuffer, result, 0, 16 * blkCount);
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                result = null;
                //ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Запись блока MifarePlus
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <param name="data"></param>
        internal static uint MifarePlusWriteData(IntPtr handle, byte encMode, byte valType, byte sector, byte block, byte blkCount, byte[] data)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(16 * blkCount);
            Marshal.Copy(data, 0, pbSendBuffer, 16 * blkCount);
            uint lowLevelResult = CLSCRF_MifarePlus_WriteData(handle, encMode, valType, sector, block, blkCount, pbSendBuffer);
            Marshal.FreeHGlobal(pbSendBuffer);
//             if (lowLevelResult != 0)
//             {
//                 ThrowException(handle, lowLevelResult);
//                 return false;
//             }
            return lowLevelResult;
        }

        /// <summary>
        /// Аутентификация MifarePlus EV1
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint MifarePlusEV1_AuthenticateA(IntPtr handle, byte sectorNumber, ushort keyFlashAddress)
        {
            uint Status = 0;

            byte[] PCDCap = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
            var pPCDCap = Marshal.AllocHGlobal(PCDCap.Length);
            Marshal.Copy(PCDCap, 0, new IntPtr(pPCDCap.ToInt64()), PCDCap.Length);
            var pRCOut = Marshal.AllocHGlobal(6);
            var pTCOut = Marshal.AllocHGlobal(6);
            Status = CLSCRF_MifarePlusEV1_Authenticate(handle, 0x03, 0x01, 0x01, 0x4A, sectorNumber, keyFlashAddress, 0x00, IntPtr.Zero, 0x06, pPCDCap, pRCOut, pTCOut);

            return Status;
        }
        /// <summary>
        /// Приемопередача T=CL ISO14443-4
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint TransceiveTCL(IntPtr handle, byte[] dataSend, ref byte[] dataRecv)
        {
            var pbSendBuffer = Marshal.AllocHGlobal(dataSend.Length + 2);
            Marshal.Copy(dataSend, 0, new IntPtr(pbSendBuffer.ToInt64() + 2), dataSend.Length);
            if (_fBNBit)
                Marshal.WriteByte(pbSendBuffer, 0x0B);
            else
                Marshal.WriteByte(pbSendBuffer, 0x0A);
            Marshal.WriteByte(new IntPtr(pbSendBuffer.ToInt64() + 1), 0x00);
            uint uiRecvLength = 1024;
            var pbRecvBuffer = Marshal.AllocHGlobal((int)uiRecvLength);
            uint lowLevelResult = CLSCRF_DirectIO_Card(handle, pbSendBuffer, (uint)dataSend.Length + 2, 1000, pbRecvBuffer, ref uiRecvLength);
            Marshal.FreeHGlobal(pbSendBuffer);
            _fBNBit = !_fBNBit;
            if (lowLevelResult == 0)
            {
                if (uiRecvLength > 2)
                {
                    dataRecv = new byte[uiRecvLength - 2];
                    Marshal.Copy(new IntPtr(pbRecvBuffer.ToInt64() + 2), dataRecv, 0, (int)uiRecvLength - 2);
                }
                Marshal.FreeHGlobal(pbRecvBuffer);
            }
            else
            {
                Marshal.FreeHGlobal(pbRecvBuffer);
                //ThrowException(handle, lowLevelResult);
            }

            return lowLevelResult;
        }

        /// <summary>
        /// Найти все карты типа ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] FindAllTags15693(IntPtr handle)
        {
            var pbData = Marshal.AllocHGlobal(1024);
            uint dwDataLength = 1024;
            uint res = CLSCRF_FindAllTags_15693(handle, 0x00, 0x00, pbData, ref dwDataLength);
            byte[] result;
            if (res == 0)
            {
                result = new byte[dwDataLength];
                Marshal.Copy(pbData, result, 0, (int)dwDataLength);
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbData);
            return result;
        }
        /// <summary>
        /// Считать несколько блоков из карт стандарта ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static byte[] ReadMultipleBlocksISO15693(IntPtr handle, byte[] UID, byte ucFirstBlockNumber, byte ucNumberOfBlocks)
        {
            var pbBlockSecurityStatus = Marshal.AllocHGlobal(1024);
            var pbData = Marshal.AllocHGlobal(1024);
            var pbUID = Marshal.AllocHGlobal(10);
            byte ucOutFlags = 0;
            byte ucErrorCode = 0;
            Marshal.Copy(UID, 0, pbUID, UID.Length);
            uint res = CLSCRF_ReadMultipleBlocks_15693(handle,
                                                        0x62,
                                                        0x23,
                                                        pbUID,
                                                        ucFirstBlockNumber,
                                                        ref ucNumberOfBlocks,
                                                        ref ucOutFlags,
                                                        pbBlockSecurityStatus,
                                                        pbData,
                                                        ref ucErrorCode);
            byte[] result;
            if ((res == 0) && (ucErrorCode == 0x00))
            {
                result = new byte[ucNumberOfBlocks * 4];
                Marshal.Copy(pbData, result, 0, (int)ucNumberOfBlocks * 4);
            }
            else
            {
                result = null;
            }
            Marshal.FreeHGlobal(pbBlockSecurityStatus);
            Marshal.FreeHGlobal(pbData);
            Marshal.FreeHGlobal(pbUID);
            return result;
        }
        /// <summary>
        /// Записать несколько блоков на карту стандарта ISO15693
        /// </summary>
        /// <param name="handle"></param>
        /// <returns></returns>
        public static uint WriteMultipleBlocksISO15693(IntPtr handle, byte[] UID, byte ucFirstBlockNumber, byte ucNumberOfBlocks, byte[] Data)
        {
            var pbData = Marshal.AllocHGlobal(1024);
            var pbUID = Marshal.AllocHGlobal(10);
            byte ucInFlags = 0;
            byte ucOutFlags = 0;
            byte ucErrorCode = 0;
            Marshal.Copy(UID, 0, pbUID, UID.Length);
            Marshal.Copy(Data, 0, pbData, ucNumberOfBlocks * 4);

            if (UID[6] == 0x07)
                ucInFlags = 0x62;
            else
                ucInFlags = 0x22;

            uint res = 0;
            for (byte i = 0; i < ucNumberOfBlocks; i++)
            {
                res = CLSCRF_WriteSingleBlock_15693(handle,
                                                            ucInFlags,
                                                            0x21,
                                                            pbUID,
                                                            (byte)(ucFirstBlockNumber + i),
                                                            new IntPtr(pbData.ToInt64() + i * 4),
                                                            ref ucOutFlags,
                                                            ref ucErrorCode);
                if ((res != 0) || (ucErrorCode != 0x00))
                {
                    //Marshal.FreeHGlobal(pbData);
                    //Marshal.FreeHGlobal(pbUID);
                    //ThrowException(handle, aia_r);
                    break;
                }
            }
            Marshal.FreeHGlobal(pbData);
            Marshal.FreeHGlobal(pbUID);

            return res;
        }
        /// <summary>
        /// Сменить текущий холдер SAM-модуля
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static uint SAMSetHolder(IntPtr handle, byte holder)
        {
            var lowLevelResult = CLSCRF_SAM_SetCurrentHolder(handle, holder);
            return lowLevelResult;
        }
        /// <summary>
        /// Считать версию SAM-модуля
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="sector"></param>
        /// <param name="block"></param>
        /// <returns></returns>
        public static byte[] SAMGetVersion(IntPtr handle, byte logicalChannel)
        {
            var pbVersion = Marshal.AllocHGlobal(256);
            var result = new byte[31];
            byte SW1 = 0x00;
            byte SW2 = 0x00;
            var lowLevelResult = CLSCRF_SAM_GetVersion(handle, logicalChannel, pbVersion, ref SW1, ref SW2);
            if (lowLevelResult == 0)
            {
                Marshal.Copy(pbVersion, result, 0, 31);
                Marshal.FreeHGlobal(pbVersion);
            }
            else
            {
                Marshal.FreeHGlobal(pbVersion);
                result = null;
                //ThrowException(handle, lowLevelResult);
            }

            return result;
        }
        /// <summary>
        /// Изменить ключ в SAM-модуле
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static uint SAMChangeKeyEntryPICC(IntPtr handle, byte logicalChannel, byte keyKind, byte keyNo, byte keyPos, byte keyVer, byte[] key)
        {
            byte keyVersionA = 0x00;
            byte keyVersionB = 0x00;
            byte keyVersionC = 0x00;
            uint desFireAID = 0;
            byte desFireKeyNo = 0x00;
            byte keyNoCEK = 0x00;
            byte keyVerCEK = 0x00;
            byte refNoKUC = 0x00;
            ushort settings = 0x0000;
            byte extSettings = 0x00;
            byte SW1 = 0x00;
            byte SW2 = 0x00;

            //byte sector = AddressToSector(address);
            //var pbUID = Marshal.AllocHGlobal(UID.Length);
            //Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            uint lowLevelResult = CLSCRF_SAM_GetKeyEntry(
                handle, 
                logicalChannel, 
                keyKind, 
                keyNo, 
                ref keyVersionA, 
                ref keyVersionB, 
                ref keyVersionC, 
                ref desFireAID, 
                ref desFireKeyNo,
                ref keyNoCEK,
                ref keyVerCEK,
                ref refNoKUC,
                ref settings,
                ref extSettings,
                ref SW1, 
                ref SW2);
            //Marshal.FreeHGlobal(pbUID);
            if (lowLevelResult != 0)
            {
                //ThrowException(handle, lowLevelResult);
                return lowLevelResult;
            }

            keyVersionA = keyVer;// 0x00;
            keyVersionB = keyVer;// 0x01;
            keyVersionC = keyVer;// 0x02;

            settings = (ushort)(settings & 0xFDFF); //активация ключа

            extSettings = (byte)(extSettings & 0xF8 | 0x01); //тип ключа - PICC

            byte programmingMask = (byte)(0xF8 | (0x01 << keyPos)); //выбор позиции ключа: 0,1,2

            byte[] SAMUID = new byte[7];
            var pbSAM_UID = Marshal.AllocHGlobal(SAMUID.Length);
            Marshal.Copy(SAMUID, 0, pbSAM_UID, SAMUID.Length);
            var pbKeyA = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyA, SAMUID.Length);
            var pbKeyB = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyB, SAMUID.Length);
            var pbKeyC = Marshal.AllocHGlobal(16);
            Marshal.Copy(key, 0, pbKeyC, SAMUID.Length);
            lowLevelResult = CLSCRF_SAM_ChangeKeyEntry(
                handle, 
                logicalChannel,
                keyNo,
                keyKind,
                pbKeyA,
                pbKeyB,
                pbKeyC,
                desFireAID,
                desFireKeyNo,
                keyNoCEK,
                keyVerCEK,
                refNoKUC,
                ref settings,
                keyVersionA,
                keyVersionB,
                keyVersionC,
                ref extSettings,
                0x00000001,
                0x00000000,
                pbSAM_UID,
                ref programmingMask,
                ref SW1, 
                ref SW2
                );
            Marshal.FreeHGlobal(pbKeyA);
            Marshal.FreeHGlobal(pbKeyB);
            Marshal.FreeHGlobal(pbKeyC);
            Marshal.FreeHGlobal(pbSAM_UID);
            return lowLevelResult;
        }
        /// <summary>
        /// Изменить ключи Mifare Standard в SAM-модуле
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static uint SAMChangeKeyEntryMifareStandard(IntPtr handle, byte logicalChannel, byte keyNo, byte keyPos, byte keyVer, byte[] keyA, byte[] keyB)
        {
            byte[] key = new byte[16];
            keyA.CopyTo(key, 0);
            keyB.CopyTo(key, 8);
            return SAMChangeKeyEntryPICC(handle, logicalChannel, 0x02, keyNo, keyPos, keyVer, key);
        }
        /// <summary>
        /// Авторизоваться к сектору Mifare Classic через SAM
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="keyType"></param>
        /// <param name="UID"></param>
        /// <param name="sector"></param>
        /// <returns></returns>
        public static uint SAMMifareStandardAuth(IntPtr handle, byte logicalChannel, byte authType, byte keyType, byte keyNo, byte keyVer, byte[] UID, int address)
        {
            byte SW1 = 0x00;
            byte SW2 = 0x00;
            byte sector = AddressToSector(address);
            var pbUID = Marshal.AllocHGlobal(UID.Length);
            Marshal.Copy(UID, UID.Length - 4, pbUID, 4);
            uint lowLevelResult = CLSCRF_SAM_MifareAuthenticate(handle, logicalChannel, authType, pbUID, keyNo, keyVer, keyType, sector, ref SW1, ref SW2);
            Marshal.FreeHGlobal(pbUID);
            return lowLevelResult;
        }

        public static byte AddressToSector(int address)
        {
            if (address <= 0x007F)
                return (byte)Math.Floor((float)address / 4);
            else if (address <= 0x00FF)
                return (byte)(32 + Math.Floor((float)(address - 0x80) / 16));
            return 0xFF;
        }

        public static byte AddressToBlock(int address)
        {
            if (address <= 0x007F)
                return (byte)(address % 4);
            else if (address <= 0x00FF)
                return (byte)((address - 0x80) % 16);
            return 0xFF;
        }


    }
}
