package ru.microem.clescar;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import ru.microem.clscrfl.Clscrfl;
import ru.microem.clscrfl.Clscrfl.ClscrflException;

import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JToolBar;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JList;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

public class CLESCAR {

	private JFrame frame;

	private Clscrfl clscrfl = null;
	
	private boolean isOpened = false;

	private TaskAutosearch taskAutosearch;
	private Thread threadAutosearch;
	
	private JButton btnOpen;

	private JComboBox cbInterface;

	private JLabel lblResult;

	private JList listCards;
	
	private DefaultListModel listCardsModel;
	
	public static CLESCAR mainWindow;

	public byte[] lastUID = null;

	private JLabel lblVersion;

	private JLabel lblSerial;
	private JTextField txtKeyA;
	private JTextField txtKeyB;
	private JTextField textData;

	private JSpinner spinnerRecord;

	private JSpinner spinnerSector;

	private JSpinner spinnerBlock;

	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					mainWindow = new CLESCAR();
					mainWindow.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public CLESCAR() {
    	try {
			clscrfl = new Clscrfl();
			clscrfl.setVerboseOutput(true);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	taskAutosearch = new TaskAutosearch(clscrfl);
    	threadAutosearch = new Thread(taskAutosearch);
        threadAutosearch.start();
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				onWindowClosing();
			}
		});
		frame.setBounds(100, 100, 450, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		frame.getContentPane().add(tabbedPane, BorderLayout.CENTER);
		
		JPanel panelInterface = new JPanel();
		tabbedPane.addTab("Interface", null, panelInterface, null);
		panelInterface.setLayout(null);
		
		JLabel lblInterface = new JLabel("Interface:");
		lblInterface.setBounds(12, 12, 70, 15);
		panelInterface.add(lblInterface);
		
		cbInterface = new JComboBox();
		cbInterface.setEnabled(false);
		cbInterface.setModel(new DefaultComboBoxModel(new String[] {"USB0", "USB1", "USB2"}));
		cbInterface.setBounds(100, 7, 96, 24);
		panelInterface.add(cbInterface);
		
		btnOpen = new JButton("Open");
		btnOpen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				onInterfaceClicked();
			}
		});
		btnOpen.setBounds(208, 7, 96, 25);
		panelInterface.add(btnOpen);
		
		JPanel panelAutosearch = new JPanel();
		panelAutosearch.addComponentListener(new ComponentAdapter() {
			@Override
			public void componentShown(ComponentEvent e) {
				onAutosearchToggled(true);
			}
			@Override
			public void componentHidden(ComponentEvent e) {
				onAutosearchToggled(false);
			}
		});

		tabbedPane.addTab("Autosearch", null, panelAutosearch, null);
		
		listCardsModel = new DefaultListModel();
		
		listCards = new JList(listCardsModel);
		panelAutosearch.add(listCards);
		
		JPanel panelReader = new JPanel();
		tabbedPane.addTab("Reader", null, panelReader, null);
		panelReader.setLayout(null);
		
		lblVersion = new JLabel("XXXXXXXXXXXX");
		lblVersion.setBounds(161, 12, 120, 15);
		panelReader.add(lblVersion);
		
		JButton btnGetVersion = new JButton("Get Version:");
		btnGetVersion.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				onGetVersion();
			}
		});
		btnGetVersion.setBounds(12, 12, 131, 25);
		panelReader.add(btnGetVersion);
		
		JButton btnGetSerial = new JButton("Get Serial");
		btnGetSerial.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onGetSerial();
			}
		});
		btnGetSerial.setBounds(12, 44, 131, 25);
		panelReader.add(btnGetSerial);
		
		lblSerial = new JLabel("XXXXXXXX");
		lblSerial.setBounds(161, 49, 108, 15);
		panelReader.add(lblSerial);
		
		JButton btnBeep = new JButton("Beep");
		btnBeep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				onBeep();
			}
		});
		btnBeep.setBounds(12, 77, 131, 25);
		panelReader.add(btnBeep);
		
		JPanel panelMifareClassic = new JPanel();
		tabbedPane.addTab("Mifare Classic", null, panelMifareClassic, null);
		panelMifareClassic.setLayout(null);
		
		JLabel lblSector = new JLabel("Sector");
		lblSector.setBounds(12, 9, 70, 15);
		panelMifareClassic.add(lblSector);
		
		spinnerSector = new JSpinner();
		spinnerSector.setModel(new SpinnerNumberModel(0, 0, null, 1));
		spinnerSector.setBounds(76, 7, 45, 20);
		panelMifareClassic.add(spinnerSector);
		
		JLabel lblKeyA = new JLabel("Key A");
		lblKeyA.setBounds(155, 9, 53, 15);
		panelMifareClassic.add(lblKeyA);
		
		txtKeyA = new JTextField();
		txtKeyA.setText("FFFFFFFFFFFF");
		txtKeyA.setBounds(197, 7, 104, 19);
		panelMifareClassic.add(txtKeyA);
		txtKeyA.setColumns(10);
		
		JLabel lblKeyB = new JLabel("Key B");
		lblKeyB.setBounds(155, 36, 45, 15);
		panelMifareClassic.add(lblKeyB);
		
		txtKeyB = new JTextField();
		txtKeyB.setText("FFFFFFFFFFFF");
		txtKeyB.setBounds(197, 36, 104, 19);
		panelMifareClassic.add(txtKeyB);
		txtKeyB.setColumns(10);
		
		JButton btnAuthenticateA = new JButton("Authenticate A");
		btnAuthenticateA.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onAuthenticateA();
			}
		});
		btnAuthenticateA.setBounds(12, 31, 139, 25);
		panelMifareClassic.add(btnAuthenticateA);
		
		JButton btnAuthenticateB = new JButton("Authenticate B");
		btnAuthenticateB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onAuthenticateB();
			}
		});
		btnAuthenticateB.setBounds(12, 62, 139, 25);
		panelMifareClassic.add(btnAuthenticateB);
		
		JLabel lblBlock = new JLabel("Block");
		lblBlock.setBounds(12, 94, 70, 15);
		panelMifareClassic.add(lblBlock);
		
		spinnerBlock = new JSpinner();
		spinnerBlock.setModel(new SpinnerNumberModel(0, 0, null, 1));
		spinnerBlock.setBounds(76, 92, 45, 20);
		panelMifareClassic.add(spinnerBlock);
		
		JButton btnReadBlock = new JButton("Read Block");
		btnReadBlock.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onReadBlock();
			}
		});
		btnReadBlock.setBounds(136, 89, 117, 25);
		panelMifareClassic.add(btnReadBlock);
		
		JButton btnWriteBlock = new JButton("Write Block");
		btnWriteBlock.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onWriteBlock();
			}
		});
		btnWriteBlock.setBounds(265, 89, 117, 25);
		panelMifareClassic.add(btnWriteBlock);
		
		JLabel lblBlockData = new JLabel("Block data:");
		lblBlockData.setBounds(12, 121, 93, 15);
		panelMifareClassic.add(lblBlockData);
		
		textData = new JTextField();
		textData.setText("00000000000000000000000000000000");
		textData.setBounds(105, 124, 297, 19);
		panelMifareClassic.add(textData);
		textData.setColumns(10);
		
		JButton btnLoadKeys = new JButton("Load Keys");
		btnLoadKeys.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onLoadKeys();
			}
		});
		btnLoadKeys.setBounds(313, 33, 120, 20);
		panelMifareClassic.add(btnLoadKeys);
		
		JLabel lblRecord = new JLabel("Record");
		lblRecord.setBounds(313, 6, 70, 15);
		panelMifareClassic.add(lblRecord);
		
		spinnerRecord = new JSpinner();
		spinnerRecord.setModel(new SpinnerNumberModel(0, 0, null, 1));
		spinnerRecord.setBounds(373, 7, 45, 20);
		panelMifareClassic.add(spinnerRecord);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		frame.getContentPane().add(toolBar, BorderLayout.SOUTH);
		
		JLabel lblLastResult = new JLabel("Last result:");
		toolBar.add(lblLastResult);
		
		lblResult = new JLabel("OK");
		toolBar.add(lblResult);
	}

	protected void onBeep() {
		try {
			clscrfl.beep(1);
		} catch (ClscrflException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	protected void onLoadKeys() {
		try {
			byte[] keyA = Clscrfl.hexToBytes(txtKeyA.getText());
			clscrfl.mifareClassicLoadKeyA((Integer)spinnerRecord.getValue(), keyA);
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		try {
			byte[] keyB = Clscrfl.hexToBytes(txtKeyB.getText());
			clscrfl.mifareClassicLoadKeyB((Integer)spinnerRecord.getValue(), keyB);
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onAuthenticateA() {
		if (lastUID == null) {
			lblResult.setText("Please read a card first");
			return;
		}
		try {
			clscrfl.mifareClassicAuthenticateA(
				(Integer)spinnerSector.getValue(), 
				(Integer)spinnerRecord.getValue(), 
				lastUID);
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onAuthenticateB() {
		if (lastUID == null) {
			lblResult.setText("Please read a card first");
			return;
		}
		try {
			clscrfl.mifareClassicAuthenticateB(
				(Integer)spinnerSector.getValue(), 
				(Integer)spinnerRecord.getValue(), 
				lastUID);
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}
	
	protected void onReadBlock() {
		try {
			byte[] data = clscrfl.mifareClassicRead(
				(Integer)spinnerSector.getValue(), 
				(Integer)spinnerBlock.getValue());
			lblResult.setText("OK");
			textData.setText(Clscrfl.bytesToHex(data));
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onWriteBlock() {
		try {
			byte[] data = Clscrfl.hexToBytes(textData.getText());
			clscrfl.mifareClassicWrite(
				(Integer)spinnerSector.getValue(), 
				(Integer)spinnerBlock.getValue(), 
				data);
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onGetVersion() {
		try {
			byte[] version = clscrfl.getVersion();
			lblVersion.setText(Clscrfl.bytesToHex(version));
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onGetSerial() {
		try {
			byte[] serial = clscrfl.getSerial();
			lblSerial.setText(Clscrfl.bytesToHex(serial));
			lblResult.setText("OK");
		} catch (ClscrflException e) {
			lblResult.setText(e.getFullMessage());
		}
		
	}

	protected void onWindowClosing() {
		taskAutosearch.quit();
	}

	protected void onAutosearchToggled(boolean active) {
		if (active) {
			taskAutosearch.resume();
		} else {
			taskAutosearch.pause();
		}
	}
	
	protected void onInterfaceClicked() {
		if (!isOpened) {
			try {
				clscrfl.OpenUSB(cbInterface.getSelectedIndex());
				lblResult.setText("OK");
				isOpened = true;
				btnOpen.setText("Close");
				clscrfl.beep(1);
			} catch (ClscrflException e) {
				lblResult.setText(e.getFullMessage());
			}
		} else {
			try {
				clscrfl.Close();
			} catch (ClscrflException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			isOpened = false;
			taskAutosearch.pause();
			btnOpen.setText("Open");
		}
	}
	
	public void addCardToList(String cardDescription) {
		this.listCardsModel.addElement(cardDescription);
	}
	
	public void clearCardList() {
		this.listCardsModel.clear();
	}
}
