package ru.microem.clescar;

import ru.microem.clscrfl.Clscrfl;
import ru.microem.clscrfl.Clscrfl.ClscrflException;
import java.util.concurrent.TimeUnit;

public class TaskAutosearch implements Runnable {

	public TaskAutosearch(Clscrfl clscrfl) {
		super();
		this.clscrfl = clscrfl;
	}

	protected boolean isPaused = true;
	protected boolean isExiting = false;
	
	private Clscrfl clscrfl = null;
	
	public void pause() {
		isPaused = true;
	}
	
	public void resume() {
		if (!clscrfl.isOpened()) {
			return;
		}
		try {
			clscrfl.radioChipPowerUp();
			isPaused = false;
		} catch (ClscrflException e) {
			if (clscrfl.isVerboseOutput()) {
				System.out.println(e.getFullMessage());
			}
		}	
	}
	
	public void quit() {
		isExiting = true;
	}
	
	@Override
	public void run() {
		while (!isExiting) {
			while (!isExiting && (isPaused || !clscrfl.isOpened())) {
				try {
					TimeUnit.MILLISECONDS.sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (isExiting) {
				return;
			}
			if (clscrfl.isOpened()) {
				runWorkCycle();
			}
			try {
				TimeUnit.MILLISECONDS.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
		}
	}

	private void runWorkCycle() {
//		System.out.println("running working cycle");
		try {
			//clscrfl.beep(1);
			clscrfl.resetRadioField(10);
			try {
				TimeUnit.MILLISECONDS.sleep(10);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			Clscrfl.ISO14443ACard card = clscrfl.activateIdleA();
			CLESCAR.mainWindow.lastUID = card.UID;
			String cardDescription = "UID: " + Clscrfl.bytesToHex(card.UID) + 
					"   ATQ: " + Clscrfl.bytesToHex(card.ATQ) + 
					"   SAK: " + Integer.toHexString(card.SAK & 0xFF);
			CLESCAR.mainWindow.clearCardList();
			CLESCAR.mainWindow.addCardToList(cardDescription);
		} catch (ClscrflException e) {
			CLESCAR.mainWindow.clearCardList();
			//e.printStackTrace();
			if (clscrfl.isVerboseOutput()) {
				System.out.println(e.getFullMessage());
			}
		}		
	}
	

}
