#include "./StdAfx.h"

#include "./Clscrfl_SAM.h"

#include "./Clscrfl.h"

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_GetCurrentHolder(IN LPVOID pReader,
OUT LPBYTE pucNumHolder)
{
	return CLSCRF_SAM_GetCurrentHolder(pReader, pucNumHolder);
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_SetCurrentHolder(IN LPVOID pReader,
IN BYTE ucNumHolder)
{
	return CLSCRF_SAM_SetCurrentHolder(pReader, ucNumHolder);
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_SetCurrentHolderGetATR(IN  LPVOID pReader,
IN  BYTE ucNumHolder,
IN  DWORD dwATRBufSize,
OUT PBYTE  pATR,
OUT PDWORD pdwATRSize
)
{
	return CLSCRF_SAM_SetCurrentHolderGetATR(pReader, ucNumHolder, dwATRBufSize, pATR, pdwATRSize);
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_SetCurrentHolderEx(IN  LPVOID pReader,
IN  BYTE ucNumHolder,
IN  BYTE ucWT10,
IN  BYTE ucPPS1,
IN  BYTE ucDeactivate,
IN  DWORD dwATRBufSize,
OUT PBYTE  pATR,
OUT PDWORD pdwATRSize
)
{
	return CLSCRF_SAM_SetCurrentHolderEx(pReader, ucNumHolder, ucWT10, ucPPS1, ucDeactivate, dwATRBufSize, pATR, pdwATRSize);
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_GetHoldersInfo(IN  LPVOID pReader,
IN  BYTE ucNumHolder,
OUT CLSCRF_ISO7816_HOLDERS_INFO* pHoldersInfo
)
{
	LONG Status = SCARD_S_SUCCESS;

	if (pReader == NULL)
		return SCARD_E_READER_UNAVAILABLE;

	if (pHoldersInfo == NULL)
		return SCARD_E_INVALID_PARAMETER;

	if (ucNumHolder > 4)
		return SCARD_E_INVALID_PARAMETER;

	ZeroMemory(pHoldersInfo, sizeof(CLSCRF_ISO7816_HOLDERS_INFO));

	CTransfer* pTr = (CTransfer*)pReader;
	pTr->m_TrBuf.Clear();
	pTr->m_TrBuf.AddByte(0xB1);
	pTr->m_TrBuf.AddByte(ucNumHolder);

	Status = pTr->SingleTransceive();

	if (Status != SCARD_S_SUCCESS)
		return Status;

	DWORD Size = pTr->m_RcBuf.GetLength();

	if ((ucNumHolder == 0) && (Size != 5))
		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F
	if ((ucNumHolder > 0) && (Size != 10))
		return SCARD_E_COMM_DATA_LOST;    // 0x8010002F

	if (ucNumHolder == 0)
	{
		Size = sizeof(pHoldersInfo->AllHolders);
		if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)(&pHoldersInfo->AllHolders), &Size))
			return SCARD_E_COMM_DATA_LOST;
	}
	else
	{
		Size = sizeof(pHoldersInfo->SpecifiedHolder);
		if (!pTr->m_RcBuf.GetBulk(1, (LPBYTE)(&pHoldersInfo->SpecifiedHolder), &Size))
			return SCARD_E_COMM_DATA_LOST;
	}

	return SCARD_S_SUCCESS;
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_Reset(IN LPVOID pReader)
{
	return CLSCRF_SAM_Reset(pReader);
}

CLSCRF_API LONG CLSCRF_DECL
CLSCRF_ISO7816_APDU(IN     LPVOID  pReader,
IN     LPCBYTE pbSendBuffer,
IN     DWORD   dwSendLength,
OUT LPBYTE  pbRecvBuffer,
IN OUT LPDWORD pdwRecvLength)
{
	return CLSCRF_SAM_APDU(pReader, pbSendBuffer, dwSendLength, pbRecvBuffer, pdwRecvLength);
}
