#if !defined(CRYPTO_H)
#define CRYPTO_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "types_def.h"

typedef const BYTE *LPCBYTE;

void DFSubkeys(PVOID pReader);

void DFEncrypt(PVOID pReader,
	PBYTE pInput,
	PBYTE pOutput,
	int iSize,
	int* piResultSize = NULL,
	bool f80Padding = false,
	bool calc_mac = false,
	PBYTE crc32Start = NULL,
	int crc32Size = 0);

bool DFDecrypt(PVOID pReader,
	PBYTE pInput,
	PBYTE pOutput,
	int iSize,
	int iExpectedSize = 0,
	int* piResultSize = NULL,
	bool f80Padding = false);

void CryptoSubkeys(PVOID pReader);

void CryptoEncrypt(
	PVOID pReader,
	PBYTE pInput,
	PBYTE pOutput,
	int iSize,
	int* piResultSize = NULL);//, 
//PBYTE crc32Start = NULL, 
//int crc32Size = 0);

bool CryptoDecrypt(
	PVOID pReader,
	PBYTE pInput,
	PBYTE pOutput,
	int iSize,
	int iExpectedSize = 0,
	int* piResultSize = NULL);

#endif // !defined(CRYPTO_H)
