#include "StdAfx.h"
#include "EncMode.h"
#include "Clscrfl.h"
#include "Clscrfl_SAM.h"
#ifdef CLSCRF_DES3
	#include "Clscrfl_DES3.h"
#endif //CLSCRF_DES3

#include "Types.h"

std::map<PVOID, ENC_SETTINGS> ENC_Settings;

LONG AuthenticateReader(LPVOID pReader, BYTE ucKeyNumber, LPBYTE pKey)
{
	LONG Status = SCARD_S_SUCCESS;

	const int BUF_SIZE = 300;
    BYTE SendBuffer[BUF_SIZE];
    BYTE RecvBuffer[BUF_SIZE];
    DWORD SendLength;
    DWORD RecvLength = BUF_SIZE;

	BYTE RndA[16] = {0};
	BYTE RndB[16] = {0};
	BYTE SessionKey[16] = {0};
	int iKeyLength = 16;

	ENC_Settings[pReader].TransferType = ENC_TRANSFER_TYPE_PLAIN;
	ZeroMemory(ENC_Settings[pReader].IV, 16);

	iKeyLength = 16;

	SendBuffer[0] = 0xAA;
	SendBuffer[1] = ucKeyNumber;
	SendLength = 2;
/////////////////
    CTransfer* pTr = (CTransfer*)pReader;
    pTr->m_TrBuf.Clear();
    pTr->m_TrBuf.AddByte( 0xEA );
    pTr->m_TrBuf.AddBulk( (LPBYTE)&SendLength, 2 );
    pTr->m_TrBuf.AddBulk( SendBuffer, SendLength );

    Status = pTr->SingleTransceive();
/////////////////
	if (( Status == 0 ) && RecvLength)
	{

		BYTE pOut[33] = {0};
		aes_128_decrypt_cbc( 
			RecvBuffer, 
			16, 
			pKey, 
			ENC_Settings[pReader].IV, 
			&pOut[16], 
			ENC_Settings[pReader].IV
			);

		memcpy(RndB, &pOut[16], 16);

		pOut[16+16] = pOut[16];

		memmove(
			pOut+16,
			pOut+17,
			16
			);

		//memcpy(&RndBs[0], &pOut[16], 16);

		for (int i = 0; i < 16; i++)
			RndA[i] = pOut[i] = (BYTE)rand();

		aes_128_encrypt_cbc( 
			pOut, 
			32, 
			pKey, 
			ENC_Settings[pReader].IV, 
			&SendBuffer[1], 
			ENC_Settings[pReader].IV 
			);

		SendBuffer[0] = 0xAF;

		SendLength = 33;

		RecvLength = BUF_SIZE;

/////////////////
		CTransfer* pTr = (CTransfer*)pReader;
		pTr->m_TrBuf.Clear();
		pTr->m_TrBuf.AddByte( 0xEA );
		pTr->m_TrBuf.AddBulk( (LPBYTE)&SendLength, 2 );
		pTr->m_TrBuf.AddBulk( SendBuffer, SendLength );

		Status = pTr->SingleTransceive();
/////////////////

		if (Status)
		{
			ENC_Settings[pReader].TransferType = ENC_TRANSFER_TYPE_PLAIN;
		
			return Status;
		}	

		aes_128_decrypt_cbc( 
			RecvBuffer, 
			16, 
			pKey, 
			ENC_Settings[pReader].IV, 
			pOut, 
			ENC_Settings[pReader].IV 
			);

		pOut[0+16] = pOut[0+16-1];
		memmove(
			pOut+1,
			pOut+0,
			16
			);
		pOut[0] = pOut[0+16];

		if (memcmp(RndA, pOut, 16) != 0)
		{
			ENC_Settings[pReader].TransferType = ENC_TRANSFER_TYPE_PLAIN;
			
			return SCARD_E_CARD_UNSUPPORTED;
		}

	}

	if (Status == SCARD_S_SUCCESS)
	{
		//aes
		memcpy(&SessionKey[0], &RndA[0], 4);
		memcpy(&SessionKey[4], &RndB[0], 4);
		memcpy(&SessionKey[8], &RndA[12], 4);
		memcpy(&SessionKey[12], &RndB[12], 4);
		
		ZeroMemory(ENC_Settings[pReader].IV, 16);

		memcpy(&ENC_Settings[pReader].SessionKey, SessionKey, 16);

		DFSubkeys(pReader);//, SessionKey, SessionKeySize, m_DF_Settings[pReader].K1, m_DF_Settings[pReader].K2);

		ENC_Settings[pReader].TransferType = ENC_TRANSFER_TYPE_ENCRYPTED;
	}

	return Status;
}

int EncipherPacket()
{
	return 0;
}

int DecipherPacket()
{
	return 0;
}
