///////////////////////////////////////////////////////////////////////////////
//    Copyright (c), Philips Semiconductors Gratkorn
//
//                     (C)PHILIPS Electronics N.V. 2000
//                        All rights are reserved. 
//  Philips reserves the right to make changes without notice at any time.
// Philips makes no warranty, expressed, implied or statutory, including but
// not limited to any implied warranty of merchantibility or fitness for any
//particular purpose, or that the use will not infringe any third party patent,
// copyright or trademark. Philips must not be liable for any loss or damage
//                          arising from its use.
///////////////////////////////////////////////////////////////////////////////
#ifndef MFERRNO_H
#define MFERRNO_H

#ifdef __cplusplus
extern "C" {
#endif

//////////////////////////////////////////////////////////////////////////////
// Reader Error Codes                   Base Address Start:      0000
//                                      Base Address End:        -999
//////////////////////////////////////////////////////////////////////////////
//#define READER_ERR_BASE_START           (0)
#define MI_OK                           (0)
//#define MI_CHK_OK                       (0)
//#define MI_CRC_ZERO                     (0)
// ICODE1 Error   Codes
#define  I1_OK                          (0)
//#define  I1_NO_ERR                      (0)

#define MI_NOTAGERR                     (-1)
//#define MI_CHK_FAILED                   (-1)
#define MI_CRCERR                       (-2)
//#define MI_CHK_COMPERR                  (-2)
//#define MI_EMPTY                        (-3)      Free !!!
#define MI_AUTHERR                      (-4)
#define MI_PARITYERR                    (-5)
#define MI_CODEERR                      (-6)

#define MI_SERNRERR                     (-8)
#define MI_KEYERR                       (-9)
#define MI_NOTAUTHERR                   (-10)
#define MI_BITCOUNTERR                  (-11)
#define MI_BYTECOUNTERR                 (-12)
//#define MI_IDLE                         (-13)      Free !!!
//#define MI_TRANSERR                     (-14)      Free !!!
#define MI_WRITEERR                     (-15)
#define MI_INCRERR                      (-16)
#define MI_DECRERR                      (-17)
#define MI_READERR                      (-18)
#define MI_OVFLERR                      (-19)
//#define MI_POLLING                      (-20)      Free !!!
#define MI_FRAMINGERR                   (-21)
//#define MI_ACCESSERR                    (-22)      Free !!!
#define MI_UNKNOWN_COMMAND              (-23)
#define MI_COLLERR                      (-24)
#define MI_RESETERR                     (-25)
//#define MI_INITERR                      (-25)      Free !!!
#define MI_INTERFACEERR                 (-26)
//#define MI_ACCESSTIMEOUT                (-27)
#define MI_NOBITWISEANTICOLL            (-28)
//#define MI_QUIT                         (-30)      Free !!!
#define MI_CODINGERR                    (-31)

#define UEM_HARD_IS_ABSENT              (-40)
#define UEM_UNKNOWN_CMD                 (-41)
#define UEM_CMD_NOT_SUPPORTED           (-42)
#define UEM_MFRC_WRONG_MODE             (-43)
#define UEM_WRONG_CRYPTO_MODE           (-44)
#define UEM_FLASH_ERASING_REQUIRED      (-45)
#define UEM_KEY_IS_ABSENT               (-46)
#define UEM_TRANSCEIVER_FAILED          (-47)
#define UEM_ICODE_STACK_OVERFLOW        (-48)
#define UEM_HALTB_ERR                   (-49)

//#define                                 (-50)
//#define MI_SENDBYTENR                   (-51)
#define MI_CASCLEVEX                    (-52)    
//#define MI_SENDBUF_OVERFLOW             (-53)      Free !!!
#define MI_BAUDRATE_NOT_SUPPORTED       (-54)

#define UEM_SAM_TIMEOUT                 (-55)
#define UEM_SAM_APDU_ERR                (-56)
#define UEM_SAM_INVALID_CARD_MAC        (-57)
#define UEM_SAM_AUTHENTICATION_ERR      (-58)
#define UEM_SAM_BYTECOUNTERR            (-59)
#define MI_WRONG_PARAMETER_VALUE        (-60)
#define I1_WRONGPARAM                   (-60)

// ICODE1 Error   Codes
//#define  I1_WRONGPARAM                  (-61)
//#define  I1_NYIMPLEMENTED               (-62)      Free !!!
//#define  I1_TSREADY                     (-63)

#define  I1_TIMEOUT                     (-70)
//#define  I1_NOWRITE                     (-71)      Free !!!
//#define  I1_NOHALT                      (-72)      Free !!!
//#define  I1_MISS_ANTICOLL               (-73)      Free !!!

#define MI_MFP_GENERAL_MANIPULATE_ERR   (-81) /* 0xaf */
#define MI_MFP_INVALID_CARD_MAC         (-82) /* 0xae */
#define MI_MFP_LENGTH_ERROR             (-84) /* 0xac */
#define MI_MFP_NO_STATE_FOR_COMMAND     (-85) /* 0xab */
#define MI_MFP_NOT_EXISTING_BLOCK       (-86) /* 0xaa */
#define MI_MFP_INVALID_BLOCK_NUMBER     (-87) /* 0xa9 */
#define MI_MFP_INVALID_MAC              (-88) /* 0xa8 */
#define MI_MFP_COMMAND_OVERFLOW         (-89) /* 0xa7 */
#define MI_MFP_AUTHENTICATION_ERR       (-90) /* 0xa6 */

//#define MI_BREAK                        (-99)      Free !!!
#define MI_NY_IMPLEMENTED               (-100)
#define MI_INVALID_CRC16                (-101)
//#define MI_MFRC_NOTAUTH                 (-102)      Free !!!
//#define MI_WRONG_DES_MODE               (-103)      Free !!!
//#define MI_HOST_AUTH_FAILED             (-104)      Free !!!

//#define MI_WRONG_LOAD_MODE              (-106)      Free !!!
//#define MI_WRONG_DESKEY                 (-107)      Free !!!
//#define MI_MKLOAD_FAILED                (-108)      Free !!!
//#define MI_FIFOERR                      (-109)      Free !!!
//#define MI_WRONG_ADDR                   (-110)      Free !!!
//#define MI_DESKEYLOAD_FAILED            (-111)      Free !!!
#define MI_RECBUF_OVERFLOW              (-112)
//#define MI_WRONG_SEL_CNT                (-114)      Free !!!

//#define MI_WRONG_TEST_MODE              (-117)      Free !!!
//#define MI_TEST_FAILED                  (-118)      Free !!!
//#define MI_TOC_ERROR                    (-119)      Free !!!
//#define MI_COMM_ABORT                   (-120)      Free !!!
//#define MI_INVALID_BASE                 (-121)      Free !!!
//#define MI_MFRC_RESET                   (-122)      Free !!!
//#define MI_WRONG_VALUE                  (-123)      Free !!!
#define MI_VALERR                       (-124)
#define UEM_UNSUPPORTED_PARAMETER       (-125)
#define UEM_SUCCESS_CHAINING            (-126)
#define UEM_TEMPERATURE_ERROR           (-127)
#define UEM_UNKNOWN_ERROR               (-128)

#ifdef __cplusplus
}
#endif

#endif // MFERRNO_H