//#include <types_def.h>

typedef unsigned char uint8_t;
typedef unsigned char BYTE;

void MfP_EV1_Address( uint8_t Type, uint8_t Sector, uint8_t Block, uint8_t* MfPAddr )
{
    BYTE BlockAddr;

    MfPAddr[1] = Type & 0xf0;
    if( Type == 0x00 )
    {
        BlockAddr = 4 * Sector;
        if( Sector >= 0x20 )
            BlockAddr += 12 * ( Sector - 0x20 );
        MfPAddr[0] = BlockAddr + Block;
    }
    else if( Type < 0x50 ) // if( MfPAddr[1] == 0x40 )
    {
        MfPAddr[0] = Sector * 2 + ( Type & 1 );
    }
    else if( MfPAddr[1] == 0xC0 )
    {
        MfPAddr[0] = ( ( ( Type & 0x07 ) - 1 ) << 4 ) + Block;
    }
    else
    {
        if( (Type == 0xa2) || (Type == 0xa3) )
            MfPAddr[0] = 0x80 | ( Type & 1 );
        else
            MfPAddr[0] = Type & 0x0f;
    }
}

