#include "../StdAfx.h"

#include "../Clscrfl.h"

#include "NFCReader.h"

NFCReader::NFCReader()
	: m_ucDsiDri(CLSCRF_PHPAL_I18092MPI_DATARATE_106)
{
	BYTE Gi[] = { 0x46, 0x66, 0x6D, 0x01, 0x01, 0x11, 0x03, 0x02, 0x00, 0x01, 0x04, 0x01, 0xFF };
	memcpy(m_Gi, Gi, sizeof(Gi));
	m_dwGiLength = sizeof(Gi);
	BYTE Nfcid3i[10] = { 0x01, 0xFE, 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7 };
	memcpy(m_Nfcid3i, Nfcid3i, sizeof(Nfcid3i));
}

uint32_t NFCReader::ActivateCard()
{
	BYTE  pbRecvBuffer[1024];
	DWORD dwRecvLength = sizeof(pbRecvBuffer);

	LONG Status = CLSCRF_NFC663_ActivateCard(
		m_pReader,
		m_Nfcid3i,
		0x00,//(BYTE)m_iDID,//IN	BYTE	Did,
		0x00,//(BYTE)(m_fNAD ? 0x01 : 0x00),//IN	BYTE	NadEnable,
		0x00,//ucNAD,//IN	BYTE	Nad,
		m_ucDsiDri,//(BYTE)m_iDSI,//IN	BYTE	Dsi,
		m_ucDsiDri,//(BYTE)m_iDRI,//IN	BYTE	Dri,
		0x00,//(BYTE)m_iFSL,//IN	BYTE	Fsl,
		m_dwGiLength,
		m_Gi,
		pbRecvBuffer,
		&dwRecvLength
		);

	if (Status == SCARD_S_SUCCESS)
		if (dwRecvLength > 0)
		{
			//Sleep(1500);
		}

	return Status;
}

uint32_t NFCReader::configurePeerAsInitiator(uint8_t baudrate)
{
	LONG Status = ActivateCard();

	return Status;
}

uint32_t NFCReader::configurePeerAsTarget(uint8_t type)
{
	LONG Status = ActivateCard();

	return Status;
}

uint32_t NFCReader::initiatorTxRxData(uint8_t *DataOut, uint32_t dataSize, uint8_t *response, uint32_t* plen)
{
	uint32_t Status = targetTxData(DataOut, dataSize);

	if (Status != 0)
		return Status;

	Status = targetRxData(response, plen);

	return Status;
}

uint32_t NFCReader::initiatorTxRxData(uint8_t *DataOut, uint32_t dataSize, uint8_t *response)
{
	uint32_t Status = targetTxData(DataOut, dataSize);

	if (Status != 0)
		return Status;

	Status = targetRxData(response);

	return Status;
}

uint32_t NFCReader::targetRxData(uint8_t *response)
{
	if (m_dwRecvLength == 0)
		return SCARD_E_TIMEOUT;

	memcpy(response, m_pbRecvBuffer, m_dwRecvLength);

	m_dwRecvLength = 0;

	return 0;
}

uint32_t NFCReader::targetRxData(uint8_t *response, uint32_t* plen)
{
	if (m_dwRecvLength == 0)
		return SCARD_E_TIMEOUT;

	memcpy(response, m_pbRecvBuffer, m_dwRecvLength);

	*plen = m_dwRecvLength;

	m_dwRecvLength = 0;

	return 0;
}

//uint32_t NFCReader::targetRxData(uint8_t *response, uint32_t len)
//{
//	if ((m_dwRecvLength == 0) || (m_dwRecvLength < len))
//		return SCARD_E_TIMEOUT;
//
//	memcpy(response, m_pbRecvBuffer, len);
//	memcpy(m_pbRecvBuffer, m_pbRecvBuffer + len, m_dwRecvLength - len);
//
//	m_dwRecvLength -= len;
//
//	return 0;
//}

uint32_t NFCReader::targetRxData(uint8_t *response, uint32_t len)
{
	if (m_dwRecvLength == 0)
		return SCARD_E_TIMEOUT;

	if ((m_dwRecvLength == 0) || (m_dwRecvLength > len))
		return SCARD_E_INSUFFICIENT_BUFFER;

	memcpy(response, m_pbRecvBuffer, m_dwRecvLength);

	return 0;
}

uint32_t NFCReader::targetTxData(uint8_t *DataOut, uint32_t dataSize)
{
	BYTE	ucOption = 0;

	//ucOption = 0;
		//m_iExchangeMode
		//| (m_fExchangeBufferedBit ? PH_EXCHANGE_BUFFERED_BIT : 0)
		//| (m_fExchangeLeaveBufferBit ? PH_EXCHANGE_LEAVE_BUFFER_BIT : 0);

	//AddReport(false, "CLSCRF_NFC663_Exchange", NULL, 0, 0);
	//AddReport(false, "DEP_REQ PDU =", pbSendBuffer, dwSendLength, 0);

	m_dwRecvLength = sizeof(m_pbRecvBuffer);

	LONG Status = CLSCRF_NFC663_Exchange(
		m_pReader,
		ucOption,
		DataOut,
		dataSize,
		m_pbRecvBuffer,
		&m_dwRecvLength
		);

	return Status;
}
