#include "../StdAfx.h"
#include "SNEP.h"

SNEP::SNEP(NFCLinkLayer *linkLayer) :
    _linkLayer(linkLayer)
{
}

SNEP::~SNEP()
{
}

uint32_t SNEP::rxNDEFPayload(uint8_t* data, uint32_t* plength)
{
	uint32_t result = _linkLayer->openSNEPServerLink();

	uint8_t Buffer[1024] = { 0 };

    if(RESULT_OK(result)) //if connection is error-free
    {
       //Serial.println(F("CONNECTED."));
		uint32_t len = 0;
		result = _linkLayer->serverLinkRxData(Buffer, &len);
       if (RESULT_OK(result))
       {
	   // TODO: to check header of SNEP packet
		   uint8_t *ptr = Buffer;
            uint8_t version = *ptr;
            uint8_t require = *(ptr + 1);
			*plength = (ptr[2] << 24) + (ptr[3] << 16) + (ptr[4] << 8) + ptr[5];

			memcpy(data, ptr + 6, *plength);
//            Serial.print("NDEF message length: ");
//            Serial.println(length);
			_linkLayer->closeSNEPServerLink();
		
			return result;
       }

	   _linkLayer->closeSNEPServerLink();
    }

    return result;
}

uint32_t SNEP::pushPayload(uint8_t *NDEFMessage, uint32_t length)
{
   //SNEP_MESSAGE *snepMessage = (SNEP_MESSAGE *) ALLOCATE_HEADER_SPACE(NDEFMessage, SNEP_MESSAGE_HDR_LEN);
   
	//SNEP_MESSAGE *snepMessage = (SNEP_MESSAGE*)(new uint8_t[SNEP_MESSAGE_HDR_LEN + length]);

	SNEP_MESSAGE snepMessage;

   snepMessage.version = 0x10;
   snepMessage.action  = 0x02;
   snepMessage.length  = MODIFY_ENDIAN(length);
   memcpy(snepMessage.message, NDEFMessage, length);
  
    uint32_t result = _linkLayer->openSNEPClientLink();

    if(RESULT_OK(result)) //if connection is error-free
    {
        result =  _linkLayer->clientLinkTxData((uint8_t *)&snepMessage, length + SNEP_MESSAGE_HDR_LEN);

		_linkLayer->closeSNEPClientLink();
    }
    
	//delete[] (uint8_t*)snepMessage;

    return result;
}
