#include "StdAfx.h"
#include "Clscrfl.h"
#include "Clscrfl_SAM.h"
#ifdef CLSCRF_DES3
	#include "Clscrfl_DES3.h"
#endif //CLSCRF_DES3
#include "ReaderSettings.h"

READER_SETTINGS::READER_SETTINGS()
{
	m_ucCurrentIOAddress = 0;
	ZeroMemory(&m_DFSettings[0], sizeof(m_DFSettings[0]));
	ZeroMemory(&m_CryptoSettings[0], sizeof(m_CryptoSettings[0]));
	m_CryptoSettings[0].fEncryptedMode = false;
}

DF_SETTINGS* READER_SETTINGS::CurrentDFSettings()
{
	return &m_DFSettings[m_ucCurrentIOAddress];
}

CRYPTO_SETTINGS* READER_SETTINGS::CurrentCryptoSettings()
{
	return &m_CryptoSettings[m_ucCurrentIOAddress];
}

void READER_SETTINGS::SetIOAdderss(BYTE ucIOAddress)
{
	m_ucCurrentIOAddress = ucIOAddress;

	if (m_CryptoSettings.find(m_ucCurrentIOAddress) == m_CryptoSettings.end())
	{
		ZeroMemory(&m_DFSettings[m_ucCurrentIOAddress], sizeof(m_DFSettings[m_ucCurrentIOAddress]));
		ZeroMemory(&m_CryptoSettings[m_ucCurrentIOAddress], sizeof(m_CryptoSettings[m_ucCurrentIOAddress]));
		m_CryptoSettings[m_ucCurrentIOAddress].fEncryptedMode = false;
	}
}
